SystemOrganization addCategory: #'Xpf-ProjectTalk'!
SystemOrganization addCategory: #'Xpf-ProjectTalk-Animations'!
SystemOrganization addCategory: #'Xpf-ProjectTalk-Cards'!
SystemOrganization addCategory: #'Xpf-ProjectTalk-Helpers'!
SystemOrganization addCategory: #'Xpf-ProjectTalk-Models'!
SystemOrganization addCategory: #'Xpf-ProjectTalk-TapeGUI'!
SystemOrganization addCategory: #'Xpf-ProjectTalk-Widgets'!
SystemOrganization addCategory: #'Xpf-ProjectTalk-History'!
SystemOrganization addCategory: #'Xpf-ProjectTalk-Colors'!

SwaDialog subclass: #XpfDeveloperChooser
	instanceVariableNames: 'okButton cancelButton developerDropList result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Helpers'!

!XpfDeveloperChooser class methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2010 17:53:24.686'!
defaultHeight

	^ 100! !

!XpfDeveloperChooser class methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2010 17:53:13.545'!
defaultWidth

	^ 300! !

!XpfDeveloperChooser class methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:09'!
for: aXpfTask

	^self new model: aXpfTask! !

!XpfDeveloperChooser class methodsFor: 'as yet unclassified' stamp: 'mt 4/4/2010 12:03:29'!
open

	[^ self new
		initializeWith: XpfTaskbarExtension instance connection repository;
		openInWorld]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'mt 5/2/2010 17:49:37.859'!
cancelButton

	cancelButton ifNil: [
		cancelButton := SwaPushButton
		label: 'Cancel'
		receiver: self
		selector: #cancel
		help: 'Close window'].
	^ cancelButton! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfDeveloperChooser methodsFor: 'user interface helper' stamp: 'SR 4/12/2009 17:36'!
createDeveloperDropList: myModel

	self developerDropList: (UITheme current 
		newDropListIn: self
		for: myModel projectsModel
		list: #list
		getSelected: #selectionIndex
		setSelected: #selectionIndex:
		getEnabled: nil
		useIndex: true
		help: 'Enter project id').
	self developerDropList minWidth: 200.
	^ self projectDropList! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'mt 5/2/2010 17:51:48.028'!
developerDropList

	developerDropList ifNil: [
		self developerDropList: (SwaComboBox
			on: XpfDeveloperChooserModel new
			list: #list
			selected: #selectionIndex
			changeSelected: #selectionIndex:
			useIndex: true
			"help: 'Enter developer'").
		self developerDropList minWidth: 200].
	^ developerDropList! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:38'!
developerDropList: anObject

	developerDropList := anObject.! !

!XpfDeveloperChooser methodsFor: 'initialization' stamp: 'SR 4/12/2009 17:53'!
initialize

	| |
	super initialize.
	self
		buttons: {self okButton. self cancelButton};
		contentMorph: self initializeUserInterface;
		addGrips;
		title: 'Specify Co-Developer'.! !

!XpfDeveloperChooser methodsFor: 'initialization' stamp: 'SR 4/12/2009 17:40'!
initializeUserInterface

	^ self createCol: {
		self createRow: {
			self createLabel: 'Developer:'.	self developerDropList}}! !

!XpfDeveloperChooser methodsFor: 'actions' stamp: 'topa 4/23/2009 16:59'!
model: anXpfTask

	super model: anXpfTask.
	self developerDropList model developerList: 
		(anXpfTask userStory iteration project developers reject: [:d | d = anXpfTask responsibleDeveloper]).! !

!XpfDeveloperChooser methodsFor: 'actions' stamp: 'SR 4/12/2009 18:11'!
ok

	self result: self developerDropList model developer.
	
	^ super ok! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'mt 5/2/2010 17:50:51.644'!
okButton

	okButton ifNil: [
		okButton := SwaPushButton
			label: 'Ok'
			receiver: self
			selector: #ok
			help: 'Confirm Developer'].
	^ okButton! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
okButton: anObject

	okButton := anObject.! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
result

	^ result! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
result: anObject

	result := anObject.! !

SwaDialog subclass: #XpfProjectTalk
	instanceVariableNames: 'tape navigation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk'!

!XpfProjectTalk commentStamp: 'mt 10/4/2009 14:54' prior: 0!
ProjectTalk - Agile software planning with ease
-----------------------------------------------

- new UI with scrollable tapes

Start with: "XpfProjectTalk open."

If you want to access the project model, use "self tape model" and not "self model".!

!XpfProjectTalk class methodsFor: 'constants' stamp: 'mt 4/14/2010 15:57:15.261'!
borderWidth

	^ 2! !

!XpfProjectTalk class methodsFor: 'constants' stamp: 'mt 5/23/2010 09:23:49.475'!
defaultHeight

	^ 768 "XpfTapeMorph tapeHeight + XpfToolbarMorph defaultHeight + XpfNavigationPanel defaultHeight"! !

!XpfProjectTalk class methodsFor: 'constants' stamp: 'mt 5/23/2010 10:20:52.516'!
defaultWidth

	^ 1030! !

!XpfProjectTalk class methodsFor: 'instance creation' stamp: 'mt 5/2/2010 17:59:09.476'!
open

	| authority |
	authority := XpfLoginProcessor serverString asUrl authority.
	((authority beginsWith: 'xpforums.hpi') or: [authority endsWith: 'xpforums'])
		ifTrue: [self inform: 'You must not start the new client with the old server. See preferences.'. ^ self].

	[
	XpfSplashScreen
		show: 'Project Talk'
		with: {'Checking connection...'. 'Loading model data & GUI...'. 'Opening GUI...'} asOrderedCollection
		for: [:step | | instance project |
			step = 1 ifTrue: [project := XpfTaskbarExtension instance connection project].
			step = 2 ifTrue: [instance := self new initializeProject: project].
			step = 3 ifTrue: [instance openInWorld; top: 18; fullScreen]]
	] on: XpfClientOpenError do: [:nothing | ].

	XpfSplashScreen delete. "In case of an error."! !

!XpfProjectTalk class methodsFor: 'instance creation' stamp: 'mt 4/26/2010 16:24:04.816'!
openExample

	| instance |
	instance := self new.
	instance
		addMainPanel: (instance
			createContainerFor: XpfProjectTapeMorph exampleTape
			and: XpfProjectTapeMorph exampleTape);
		openInWorld;
		top: 0;
		fullScreen.! !

!XpfProjectTalk class methodsFor: 'instance creation' stamp: 'mt 5/23/2010 10:19:32.153'!
openForHand: aHand

	| instance project |
	[ XpfSplashScreen
		show: 'Project Talk'
		with: {'Checking connection...'. 'Loading model data & GUI...'. 'Opening GUI...'} asOrderedCollection
		for: [:step | 
			step = 1 ifTrue: [project := aHand project].
			step = 2 ifTrue: [instance := self new initializeProject: project].
			step = 3 ifTrue: [instance openInWorld; top: 18 ";fullScreen"]]
	] on: XpfClientOpenError do: [:nothing | ].

	XpfSplashScreen delete. "In case of an error."! !

!XpfProjectTalk methodsFor: 'initialization' stamp: 'mt 5/17/2010 20:39:42.4'!
createContainerFor: tape1 and: tape2
	"Layout two tapes horizontally in a splitter."

	| tapes scroller1 scroller2 |
	scroller1 := tape1 withScrollBar.
	scroller2 := tape2 withScrollBar.
	navigation
		setLeftScrollBar: scroller1 hScrollbar;
		setRightScrollBar: scroller2 hScrollbar.
	
	(scroller1 hScrollbar)
		setValue: 0.0;
		side: #left;
		boundingScrollBar: scroller2 hScrollbar.
	(scroller2 hScrollbar)
		setValue: 1.0;
		side: #right;
		boundingScrollBar: scroller1 hScrollbar.

	tapes := XpfBorderedMorph new
		addMorph: (scroller1 "withToolbar" hResizing: #spaceFill; vResizing: #spaceFill)
			fullFrame: (LayoutFrame fractions: (0@0 corner: 0.66@1));
		addMorph: (scroller2 "withToolbar" hResizing: #spaceFill; vResizing: #spaceFill)
			fullFrame: (LayoutFrame fractions: (0.66@0 corner: 1@1));
		addPaneSplitters;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
		
	^ BorderedMorph new
		color: Color transparent;
		borderWidth: 0;
		listDirection: #topToBottom;
		changeTableLayout;
		addMorphBack: tapes;
		addMorphBack: navigation;
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!XpfProjectTalk methodsFor: 'close & delete' stamp: 'mt 4/8/2010 17:40:25.41'!
delete

	[self tape project repository stopUpdating]
		on: Error
		do: [:fallThrough |].
		
	super delete.
! !

!XpfProjectTalk methodsFor: 'geometry' stamp: 'mt 5/23/2010 09:28:16.844'!
fullScreen
	"OVERRIDE: Just expand horizontally."
	
	self
		width: 1024; "World width;"
		left: 0.
		
	navigation updateExtent.! !

!XpfProjectTalk methodsFor: 'initialization' stamp: 'mt 6/2/2010 12:30:02.18'!
initialize

	self isWIP ifTrue: [self showWIPWarning].

	super initialize.		
	self
		removeMenuBox;
		title: 'XPForums ProjectTalk - No project loaded.'.! !

!XpfProjectTalk methodsFor: 'initialization' stamp: 'mt 4/7/2010 17:33:41.946'!
initializeProject: anXpfProject
	"Setup this client instance for a project."

	self
		title: anXpfProject title;
		initializeProjectTape: anXpfProject.
		
	"Start automatic updating."
	XpfSplashScreen appendMessage: 'Auto-update...'.
	anXpfProject isRestProxy ifTrue:
		[anXpfProject repository startUpdating].! !

!XpfProjectTalk methodsFor: 'initialization' stamp: 'mt 4/26/2010 16:24:42.941'!
initializeProjectTape: anXpfProject

	| tape2 |
	XpfSplashScreen appendMessage: 'Project...'.

	tape := XpfProjectTapeMorph new name: 'primary'.
	self tape model: anXpfProject.

	navigation := XpfNavigationPanel for: tape.

	tape2 := XpfProjectTapeMorph new
		name: 'secondary';
		model: anXpfProject.
	
	self contentMorph: (self
			createContainerFor: self tape
			and: tape2).
			
	self addMainPanel.! !

!XpfProjectTalk methodsFor: 'work-in-progress-info' stamp: 'mt 6/2/2010 12:18:28.916'!
isWIP

	^ true! !

!XpfProjectTalk methodsFor: 'initialization' stamp: 'mt 4/7/2010 17:36:46.982'!
newMainPanel
	"Overridden to ignore button row."

	^ self contentMorph! !

!XpfProjectTalk methodsFor: 'work-in-progress-info' stamp: 'mt 6/2/2010 12:29:27.736'!
showWIPWarning

	UserDialogBoxMorph
		inform: 
			('This version of ProjectTalk is still under development and may corrupt data or may not be stable in general. Additionally, it is not meant to be feature-complete. ' 
				withNoLineLongerThan: 50), 
			String cr, String cr, 
			('Backup everything you want to use with this version.'
				withNoLineLongerThan: 50)
		title: 'WIP version warning'.! !

!XpfProjectTalk methodsFor: 'accessing' stamp: 'mt 10/4/2009 14:48'!
tape

	^ tape! !

SwaDialog subclass: #XpfTaskDeveloperDialog
	instanceVariableNames: 'okButton developerList responsibleDeveloper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfTaskDeveloperDialog class methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2010 17:46:05.09'!
defaultHeight

	^ 120! !

!XpfTaskDeveloperDialog class methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2010 17:45:43.635'!
defaultWidth

	^ 300! !

!XpfTaskDeveloperDialog class methodsFor: 'as yet unclassified' stamp: 'mt 4/4/2010 12:03:43'!
open

	[^ self new
		initializeWith: XpfTaskbarExtension instance connection repository;
		openInWorld]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'mt 5/2/2010 17:39:57.497'!
developerList

	developerList ifNil: [
		self developerList: (SwaComboBox
				on: XpfDeveloperChooserModel new
				list: #list
				selected: nil
				changeSelected: nil
				"help: 'Participating developer'").
		].
	^ developerList! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:44'!
developerList: anObject

	developerList := anObject! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'cs 4/23/2009 15:09'!
initialize

	super initialize.
	self
		buttons: {self okButton};
		contentMorph: self initializeUserInterface;
		addGrips;
		title: 'Developers of this Task'.! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:26'!
initializeUserInterface

	^ self createCol: {
		self createRow: {self createLabel: 'Responsible Developer:'. self responsibleDeveloper}.
		self createLabel: 'Developers:'.
		self developerList}! !

!XpfTaskDeveloperDialog methodsFor: 'as yet unclassified' stamp: 'cs 4/23/2009 15:07'!
model: aXpfTask

	super model: aXpfTask.
	self responsibleDeveloper contents: (aXpfTask responsibleDeveloper isNil
		ifTrue: ['(not set)'] 
		ifFalse: [self model responsibleDeveloper userName]).
	self developerList model developerList: aXpfTask developers.! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'mt 5/2/2010 17:38:46.823'!
okButton

	okButton ifNil: [
		okButton := SwaPushButton
			label: 'Ok'
			receiver: self
			selector: #ok
			help: 'Confirm Developer'].
	^ okButton! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:00'!
okButton: anObject

	okButton := anObject! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:45'!
responsibleDeveloper

	responsibleDeveloper ifNil: [
		self responsibleDeveloper: (self createLabel: '(not set)')].
	^ responsibleDeveloper! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:45'!
responsibleDeveloper: anObject

	responsibleDeveloper := anObject! !

PasteUpMorph subclass: #XpfIterationMorph
	instanceVariableNames: 'leftSizeGrip rightSizeGrip gridMorph titleLabel commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfIterationMorph commentStamp: 'mt 10/4/2009 14:31' prior: 0!
I provide a container for user stories. My size grips (left & right) offer resizing capabilities. I will be aware that all of my user stories will be visible at anytime. I have a grid.!

!XpfIterationMorph class methodsFor: 'examples' stamp: 'mt 4/8/2010 17:43:43.928'!
exampleIteration

	^ self new
		addMorph: (XpfDraggableCardMorph new position: 1@5);
		addMorph: (XpfDraggableCardMorph new position: 2@3);
		addMorph: (XpfDraggableCardMorph new position: 6@4);
		addMorph: (XpfDraggableCardMorph new position: 5@1)! !

!XpfIterationMorph methodsFor: 'dropping/grabbing' stamp: 'mt 12/1/2009 19:08'!
acceptDroppingMorph: aUserStoryMorph event: evt 

	| cell |
	cell := self gridMorph calculateCell: evt hand position.	

	aUserStoryMorph formerOwnerStillUsesModel
		ifTrue: [aUserStoryMorph delete. ^ self].		

	super
		acceptDroppingMorph: aUserStoryMorph
		event: evt.

	self updatePositionFor: aUserStoryMorph at: cell
! !

!XpfIterationMorph methodsFor: 'testing' stamp: 'topa 8/24/2009 13:01'!
acceptsUserStories

	^ true! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2009 16:48'!
addMorph: aMorph
	"IMPORTANT: If the morph to be added has strange coordinates the result can look unexpected."

	self addMorphs: {aMorph}.! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/11/2009 14:19'!
addMorphSilent: aMorph
	"Just like the normal version of this method."

	super addMorph: aMorph.! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 5/19/2010 10:12:20.264'!
addMorphs: someMorphs
	"Not so expensive like calling #addMorph: manually for each morph."
	
	someMorphs do: [:m | self addMorphSilent: m].
	
	self fitToSubmorphs.
	self updateUserStoryPositions.! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 5/20/2010 08:36:38.343'!
addNewUserStory: aPriority
	"Add a new user story to the iteration for the given priority."

	self iteration addNewUserStory: (XpfUserStoryAddMorph emptyUserStoryAt: aPriority).! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 5/20/2010 08:35:34.519'!
addUserStory: anXpfUserStory

	(self includesUserStoryAsMorph: anXpfUserStory)
		ifTrue: [^ self].
	
	self gridMorph withoutSmoothMoving: [
		self addMorph: (XpfUserStoryMorph forUserStory: anXpfUserStory)].! !

!XpfIterationMorph methodsFor: 'submorphs-positioning' stamp: 'mt 10/7/2009 08:43'!
comeToFront
	"Override to get the owner to front. Needed for resizing via resize grip morphs."

	super comeToFront.
	self owner ifNotNilDo: [:o |
		o comeToFront]! !

!XpfIterationMorph methodsFor: 'accessing' stamp: 'mt 11/27/2009 11:01'!
commands
	"^ <Array with: <XpfCommand>* >"
	
	^ commands ifNil: [commands := {
		XpfCommand new name: 'New story'; target: self; selector: #createNewUserStoryAtHand; icon: #xpfAddTask.
		nil.	
		XpfCommand new name: 'Edit name'; target: self; selector: #editName; icon: #xpfPencil.
		XpfCommand new name: 'Delete'; target: self; selector: #remove; icon: #xpfDeleteIcon.

		}]! !

!XpfIterationMorph methodsFor: 'accessing-morphs' stamp: 'mt 4/8/2010 17:12:16.474'!
contextMenu
	"^ <MenuMorph>"
	
	| menu |
	menu := MenuMorph entitled: 'Iteration'.
	self commands do: [:cmd |
		cmd
			ifNil: [menu addLine]
			ifNotNil: [menu 
				addLabel: cmd name
				target: cmd target
				selector: cmd selector
				enabled: true
				icon: cmd icon]].
	^ menu! !

!XpfIterationMorph methodsFor: 'actions' stamp: 'mt 10/28/2009 19:31'!
createNewUserStoryAtHand

	self iteration ifNil: [World hands first addMorph: (XpfDraggableCardMorph new topLeft: World hands first topLeft). ^ self].

	World hands first addMorph: ((XpfUserStoryMorph forUserStory: XpfNewUserStory new)
		topLeft: World hands first topLeft).! !

!XpfIterationMorph methodsFor: 'drawing' stamp: 'mt 5/20/2010 20:07:01.15'!
drawBoundsOn: aCanvas

	aCanvas
		fillRectangle: (self topLeft corner: self bottomLeft + (1@0))
		color: self palette dark.
		
	aCanvas
		fillRectangle: (self topRight - (2@0) corner: self bottomRight)
		color: self palette dark.
		
	aCanvas
		fillRectangle: (self bottomLeft - (0@2) corner: self bottomRight)
		color: self palette dark.! !

!XpfIterationMorph methodsFor: 'drawing' stamp: 'mt 5/21/2010 10:56:06.644'!
drawOn: aCanvas

	self
		drawBoundsOn: aCanvas;
		drawStoryPathOn: aCanvas.! !

!XpfIterationMorph methodsFor: 'drawing' stamp: 'mt 5/23/2010 10:16:26.844'!
drawScaledOn: aCanvas factor: aFactor boundingBox: bb

	| miniCardSize |
	(aCanvas isVisible: bb) ifFalse: [^ self].
	
	miniCardSize := ((XpfUserStoryMorph defaultWidth @ XpfUserStoryMorph defaultHeight) * aFactor) asIntegerPoint max: 5@5.
	(self userStoryMorphs sort: [:m1 :m2 | m1 model priority < m2 model priority])
		do: [:morph | | pt |
			pt := ((morph center - self topLeft) * aFactor) + bb topLeft. "scale and move"
			aCanvas
				fillRectangle: (Rectangle center: pt + (2@2) extent: miniCardSize)
				color: self palette verydark.
				
			"morph isDone
				ifTrue: ["
					aCanvas
						fillRectangle: (Rectangle center: pt extent: miniCardSize)
						fillStyle: (SolidFillStyle color: self palette middark)
						borderStyle: (SimpleBorder new color: self palette mid; width: 1)."]
				ifFalse: [
					aCanvas
						fillRectangle: (Rectangle center: pt extent: miniCardSize)
						fillStyle: (SolidFillStyle color: XpfStoryColorPalette highlight1)
						borderStyle: (SimpleBorder new color: (XpfStoryColorPalette highlight1 alpha: 0.5); width: 1)]"].

	aCanvas
		line: bb bottomLeft - (0 @ XpfPagingAreaMorph defaultFooterHeight)
		to: bb bottomLeft
		color: self palette base.
		
	aCanvas
		line: bb bottomLeft - (-1 @ XpfPagingAreaMorph defaultFooterHeight)
		to: bb bottomLeft + (1@0)
		color: self palette base.
		
	aCanvas
		drawString: ('{1}-{2}' format: 
			((self model isXpfFutureIteration and: [self model isForProject])
				ifFalse: [{
					self model theRelease project releases indexOf: self model theRelease.
					self model isXpfFutureIteration
						ifTrue: ['?']
						ifFalse: [self model theRelease iterations indexOf: self model].}]
				ifTrue: [{'?'.'?'}]))
		at: bb bottomLeft - (-4 @ XpfPagingAreaMorph defaultFooterHeight)
		font: (XpfFontProvider sansFontAt: 6)
		color: self palette text.! !

!XpfIterationMorph methodsFor: 'drawing' stamp: 'mt 5/23/2010 10:16:36.452'!
drawScaledWithHighlightOn: aCanvas factor: aFactor boundingBox: bb

| miniCardSize |
	miniCardSize := ((XpfUserStoryMorph defaultWidth @ XpfUserStoryMorph defaultHeight) * aFactor) asIntegerPoint max: 5@5.
	(self userStoryMorphs sort: [:m1 :m2 | m1 model priority < m2 model priority])
		do: [:morph | | pt |
			pt := ((morph center - self topLeft) * aFactor) + bb topLeft. "scale and move"
			aCanvas
				fillRectangle: (Rectangle center: pt + (2@2) extent: miniCardSize)
				color: self palette dark.
				
			morph isDone
				ifTrue: [
					aCanvas
						fillRectangle: (Rectangle center: pt extent: miniCardSize)
						fillStyle: (SolidFillStyle color: XpfStoryColorPalette highlight2)
						borderStyle: (SimpleBorder new color: self palette light; width: 1)]
				ifFalse: [
					aCanvas
						fillRectangle: (Rectangle center: pt extent: miniCardSize)
						fillStyle: (SolidFillStyle color: XpfStoryColorPalette highlight1)
						borderStyle: (SimpleBorder new color: self palette light; width: 1)]].! !

!XpfIterationMorph methodsFor: 'drawing' stamp: 'mt 5/20/2010 20:07:21.914'!
drawStoryPathOn: aCanvas

	| offsetX offsetY upperY lowerY startPoint |
	offsetX := self left + self gridMorph margin left.
	offsetY := self top + self gridMorph margin top.
	
	upperY := offsetY + (self gridMorph vStep / 2) rounded.
	lowerY := offsetY + ((self gridMorph vStep / 2) rounded + (self gridMorph rowCount - 1 * self gridMorph vStep + (self gridMorph vStep / 1.5) rounded)).

	1 to: self gridMorph columnCount - 1 do: [ :index |
		"line between colums"
		aCanvas
			line: (offsetX + (self gridMorph hStep * index) @ upperY)
			to: (offsetX + (self gridMorph hStep * index) @ lowerY)
			color: self palette dark.
		
		"line from bottom of column to line between columns"
		aCanvas
			line: offsetX + (self gridMorph hStep * index) - (self gridMorph hStep / 2) rounded @ lowerY
			to: offsetX + (self gridMorph hStep * index) @ lowerY
			color: self palette dark.

		"line from line between columns to top of column"
		aCanvas
			line: offsetX + (self gridMorph hStep * index) @ upperY
			to: offsetX + (self gridMorph hStep * index) + (self gridMorph hStep / 2) rounded @ upperY
			color: self palette dark.

			].

	1 to: self gridMorph columnCount do: [ :index |
		aCanvas
			line: (offsetX + (self gridMorph hStep * index) - (self gridMorph hStep / 2) rounded @ upperY)
			to: (offsetX + (self gridMorph hStep * index) - (self gridMorph hStep / 2) rounded @ lowerY)
			color: self palette dark].
		
	aCanvas
		fillRectangle: (Rectangle
			center: (offsetX + (self gridMorph hStep * self gridMorph columnCount) - (self gridMorph hStep / 2) rounded @ lowerY)
			extent: 5@5)
		color: self palette dark.
	
	startPoint := offsetX + (self gridMorph hStep / 2) rounded @ upperY.
	aCanvas
		drawPolygon: {
			startPoint.
			startPoint + (5 @ 15).
			startPoint + (-6 @ 15).
		}
		color: self palette dark
		borderWidth: 0
		borderColor: Color transparent.
! !

!XpfIterationMorph methodsFor: 'actions' stamp: 'mt 10/28/2009 11:47'!
editName

	| newName |
	self iteration ifNil: [^ self].

	newName := FillInTheBlankMorph
		request: 'Enter a new name for the iteration:'
		initialAnswer: self iteration title.
		
	newName ifNotEmpty: [self iteration title: newName]	! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 9/29/2009 11:22'!
expandToLeft: aNumber
	"OVERRIDE: Ensure to keep space for size grips and all submorphs."
	
	| delta smBounds |
	self hideSupportMorphs. "To be ignored by submorph bounds calculation."
	smBounds := self submorphs size <= self supportMorphCount
		ifTrue: []
		ifFalse: [self submorphBounds].
	
	"Keep space for both size grips minimum."
	delta := (self width - self leftSizeGrip width - self rightSizeGrip width) negated
		max: aNumber.
		
	"Always show all submorphs."
	(smBounds notNil and: [(self left - delta) > (smBounds left - self leftSizeGrip width)])
		ifTrue: [delta := self left - smBounds left + self leftSizeGrip width].
	
	delta := (self gridMorph proposeNewExtent: (self width + delta @ self height))
		x - self width.
	
	super expandToLeft: delta.
	self changed: #resizedLeft with: delta.

	"recover positions of grips"
	self showSupportMorphs.! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 5/19/2010 10:30:26.611'!
expandToRight: aNumber
	"OVERRIDE: Ensure to keep space for size grips and all submorphs."
	
	| delta smBounds |
	self hideSupportMorphs. "To be ignored by submorph bounds calculation."
	smBounds := self submorphs size <= self supportMorphCount
		ifTrue: [nil]
		ifFalse: [self submorphBounds].
	
	"Keep space for both size grips minimum."
	delta := (self width - self gridMorph hStep) negated
		max: aNumber.

	"Always show all submorphs."
	"(smBounds notNil and: [(self right + delta) < (smBounds right + self rightSizeGrip width)])
		ifTrue: [delta := smBounds right + self rightSizeGrip width - self right]."
	
	delta := (self gridMorph proposeNewExtent: (self width + delta @ self height))
		x - self width.
	
	super expandToRight: delta.
	self changed: #resizedRight with: delta.

	"recover positions of grips"
	self showSupportMorphs.! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 8/20/2009 11:34'!
expandToSubmorphs
	"Expand me to left or right to show all submorphs and keep space for the size grips."
	
	self
		expandToLeft: 0;
		expandToRight: 0.! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 5/20/2010 08:53:12.691'!
extent: aPoint
	"Should be used by #width: and #height:. Update my grips and grid."
	
	super extent: aPoint.
	self gridMorph updateExtent.
	self  updateTitle.
	
	"self leftSizeGrip
		height: aPoint y;
		topLeft: self topLeft.
	self rightSizeGrip
		height: aPoint y;
		bottomRight: self bottomRight"! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 5/19/2010 10:35:28.665'!
fitToSubmorphs
	"Resize me to fit my submorphs plus some space for my size grips."
	
	self gridMorph rowCount <= 0
		ifTrue: [^ self].
	
	self expandToRight: (((self userStoryMorphs size / self gridMorph rowCount) roundUpTo: 1) * self gridMorph hStep) - self width.
		
	self width < self gridMorph hStep
		ifTrue: [self widthGrid: self gridMorph hStep]! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 5/20/2010 18:03:02.14'!
fixUserStoryModelPriorities
	"Take the coordinates in the grid to retrieve their intended priority. SHOULD ONLY BE USED AS A WORKAROUND!!"
	
	self userStoryMorphs do: [:story |
		story model priority: (self gridMorph listIndexForPoint: story topLeft)].! !

!XpfIterationMorph methodsFor: 'accessing' stamp: 'mt 9/17/2009 11:51'!
gridMorph

	gridMorph ifNil: [gridMorph := XpfUserStoryGridMorph forMorph: self].
	^ gridMorph! !

!XpfIterationMorph methodsFor: 'dropping/grabbing' stamp: 'mt 12/1/2009 18:43'!
handleDropMorph: evt

	| cell morph |
	morph := evt contents.
	cell := self gridMorph calculateCell: evt hand position.
	
	super handleDropMorph: evt.
	
	evt wasHandled
		ifTrue: [^ self].
		
	(morph isUserStoryMorph and: [self includesUserStoryAsMorph: morph model])
		ifTrue: [			
			self updatePositionFor: (self submorphs detect: [:m |
				m isUserStoryMorph and: [m model id = morph model id]]) at: cell].! !

!XpfIterationMorph methodsFor: 'event handling' stamp: 'mt 8/27/2009 16:01'!
handleMouseLeave: evt

	self leftSizeGrip isHighlighted: false.
	self rightSizeGrip isHighlighted: false.! !

!XpfIterationMorph methodsFor: 'event handling' stamp: 'mt 9/17/2009 10:42'!
handleMouseMove: evt
	"Create a appear-on-hover effect for the size grip morphs. Ensure that these grip morphs are always on top."
	
	evt translateBy: self position negated.
	
	evt position x < self leftSizeGrip width
		ifTrue: [self leftSizeGrip isHighlighted: true. self comeToFront.]
		ifFalse: [self leftSizeGrip isHighlighted: false].

	evt position x > (self width - self rightSizeGrip width)
		ifTrue: [self rightSizeGrip isHighlighted: true. self comeToFront.]
		ifFalse: [self rightSizeGrip isHighlighted: false].! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 5/20/2010 08:53:05.088'!
height: aNumber

	super height: aNumber.
	self userStoryMorphs ifNotEmpty: [
		self
			fitToSubmorphs;
			updateUserStoryPositions].! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 9/29/2009 15:04'!
heightGrid: aNumber
	"Should be used instead of #width: and #height: to regard the grid. Normally you should use #expandTo*:."
	
	self height: (self gridMorph proposeNewExtent: (0 @ aNumber)) y.! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 5/18/2010 18:02:19.962'!
hideSupportMorphs
	"Hide morphs that are for supporting this object, e.g., size grips, a grid a.s.o."

	"self leftSizeGrip hide.
	self rightSizeGrip hide."
	self gridMorph hide.
	self titleLabel hide.! !

!XpfIterationMorph methodsFor: 'testing' stamp: 'mt 11/1/2009 18:17'!
includesUserStory: userStory

	self iteration ifNil: [^ false].
	^ self iteration userStories anySatisfy: [:myStory |
		myStory id = userStory id]! !

!XpfIterationMorph methodsFor: 'testing' stamp: 'mt 11/1/2009 18:20'!
includesUserStoryAsMorph: userStory

	^ self submorphs anySatisfy: [:m |
		m isUserStoryMorph and: [m model id = userStory id]]! !

!XpfIterationMorph methodsFor: 'initialization' stamp: 'mt 5/18/2010 18:02:31.439'!
initialize

	super initialize.
	self
		clipSubmorphs: false;
		borderWidth: 1;
		borderColor: Color black;
		color: Color lightGray;
		extent: 0 @ XpfTapeMorph tapeHeight;
		"initializeSizeGrips;"
		initializeGrid;
		initializeTitle;
		fitToSubmorphs.! !

!XpfIterationMorph methodsFor: 'initialization' stamp: 'mt 5/18/2010 17:59:01.576'!
initializeGrid

	self addMorphSilent: self gridMorph.
	self gridMorph
		updateExtent;
		margin: (22 "self leftSizeGrip width" @ 35 corner: 22 "self rightSizeGrip width" @ 35).! !

!XpfIterationMorph methodsFor: 'initialization' stamp: 'mt 9/29/2009 10:17'!
initializeSizeGrips

	self
		addMorphSilent: self leftSizeGrip;
		addMorphSilent: self rightSizeGrip.

	(self leftSizeGrip)
		orientation: #toLeft;
		height: self height;
		topLeft: self topLeft;
		overlayColor: self color.
		
	(self rightSizeGrip)
		orientation: #toRight;
		height: self height;
		bottomRight: self bottomRight;
		overlayColor: self color.! !

!XpfIterationMorph methodsFor: 'initialization' stamp: 'mt 5/18/2010 18:09:29.805'!
initializeTitle

	self titleLabel	lock.
	self addMorphSilent: self titleLabel.
	self updateTitle.
! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 10/7/2009 08:51'!
iteration
	"Use this convenient accessor for more readable code."
	
	^ self model! !

!XpfIterationMorph methodsFor: 'accessing' stamp: 'mt 8/6/2009 12:43'!
leftSizeGrip

	leftSizeGrip ifNil: [
		leftSizeGrip := XpfResizeGrip new.
		leftSizeGrip addDependent: self].
	^ leftSizeGrip! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 10/4/2009 14:32'!
model
	"Override to avoid to create a custom model on demand."
	
	^ model! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 10/8/2009 09:57'!
model: anXpfIteration

	self model ifNotNilDo: [:mod |
		mod removeDependent: self.
		mod userStories removeDependent: self].

	model := anXpfIteration.
		
	self model ifNotNilDo: [:mod |		
		mod addDependent: self.
		mod userStories addDependent: self].
	
	self processModel.! !

!XpfIterationMorph methodsFor: 'event handling' stamp: 'mt 10/28/2009 11:43'!
mouseDown: evt
	"Do nothing for now."
	
	evt yellowButtonChanged ifTrue: [self contextMenu popUpInWorld]! !

!XpfIterationMorph methodsFor: 'submorphs-positioning' stamp: 'mt 8/20/2009 12:12'!
moveDistantSubmorphsVertically
	"Move submorphs which are not in my bounds (vertically). Horizontal fix is not necessary because of the size grip feature. See #expandToSubmorphs and #fitToSubmorphs."
	
	self submorphs do: [:m |
		m top < self top ifTrue: [m top: self top].
		m bottom > self bottom ifTrue: [m bottom: self bottom]].! !

!XpfIterationMorph methodsFor: 'colors' stamp: 'mt 5/17/2010 19:43:17.14'!
palette

	^ XpfIterationColorPalette! !

!XpfIterationMorph methodsFor: 'accessing-model' stamp: 'mt 5/19/2010 10:13:29.026'!
processModel

	self removeAllSubmorphs.

	self addMorphs:
		(self iteration userStories collect:[:us| 
			XpfUserStoryMorph forUserStory: us]).
	
	self updateTitle.
		
	self gridMorph smoothMoving: true.! !

!XpfIterationMorph methodsFor: 'actions' stamp: 'mt 10/28/2009 18:09'!
remove

	| answer |
	self iteration ifNil: [^ self].
	
	answer := FillInTheBlankMorph
		request: 'Enter ''yes'' if you really want to remove the iteration: '.

	answer = 'yes' ifTrue: [self iteration delete].! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/8/2009 10:40'!
removeAllSubmorphs

	self
		removeAllMorphsIn: (self submorphs reject: [:m | self supportMorphs includes: m]);
		fitToSubmorphs.! !

!XpfIterationMorph methodsFor: 'actions' stamp: 'mt 10/29/2009 19:21'!
removeMorph

	self owner ifNotNilDo: [:releaseTape |
		releaseTape removeMorph: self]! !

!XpfIterationMorph methodsFor: 'dropping/grabbing' stamp: 'mt 12/1/2009 10:36'!
repelsMorph: morph event: evt

	^ false! !

!XpfIterationMorph methodsFor: 'accessing' stamp: 'mt 8/6/2009 12:43'!
rightSizeGrip

	rightSizeGrip ifNil: [
		rightSizeGrip := XpfResizeGrip new.
		rightSizeGrip addDependent: self].
	^ rightSizeGrip! !

!XpfIterationMorph methodsFor: 'actions' stamp: 'mt 10/29/2009 19:13'!
showMessage: aString

	XpfOverlayMessage showAtAllHands: aString.! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 5/18/2010 18:09:19.269'!
showSupportMorphs
	"Show morphs that are for supporting this object, e.g., size grips, a grid a.s.o."

	self gridMorph
		show;
		topLeft: self topLeft.
	"self leftSizeGrip
		show;
		comeToFront;
		topLeft: self topLeft.
	self rightSizeGrip
		show;
		comeToFront;
		bottomRight: self bottomRight."
	self titleLabel
		show;
		top: self top + 10;
		left: self left + 10.
	! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/4/2009 15:09'!
supportMorphCount

	^ self supportMorphs size! !

!XpfIterationMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 5/18/2010 18:02:02.222'!
supportMorphs

	^ {self gridMorph. "self leftSizeGrip. self rightSizeGrip." self titleLabel}! !

!XpfIterationMorph methodsFor: 'accessing' stamp: 'mt 5/18/2010 18:07:14.81'!
titleLabel

	^ titleLabel ifNil: [titleLabel := TextMorph new textColor: self palette text].! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 11/19/2009 16:30'!
update: aSymbol

	aSymbol = #title ifTrue: [
		self showMessage: 'Iteration title changed.'.
		self updateTitle].
	"aSymbol = #userStoriesLoaded ifTrue: [self updateUserStoryMorphs]."
	aSymbol = #deleted ifTrue: [
		self showMessage: 'Iteration deleted.'.
		self removeMorph].
	
	"Transcript show: self owner owner name, ' ', aSymbol; cr."! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 11/15/2009 22:33'!
update: aSymbol with: anArray
	
	aSymbol = #resized ifTrue: [		
		anArray first orientation = #toLeft "first = grip, second = number"
			ifTrue: [self expandToLeft: anArray second]
			ifFalse: [self expandToRight: anArray second]].
		
	aSymbol = #fitToSubmorphs ifTrue: [ "first = grip, second = number"
		anArray first orientation = #toLeft
			ifTrue: [self expandToLeft: self width negated]
			ifFalse: [self expandToRight: self width negated]].	
		
	aSymbol = #userStoriesAdded ifTrue: [
		self showMessage: 'Story added.'.
		self addUserStory: anArray].
	
	"Transcript show: self owner owner name, ' ', aSymbol; cr."! !

!XpfIterationMorph methodsFor: 'dropping/grabbing' stamp: 'mt 5/20/2010 19:05:30.862'!
updatePositionFor: aUserStoryMorph at: aCellPoint

	| oldPrio newPrio |
	newPrio := self gridMorph calculateListPosition: aCellPoint + (1@1).
	oldPrio := aUserStoryMorph model priority.
	
	aUserStoryMorph
		setProperty: #forceWalkOnPositionChange
		toValue: true.
	
	"Model (position) update AFTER dropping."
	(self includesUserStory: aUserStoryMorph model)
		ifFalse: [
			aUserStoryMorph updateModelPriority: newPrio.
			aUserStoryMorph moveTo: self iteration.
			
			self userStoryMorphs do: [:story |
				| prio |
				story ~= aUserStoryMorph ifTrue: [
					prio := self gridMorph listIndexForPoint: story topLeft.
					story updateModelPriority:
						(prio >= newPrio
							ifTrue: [prio + 1]
							ifFalse: [prio])]]]
		ifTrue: [
			aUserStoryMorph updateModelPriority:
				(newPrio > oldPrio
				ifTrue: [newPrio - 1]
				ifFalse: [newPrio]).
			
			self userStoryMorphs do: [:story |
			| prio |
			story ~= aUserStoryMorph ifTrue: [
				prio := self gridMorph listIndexForPoint: story topLeft.
				story updateModelPriority:
					((newPrio < oldPrio)
						ifTrue: [
							(prio >= newPrio and: [prio < oldPrio])
								ifTrue: [prio + 1]
								ifFalse: [prio]]
						ifFalse: [
							(prio > oldPrio and: [prio < newPrio])
								ifTrue: [prio - 1]
								ifFalse: [prio]])]]].
	
	self
		fitToSubmorphs;
		updateUserStoryPositions.! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 12/1/2009 18:49'!
updateTitle

	self model
		ifNil: [self titleLabel contents: '(unnamed)']
		ifNotNil: [self titleLabel contents: self model title "self titleLabel contents: self model id asString"].
	
	self right < self titleLabel right
		ifTrue: [self titleLabel contents: '...'].! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 5/18/2010 20:41:11.391'!
updateUserStoryMorphs
	"Aggregate all stories that belong to this iteration and add missing morphs, delete the obsolete ones."

	| allStories |
	
	allStories := (self userStoryMorphs, self userStoryMorphsAtHand)
		collect: [:userStoryMorph |
			(self iteration userStories includes: userStoryMorph model)
				ifFalse: [userStoryMorph delete].
			userStoryMorph model].
				
	self iteration userStories do: [:userStory |
		(allStories includes: userStory)
			ifFalse: [self addMorph: (XpfUserStoryMorph forUserStory: userStory)]].
		
	"self expandToSubmorphs."! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 5/20/2010 18:35:19.943'!
updateUserStoryPosition: aUserStoryMorph
	
	self gridMorph fixMorphPosition: aUserStoryMorph.! !

!XpfIterationMorph methodsFor: 'updating' stamp: 'mt 5/20/2010 18:00:41.193'!
updateUserStoryPositions
	"Sort all user stories according to their priority and let them be arranged in the grid."
	
	self gridMorph fixMorphPositions:
		(self userStoryMorphs sort: [:m1 :m2 | 
			m1 model priority < m2 model priority]).! !

!XpfIterationMorph methodsFor: 'accessing-morphs' stamp: 'mt 10/26/2009 13:46'!
userStoryMorphs

	^ self submorphs select: [:m | m isUserStoryMorph]! !

!XpfIterationMorph methodsFor: 'accessing-morphs' stamp: 'mt 10/26/2009 13:47'!
userStoryMorphsAtHand

	^ World hands 
		inject: OrderedCollection new 
		into: [:morphs :hand | 
			morphs, (hand submorphs select: [:m |
				m isUserStoryMorph and: [m model iteration = self iteration]])]! !

!XpfIterationMorph methodsFor: 'dropping/grabbing' stamp: 'mt 5/20/2010 08:38:07.204'!
wantsDroppedMorph: aMorph event: evt

	aMorph isUserStoryMorph
		ifTrue: [
			| priority |
			priority := self gridMorph calculateListPosition: (self gridMorph calculateCell: evt hand position) + (1@1).
	
			aMorph isNew
				ifTrue: [self addNewUserStory: priority.
				aMorph delete. 
				evt wasHandled: true.
				^ false].
					
			^ (self includesUserStoryAsMorph: aMorph model) not	].
		
	^ false! !

!XpfIterationMorph methodsFor: 'resizing' stamp: 'mt 9/29/2009 15:03'!
widthGrid: aNumber
	"Should be used instead of #width: and #height: to regard the grid. Normally you should use #expandTo*:."
	
	self width: (self gridMorph proposeNewExtent: (aNumber @ 0)) x.! !

XpfIterationMorph subclass: #XpfOpenStoriesMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfOpenStoriesMorph commentStamp: 'mt 10/4/2009 16:23' prior: 0!
Just override the appearance.!

!XpfOpenStoriesMorph methodsFor: 'drawing' stamp: 'mt 5/20/2010 21:58:36.922'!
drawScaledOn: aCanvas factor: aFactor boundingBox: bb
	"Just draw it differently in the navigation bar."
	
	"aCanvas
		fillRectangle: (bb translateBy: (1@0))
		color: self palette middark."
		
	super
		drawScaledOn: aCanvas
		factor: aFactor
		boundingBox: bb.
		
	"aCanvas
		drawString: 'open'
		at: bb topLeft + (5@0)
		font: (XpfFontProvider sansFontAt: 7)
		color: self palette middark."
! !

PasteUpMorph subclass: #XpfTaskListMorph
	instanceVariableNames: 'updateIsLocked scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfTaskListMorph methodsFor: 'updating' stamp: 'mt 4/28/2009 13:21'!
acceptDroppingMorph: aMorph event: evt 

	self doWithoutUpdates: [
		(aMorph isTaskMorph and: [self model noneSatisfy: [:a | a id = aMorph model id]])
				ifTrue: [self model add: aMorph model].
		super acceptDroppingMorph: aMorph event: evt].! !

!XpfTaskListMorph methodsFor: 'testing' stamp: 'mfp 3/19/2009 14:41'!
acceptsTasks

	^ true! !

!XpfTaskListMorph methodsFor: 'initialization' stamp: 'mt 4/28/2010 21:23:13.819'!
createUserInterface

	submorphs ifNotNilDo: [:s |
		s do: [:m | m
			removeDependent: self;
			delete]].
	
	self model do: [:task | |taskMorph|
		taskMorph := (XpfTaskMorph forTask: task).
		taskMorph addDependent: self.
		self addMorphBack: taskMorph].

	2 timesRepeat: [self scrollPane updateScrollbars].
	
	submorphs ifNotEmpty: [
		self scrollPane scrollToShow: submorphs last bounds].! !

!XpfTaskListMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/22/2009 13:42'!
doWithoutUpdates: aBlock

	self updateIsLocked: true.
	^ aBlock ensure: [self updateIsLocked: false]
	! !

!XpfTaskListMorph methodsFor: 'initialization' stamp: 'mt 5/2/2010 16:48:01.84'!
initialize

	super initialize.
	self
		changeTableLayout;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		color: Color transparent;
		borderWidth: 0;
		listDirection: #topToBottom;
		layoutInset: 2;
		cellInset: 2;
		extent: XpfTaskTitleContent defaultExtent + XpfTaskActionsContent defaultExtent * (1@2).! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'SR 4/18/2009 11:12'!
model

	^ model! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 17:29'!
model: anXpfTaskCollection

	self model ifNotNil: [
		self model removeDependent: self].
	model := anXpfTaskCollection.
	self model ifNotNil: [
		self createUserInterface.
		self model addDependent: self]! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mt 4/8/2010 17:21:07.2'!
scrollPane

	^ scrollPane ifNil: [scrollPane := SwaGeneralScrollPane new]! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 16:29'!
scrollPane: anObject

	scrollPane := anObject.! !

!XpfTaskListMorph methodsFor: 'updating' stamp: 'mt 4/28/2010 21:31:07.205'!
update: anObject

	self updateIsLocked ifFalse: [
		(anObject = #tasksLoaded) | (anObject = #tasksAdded) ifTrue: [
			self createUserInterface]].
	
	anObject = #zoomIn | (anObject = #zoomOut) ifTrue: [
		2 timesRepeat: [self scrollPane updateScrollbars]. "yep!!"].
	
	super update: anObject.! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'topa 4/22/2009 13:41'!
updateIsLocked

	^ updateIsLocked ifNil: [self updateIsLocked: false. updateIsLocked]! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'topa 4/22/2009 13:41'!
updateIsLocked: anObject

	updateIsLocked := anObject.! !

!XpfTaskListMorph methodsFor: 'layout' stamp: 'mt 5/14/2009 16:30'!
withScrollBars

	self scrollPane
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.35);
		scrollTarget: self.
	^ self scrollPane! !

ProportionalSplitterMorph subclass: #XpfSplitterMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk'!

!XpfSplitterMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/17/2010 19:55:41.421'!
splitterWidth
	^ 16! !

!XpfSplitterMorph methodsFor: 'drawing' stamp: 'mt 5/18/2010 18:19:19.265'!
darkGradient

	^ self
		valueOfProperty: #darkGradient
		ifAbsentPut: [
			GradientFillStyle ramp: { 
				0.0 -> self palette verydark. 
				1.0 -> self palette dark}].! !

!XpfSplitterMorph methodsFor: 'drawing' stamp: 'mt 5/20/2010 21:56:26.662'!
drawOn: aCanvas

	| rect |		
"	rect := self topLeft corner: self bottomLeft + ((self width / 4)@0) - (1@0).
	aCanvas
		fillRectangle: rect
		fillStyle: (self darkGradient
			origin: rect topRight;
			direction: rect width negated @ 0).
			
	rect := self topRight - ((self width / 4)@0) + (1@0) corner: self bottomRight.."
	
	#(0.25 0.5 0.75 1.0) withIndexDo: [:alphaValue :index |
		aCanvas
			line: self topLeft + ((index - 1) @ 0)
			to: self bottomLeft + ((index - 1) @ 0)
			color: (self palette verydark alpha: alphaValue)].

	#(0.25 0.5 0.75 1.0) withIndexDo: [:alphaValue :index |
		aCanvas
			line: self topRight - (index @ 0)
			to: self bottomRight - (index @ 0)
			color: (self palette verydark alpha: alphaValue)].
					
	rect := self topLeft + ((self width / 4)@0) corner: self bottomRight - ((self width / 4)@0).
	aCanvas
		fillRectangle: rect
		fillStyle: (self lightGradient
			origin: rect topLeft;
			direction: rect width @ 0).
! !

!XpfSplitterMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/25/2010 17:54:11.779'!
hideLeft

	self rightMorph visible ifFalse: [self showRight].

	self leftMorph layoutFrame
		rightFraction: 0;
		rightOffset: 0. 
	self leftMorph hide.
	
	self rightMorph layoutFrame
		leftFraction: 0;
		leftOffset: 0.
	
	self hide.
	self owner layoutChanged.! !

!XpfSplitterMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/25/2010 17:54:57.232'!
hideRight

	self leftMorph visible ifFalse: [self showLeft].

	self rightMorph layoutFrame
		leftFraction: 1;
		leftOffset: 0. 
	self rightMorph hide.
	
	self leftMorph layoutFrame
		rightFraction: 1;
		rightOffset: 0.
	
	self hide.
	self owner layoutChanged.! !

!XpfSplitterMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/17/2010 20:15:15.955'!
initialize

	super initialize.
	"self fillStyle: self gradient."
	self removeMorph: handle.! !

!XpfSplitterMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/25/2010 17:30:50.13'!
leftMorph

	^ leftOrTop
		ifEmpty: []
		ifNotEmpty: [leftOrTop first]! !

!XpfSplitterMorph methodsFor: 'drawing' stamp: 'mt 5/17/2010 20:25:07.219'!
lightGradient

	^ self
		valueOfProperty: #lightGradient
		ifAbsentPut: [
			GradientFillStyle ramp: { 
				0.0 -> self palette light.
				0.5 -> self palette base.
				1.0 -> self palette light}].! !

!XpfSplitterMorph methodsFor: 'event handling' stamp: 'mt 5/17/2010 20:16:05.248'!
mouseEnter: anEvent

	self setInverseColors.
	self changed.
	anEvent hand showTemporaryCursor: self resizeCursor.! !

!XpfSplitterMorph methodsFor: 'colors' stamp: 'mt 5/17/2010 19:59:29.189'!
palette

	^ XpfSplitterColorPalette! !

!XpfSplitterMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/25/2010 17:30:55.078'!
rightMorph

	^ rightOrBottom
		ifEmpty: []
		ifNotEmpty: [rightOrBottom first]! !

!XpfSplitterMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/25/2010 17:21:51.72'!
showLeft

	self showRight.! !

!XpfSplitterMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/25/2010 17:55:48.31'!
showRight

	self rightMorph layoutFrame
		leftFraction: 0.5;
		leftOffset: 0. 
	self rightMorph show.
	
	self leftMorph layoutFrame
		rightFraction: 0.5;
		rightOffset: 0.
	self leftMorph show.
	
	self show.
	self owner layoutChanged.! !

!Morph methodsFor: '*xpf-projecttalk-override' stamp: 'mt 9/29/2009 16:50'!
acceptDroppingMorph: aMorph event: evt
	"This message is sent when a morph is dropped onto a morph that has agreed to accept the dropped morph by responding 'true' to the wantsDroppedMorph:Event: message. This default implementation just adds the given morph to the receiver."
	| layout |
	layout := self layoutPolicy.
	layout ifNil:[^self addMorphFront: aMorph].
	self privateAddMorph: aMorph 
		atIndex: (layout indexForInserting: aMorph at: evt position in: self).! !

!Morph methodsFor: '*xpf-projecttalk-testing' stamp: 'mfp 3/19/2009 14:43'!
acceptsTasks

	^ false! !

!Morph methodsFor: '*xpf-projecttalk-testing' stamp: 'cs 3/10/2009 16:13'!
acceptsUserStories

	^ false! !

!Morph methodsFor: '*xpf-projecttalk-animations' stamp: 'mt 5/18/2010 17:38:17.797'!
darkenThen: aBlock

	self darkenAnimation
		direction: #forward;
		finishBlock: aBlock;
		start.! !

!Morph methodsFor: '*xpf-projecttalk-geometry' stamp: 'mt 4/19/2010 19:48:15.02'!
expandTo: aDirection delta: aNumber
	"private - expand morph to the opposite of the given direction"
	
	| myOrigin submorphOrigins |
	submorphOrigins := OrderedCollection new.
	self submorphs do: [:m | submorphOrigins add: m position].
	myOrigin := self perform: aDirection asSymbol.
	
	(aDirection = #left) | (aDirection = #right)
		ifTrue: [self width: (self width + aNumber max: 0)]
		ifFalse: [self height: (self height + aNumber max: 0)].
		
	self perform: (aDirection, #:) asSymbol with: myOrigin.
	self submorphs withIndexDo: [:m :i | m position: (submorphOrigins at: i)].! !

!Morph methodsFor: '*xpf-projecttalk-geometry' stamp: 'mt 8/6/2009 19:42'!
expandToBottom: aNumber

	self expandTo: #top delta: aNumber! !

!Morph methodsFor: '*xpf-projecttalk-geometry' stamp: 'mt 8/6/2009 19:42'!
expandToLeft: aNumber

	self expandTo: #right delta: aNumber! !

!Morph methodsFor: '*xpf-projecttalk-geometry' stamp: 'mt 8/6/2009 19:42'!
expandToRight: aNumber

	self expandTo: #left delta: aNumber! !

!Morph methodsFor: '*xpf-projecttalk-geometry' stamp: 'mt 8/6/2009 19:43'!
expandToTop: aNumber

	self expandTo: #bottom delta: aNumber! !

!Morph methodsFor: '*xpf-projecttalk' stamp: 'mt 10/7/2009 09:15'!
formerOwnerStillUsesModel
	"You can use all morphs that understand #model here."

	self formerOwner ifNotNilDo: [ :o | 
		^ (o submorphs anySatisfy: [ :s | s model = self model ])].
	^ false! !

!Morph methodsFor: '*xpf-projecttalk-testing' stamp: 'mfp 3/19/2009 16:14'!
isEntityMorphContent

	^ false! !

!Morph methodsFor: '*xpf-projecttalk-testing' stamp: 'topa 3/19/2009 14:53'!
isTaskMorph

	^ false! !

!Morph methodsFor: '*xpf-projecttalk-testing' stamp: 'topa 3/3/2009 23:50'!
isUserStoryMorph

	^ false! !

!Morph methodsFor: '*xpf-projecttalk-testing' stamp: 'SR 4/14/2009 22:01'!
isXpfEntityMorph

	^ false! !

!Morph methodsFor: '*xpf-projecttalk-testing' stamp: 'SR 4/14/2009 21:04'!
isXpfTaskTitleContent

	^ false! !

!Morph methodsFor: '*xpf-projecttalk-testing' stamp: 'mfp 3/19/2009 16:15'!
isXpfUserStoryTitleContent

	^ false! !

!Morph methodsFor: '*xpf-projecttalk-animations' stamp: 'mt 5/18/2010 17:36:13.025'!
lightenThen: aBlock

	self darkenAnimation
		direction: #backward;
		finishBlock: aBlock;
		start.! !

!Morph methodsFor: '*xpf-projecttalk-animations' stamp: 'mt 6/7/2010 15:25:32.279'!
walkToTopLeft: aPoint

	(AnimPropertyAnimation
		on: self
		property: #topLeft
		start: self topLeft
		end: aPoint
		duration: 200)
		register;
		start: #deleteWhenFinished.! !

!Morph methodsFor: '*xpf-projecttalk-animations' stamp: 'mt 6/7/2010 15:25:32.174'!
walkToTopLeft: aPoint offsetBlock: aBlock

	(AnimPropertyAnimation
		on: self
		property: #topLeft
		start: self topLeft - aBlock value
		end: aPoint
		duration: 200)
		offsetBlock: aBlock;
		register;
		start: #deleteWhenFinished.! !

!Morph methodsFor: '*xpf-projecttalk-animations' stamp: 'mt 5/18/2010 20:19:59.879'!
warpToTopLeft: aPoint

	self fadeOutThen: [
		self
			topLeft: aPoint;
			fadeIn].! !

!Morph methodsFor: '*xpf-projecttalk-animations' stamp: 'mt 5/18/2010 20:52:08.08'!
warpToTopLeft: aPoint offsetBlock: aBlock

	self fadeOutThen: [
		self
			topLeft: aPoint + aBlock value;
			fadeIn].! !

Morph subclass: #XpfCardMorph
	instanceVariableNames: 'storyMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfCardMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/21/2010 09:39:35.163'!
drawOn: aCanvas

	super drawOn: aCanvas.
	
	self storyMorph ifNotNilDo: [:storyMorph |
		aCanvas
			drawPolygon: {
				self topRight - (20@0).
				self topRight.
				self topRight + (0@20)}
			color: (storyMorph isDone ifTrue: [self palette highlight2] ifFalse: [self palette highlight1])
			borderWidth: 1
			borderColor: (storyMorph isDone ifTrue: [self palette highlight2 alpha: 0.5] ifFalse: [self palette highlight1 alpha: 0.5])].! !

!XpfCardMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/21/2010 09:31:52.692'!
palette
	
	^ XpfStoryColorPalette! !

!XpfCardMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/21/2010 09:38:43.115'!
storyMorph

	^ storyMorph! !

!XpfCardMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/21/2010 09:38:51.942'!
storyMorph: aStoryMorph

	storyMorph := aStoryMorph.! !

Morph subclass: #XpfEntityMorphContent
	instanceVariableNames: 'model inEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

XpfEntityMorphContent subclass: #XpfActionsContent
	instanceVariableNames: 'editModeButton historyButton acceptButton cancelButton estimationIcon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
acceptButton

	acceptButton ifNil: [
		self acceptButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfAccept;
			actionSelector: #acceptChanges;
			setBalloonText: 'Accept changes')].
	^ acceptButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:22'!
acceptButton: anObject

	acceptButton := anObject.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 16:22'!
acceptChanges

	self changed: #accepted.! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
cancelButton

	cancelButton ifNil: [
		self cancelButton:(IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCancel;
			actionSelector: #cancelChanges;
			setBalloonText: 'Cancel changes')].
	^ cancelButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:22'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 16:22'!
cancelChanges

	self changed: #cancelled.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'mt 4/24/2009 15:23'!
createEditModeLayout

	self addMorphBack: self cancelButton.
	self addMorphBack: self acceptButton.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:42'!
createNormalModeLayout
! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
editModeButton

	editModeButton ifNil: [
		self editModeButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfEdit;
			actionSelector: #switchEditMode;
			setBalloonText: 'Toggle edit mode')].
	^ editModeButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
editModeButton: anObject

	editModeButton := anObject! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:38'!
historyButton

	historyButton ifNil: [
		self historyButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfHistory;
			actionSelector: #showHistory;
			setBalloonText: 'Show history of this user story')].
	^ historyButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:38'!
historyButton: anObject

	historyButton := anObject! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:45'!
initialize

	super initialize.
	self
		createNormalModeLayout;
		vResizing: #spaceFill;
		hResizing: #shrinkWrap;
		changed.! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:09'!
showHistory

	self model repository changed: #showHistory with: self model.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 16:25'!
switchEditMode

	self changed: #enterEditMode.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:53'!
toggleEditMode

	super toggleEditMode.
	
	self removeAllMorphs.
	self extent: 0@0.
	
	self inEditMode
		ifFalse: [self createNormalModeLayout]
		ifTrue: [self createEditModeLayout].
		
	self changed.
	! !

XpfActionsContent subclass: #XpfTaskActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfTaskActionsContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:44'!
defaultExtent

	^ 0@20! !

XpfActionsContent subclass: #XpfUserStoryActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfUserStoryActionsContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:43'!
defaultExtent

	^ 0@40! !

!XpfEntityMorphContent class methodsFor: 'as yet unclassified' stamp: 'mfp 3/17/2009 16:48'!
defaultExtent

	self subclassResponsibility.! !

!XpfEntityMorphContent class methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 13:50'!
forModel: anXpfEntity

	^ (self basicNew)
	 	model: anXpfEntity;
		initialize! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:30'!
accept! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 16:08'!
cancel! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:26'!
inEditMode

	^ inEditMode! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:26'!
inEditMode: anObject

	inEditMode := anObject.! !

!XpfEntityMorphContent methodsFor: 'initialization' stamp: 'mfp 3/18/2009 15:38'!
initialize

	super initialize.
	self 
		inEditMode: false;
		layoutPolicy: TableLayout new;
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		fillStyle: Color transparent.! !

!XpfEntityMorphContent methodsFor: 'testing' stamp: 'mfp 3/19/2009 16:13'!
isEntityMorphContent

	^ true! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 15:09'!
model

	^ model! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mt 4/28/2009 18:33'!
model: anXpfEntity

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfEntity.
	self model ifNotNil: [self model addDependent: self].
	
	self update.! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:58'!
toggleEditMode

	self
		inEditMode: (self inEditMode not);
		update.
	! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:30'!
update! !

XpfEntityMorphContent subclass: #XpfEstimationContent
	instanceVariableNames: 'estimated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfEstimationContent class methodsFor: 'defaults' stamp: 'cs 4/14/2009 18:31'!
defaultExtent

	^ 40@20! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:34'!
estimated

	estimated ifNil: [
		self estimated: (self theme newLabelIn: self label: '').
		self estimated
			hResizing: #shrinkWrap;
			disabledStyle: #plain;
			font: XpfFontProvider sansFont.
		self updateLabel].
	
	^ estimated! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'cs 4/14/2009 18:27'!
estimated: anObject

	estimated := anObject.! !

!XpfEstimationContent methodsFor: 'initialization' stamp: 'mt 4/25/2009 16:56'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #center;
		cellInset: 3;
		layoutInset: 2;
		addMorph: MenuIcons xpfClock asMorph;
		addMorphBack: ((self theme newToolSpacerIn: self) hResizing: #spaceFill; vResizing: #rigid);
		addMorphBack: self estimated;
		update.! !

!XpfEstimationContent methodsFor: 'as yet unclassified' stamp: 'SR 4/18/2009 10:43'!
model: aModel

	super model: aModel.
	self updateLabel! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'SR 4/18/2009 10:57'!
update: aSymbol

	aSymbol = #timeEstimated ifTrue: [self updateLabel].
	super update: aSymbol.! !

!XpfEstimationContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 13:58'!
updateLabel

	self model ifNil: [^self].
	self model timeEstimated ifNil: [^self].
	self estimated contents: (self model timeEstimated asString)", ' hrs'".! !

XpfEntityMorphContent subclass: #XpfProgressEstimationSliderContent
	instanceVariableNames: 'estimationSlider estimationContent progressBar estimationSliderModel isUserStory proxyModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'mfp 4/23/2009 15:00'!
withModel: aModel

	^ self new
		model: aModel;
		initializeUserInterface
! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:41'!
accept

	self model timeEstimated: self estimationSliderModel timeEstimated.
	super accept! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:21'!
barOrSliderExtent

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'private' stamp: 'topa 4/23/2009 14:25'!
calculateProgressBarValue

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:41'!
cancel

	self estimationSliderModel timeEstimated: (self model timeEstimated ifNil: [0.0]).
	super cancel! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:35'!
currentQuantum

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 4/7/2010 17:26:20.749'!
estimationContent

	estimationContent ifNil: [
		"estimationContent := (XpfEstimationContent forModel: self estimationSliderModel)"
		estimationContent := (SwaLineEdit
				for: self estimationSliderModel
				get: #timeEstimated
				set: #timeEstimated:
"				class: LargePositiveInteger
				getEnabled: #isEnabled"
				help: '') "maxLength: 2." ]. 
	^ estimationContent! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:42'!
estimationContent: anObject

	estimationContent := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/21/2009 16:23'!
estimationSlider

	estimationSlider ifNil: [self estimationSlider:
		((self theme newSliderIn: self
			for: self estimationSliderModel
			getValue: #timeEstimated  
			setValue:  #timeEstimated:
			min: 0.5  
			max: self maxEstimation  
			quantum: self currentQuantum  
			getEnabled: nil  
			help: 'Drag slider to adjust estimated time required')
			height: self barOrSliderExtent y;
			width: self barOrSliderExtent x;
			vResizing: #rigid;
			hResizing: #rigid)].
	^ estimationSlider! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/16/2009 11:16'!
estimationSlider: anObject
	
	estimationSlider := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 12:26'!
estimationSliderModel

	estimationSliderModel ifNil: [
		self estimationSliderModel: XpfProgressEstimationSliderModel new].
	^ estimationSliderModel! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:37'!
estimationSliderModel: anObject

	estimationSliderModel := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'initialization' stamp: 'mt 4/25/2009 17:32'!
initializeUserInterface

	self
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		cellInset: 14;
		updateUserInterface;
		update.! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/23/2009 13:39'!
isTask

	^ self isUserStory not! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:34'!
maxEstimation

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'initialization' stamp: 'mt 5/14/2009 12:25'!
model: anXpfUserStoryOrTaskEntity
	
	super model: anXpfUserStoryOrTaskEntity.
	self model ifNotNilDo: [:m |
		self estimationSliderModel
			timeEstimated: (m timeEstimated ifNil: [0.0])].
	! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 19:25'!
progressBar

	progressBar ifNil: [self progressBar:
		(ProgressBarMorph new
			borderWidth: 1;
			color: (Color r: 0.5 g: 0.5 b: 0.5 alpha: 0.7);
			progressColor: Color lightGreen;
			extent: self barOrSliderExtent).
		self updateProgressBar].
	^ progressBar! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'SR 4/17/2009 11:17'!
progressBar: anObject

	progressBar := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 18:51'!
toggleEditMode

	super toggleEditMode.
	self updateUserInterface.
! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 13:52'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #timeEstimated ifTrue: [self estimationSliderModel timeEstimated: (self model timeEstimated ifNil: [0.0])].
	self updateProgressBar.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 14:44'!
updateProgressBar

	self progressBar value contents: self calculateProgressBarValue.	! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'mt 4/24/2009 18:16'!
updateUserInterface

	self
		removeAllMorphs;
		addMorph: (self inEditMode 
			ifTrue: [self estimationSlider]
			ifFalse: [self progressBar]);
		addMorphBack:	self estimationContent.! !

XpfProgressEstimationSliderContent subclass: #XpfTaskProgressEstimationSliderContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

XpfTaskProgressEstimationSliderContent subclass: #XpfTaskProgressContentForWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfTaskProgressContentForWidget methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 12:30'!
barOrSliderExtent

	^  95 @ 10! !

!XpfTaskProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2009 16:12'!
defaultExtent

	^ 150@20! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 4/25/2009 17:30'!
barOrSliderExtent

	^  68 @ 10! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'private' stamp: 'topa 4/23/2009 14:24'!
calculateProgressBarValue

	^ self model 
		ifNil: [0.0]
		ifNotNil: [(self model timeEstimated isNil not and: [self model timeActual isNil not] and: [self model timeEstimated > 0.0])
			ifFalse: [0.0]
			ifTrue: [self model timeActual / self model timeEstimated]]! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:27'!
currentQuantum

	^ 0.5! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:34'!
maxEstimation

	^ 20.0! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 19:19'!
updateProgressBar

	super updateProgressBar.
	self model ifNotNilDo: [:m |
		self progressBar assureExtension
			balloonText: ('Actual time: {1}' format: {((m timeActual ifNil: [0.0]) * 10) truncated / 10 asFloat}).
		(m timeActual notNil & m timeEstimated notNil
		and: [m timeActual > m timeEstimated])
			ifTrue: [self progressBar
				borderWidth: 2;
				borderColor: Color red]
			ifFalse: [self progressBar
				borderWidth: 1;
				borderColor: Color black]].! !

XpfProgressEstimationSliderContent subclass: #XpfUserStoryProgressEstimationSliderContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfUserStoryProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2009 16:12'!
defaultExtent

	^ 140@20! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 4/25/2009 17:29'!
barOrSliderExtent

	^ 103 @ 10! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:25'!
calculateEstimationSumForAllTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			task timeEstimated 
				ifNotNil: [subTotal + task timeEstimated] 
				ifNil: [subTotal]]! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:26'!
calculateEstimationSumForCompletedTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			(task isDone and: [task timeEstimated notNil])  
				ifTrue: [subTotal + task timeEstimated] 
				ifFalse: [subTotal]]
! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'private' stamp: 'mfp 4/23/2009 14:57'!
calculateProgressBarValue

	^ self model 
		ifNotNil: [ self calculateEstimationSumForAllTasks = 0.0 
			ifTrue: [ 0.0 ]
			ifFalse: [self calculateEstimationSumForCompletedTasks / self calculateEstimationSumForAllTasks]]! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:27'!
currentQuantum

	^ 1.0! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:34'!
maxEstimation

	^ 60.0! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/23/2009 14:54'!
model: anXpfUserStory

	super model: anXpfUserStory.
	self model tasks do: [:task | task addDependent: self].
	self model tasks addDependent: self.! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/23/2009 14:50'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	aSymbol = #tasksAdded ifTrue: [anObject addDependent: self].
	aSymbol = #tasksRemoved ifTrue: [anObject removeDependent: self]
! !

XpfEntityMorphContent subclass: #XpfTaskDeveloperContent
	instanceVariableNames: 'responsibleDeveloperButton responsibleDeveloperLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfTaskDeveloperContent class methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:26'!
defaultExtent

	^ 100 @25! !

!XpfTaskDeveloperContent class methodsFor: 'as yet unclassified' stamp: 'cs 5/7/2009 15:13'!
forModel: anXpfTask

	^ (super forModel: anXpfTask)
		update: #responsibleDeveloper! !

!XpfTaskDeveloperContent methodsFor: 'initialization' stamp: 'mt 4/28/2010 20:32:09.927'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		layoutInset: 0;
		cellInset: 0;
		addMorphBack: self responsibleDeveloperButton;
		addMorphBack: (SwaRowPanel for: {self responsibleDeveloperLabel}).! !

!XpfTaskDeveloperContent methodsFor: 'model actions' stamp: 'mt 5/14/2009 10:45'!
responsibleDeveloper
	
	^ self model responsibleDeveloper
		ifNil: ['(nobody)']
		ifNotNilDo: [:dev | dev userName]! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:05'!
responsibleDeveloperButton

	responsibleDeveloperButton ifNil: [
		self responsibleDeveloperButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfUser;
			actionSelector: #showDeveloper;
			setBalloonText: 'Show all developers for this task.')].
	^ responsibleDeveloperButton! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'cs 5/13/2009 14:20'!
responsibleDeveloperButton: anObject

	responsibleDeveloperButton := anObject.! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:42'!
responsibleDeveloperLabel

	responsibleDeveloperLabel ifNil: [
		self responsibleDeveloperLabel: '' asMorph].
	^ responsibleDeveloperLabel! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:06'!
responsibleDeveloperLabel: anObject

	responsibleDeveloperLabel := anObject.! !

!XpfTaskDeveloperContent methodsFor: 'model actions' stamp: 'mig 4/15/2009 18:23'!
showDeveloper

	World openModal: (XpfTaskDeveloperDialog new model: self model)! !

!XpfTaskDeveloperContent methodsFor: 'updating' stamp: 'topa 5/5/2010 15:20:25.512'!
update: aSymbol
	
	aSymbol = #responsibleDeveloper ifTrue: [
		self responsibleDeveloperLabel
			font: (XpfFontProvider sansFontAt: 7);
			contents: (self responsibleDeveloper truncateWithElipsisTo: 20);
			width: 135].
	super update: aSymbol.! !

XpfEntityMorphContent subclass: #XpfTaskWidgetActionsContent
	instanceVariableNames: 'startStopButton editTimeButton takeResponsibilityButton startTime doneButton reopenButton userStoryArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

XpfTaskWidgetActionsContent subclass: #XpfSimpleTaskWidgetActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfSimpleTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 15:42'!
initialize

	super initialize.

	self
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		layoutInset: 5.! !

!XpfSimpleTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'topa 5/5/2010 15:20:19.486'!
initializeUserInterface

	self
		addMorphBack: ('Other Options: ' asMorph
			font: (XpfFontProvider sansFontAt: 7));
		addMorphBack: self takeResponsibilityButton;
		addMorphBack: self startStopButton;
		addMorphBack: self editTimeButton;
		addMorphBack: self doneButton;
		addMorphBack: self reopenButton.! !

!XpfTaskWidgetActionsContent class methodsFor: 'as yet unclassified' stamp: 'topa 4/21/2009 17:53'!
defaultExtent

	^ 50@27! !

!XpfTaskWidgetActionsContent methodsFor: 'testing' stamp: 'mt 5/14/2009 09:51'!
alreadyResponsible

	^ self model notNil
		and: [self model responsibleDeveloper notNil
		and: [self model responsibleDeveloper = self model currentUser]]! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:21'!
doneButton

	doneButton ifNil: [
		self doneButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfDone;
			actionSelector: #doneWork;
			setBalloonText: 'Finish this task')].
	^ doneButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:06'!
doneButton: aButton

	doneButton := aButton.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'topa 4/23/2009 17:15'!
doneWork

	self model isDone: true.
	self stopWork.
	! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 4/28/2010 20:35:51.863'!
editTime

	| result |
	self model ifNil: [^ self].
	
	result := SwaInputDialog
		getTextWithTitle: 'Set actual time'
		label: 'Enter a new actual', String cr, ' time for this task:'
		value: (((self model timeActual ifNil: [0.0]) * 10) truncated / 10 asFloat) asString.
		
	result ifNil: [^ self].
	
	self model timeActual: result asNumber asFloat.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 15:42'!
editTimeButton

	editTimeButton ifNil: [
		self editTimeButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfClockEdit;
			actionSelector: #editTime;
			setBalloonText: ('Set actual time. This is an alternative way to the start/stop mechanism.' withNoLineLongerThan: 60))].
	^ editTimeButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 15:09'!
editTimeButton: anObject

	editTimeButton := anObject.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/6/2010 16:56:18.828'!
estimateTask

	| result |
	self model ifNil: [^ false].
	
	result := SwaInputDialog
		getTextWithTitle: 'Take responsibility'
		label: 'You may only be responsible', String cr, ' if you can estimate this task'
		value: (((self model timeActual ifNil: [0.0]) * 10) truncated / 10 asFloat) asString.
		
	result ifNil: [^ false].
	
	self model timeEstimated: result asNumber asFloat.
	^ true.! !

!XpfTaskWidgetActionsContent methodsFor: 'initialization' stamp: 'mt 5/14/2009 15:33'!
initialize

	super initialize.
	self
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		initializeUserInterface.! !

!XpfTaskWidgetActionsContent methodsFor: 'initialization' stamp: 'mt 5/15/2009 15:11'!
initializeUserInterface

	self
		addMorphBack: self userStoryArea;
		addMorphBack: self takeResponsibilityButton;
		addMorphBack: self startStopButton;
		addMorphBack: self editTimeButton;
		addMorphBack: self doneButton;
		addMorphBack: self reopenButton.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:38'!
model: aModel

	super model: aModel.
	self updateAll.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'topa 4/23/2009 16:34'!
reopen

	self model isDone: false.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:22'!
reopenButton

	reopenButton  ifNil: [
		self reopenButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfPencil;
			actionSelector: #reopen;
			setBalloonText: 'Re-open this task')].
	^ reopenButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:17'!
reopenButton: anObject

	reopenButton := anObject.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 15:11'!
startStopButton

	startStopButton ifNil: [
		self startStopButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfClockPlay;
			actionSelector: #toggleStartStop;
			setBalloonText: 'Start work and choose Co-Developer')].
	^ startStopButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:14'!
startStopButton: anObject

	startStopButton := anObject! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/14/2009 11:00'!
startWork

	| secondDeveloper |
	secondDeveloper := (World openModal: (XpfDeveloperChooser for: self model)) result.
	secondDeveloper ifNil: [^self].

	self model
		addDeveloper: self model currentUser;
		addDeveloper: secondDeveloper;
		isStarted: true.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'cs 4/23/2009 14:19'!
stopWork

	self model isStarted: false.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/15/2009 16:02'!
takeResponsibility

	self estimateTask
		ifTrue: [
			self model responsibleDeveloper: self model currentUser.
			self model developers reload].! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/12/2009 18:46'!
takeResponsibilityButton

	takeResponsibilityButton ifNil: [
		self takeResponsibilityButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfMedal;
			actionSelector: #takeResponsibility;
			setBalloonText: 'Take responsibility')].
	^ takeResponsibilityButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:14'!
takeResponsibilityButton: anObject

	takeResponsibilityButton := anObject! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'cs 4/23/2009 14:15'!
toggleStartStop

	self model isStarted
		ifTrue: [self stopWork]
		ifFalse: [self startWork].! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/15/2009 15:20'!
update: aSymbol

	aSymbol = #isDone	ifTrue: [
		self
			updateDoneButton;
			updateReopenButton;
			updateStartStopButton;
			updateEditTimeButton].
	aSymbol = #responsibleDeveloper ifTrue: [
		self
			updateTakeResponsibilityButton;
			updateDoneButton;
			updateStartStopButton;
			updateEditTimeButton].
	aSymbol = #isStarted ifTrue: [
		self
			updateStartStopButton;
			updateEditTimeButton].! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/15/2009 15:17'!
updateAll

	self
		updateTakeResponsibilityButton;
		updateDoneButton;
		updateReopenButton;
		updateStartStopButton;
		updateEditTimeButton;
		updateUserStoryArea.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 09:53'!
updateDoneButton

	self doneButton
		visible:
			(self model notNil
				and: [self model isDone not
				and: [self alreadyResponsible]]);
		disableTableLayout:
			self doneButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/15/2009 15:15'!
updateEditTimeButton

	self editTimeButton visible:
		(self model notNil
			and: [self model isDone not
			and: [self alreadyResponsible
			and: [self model isStarted not]]]).
	self editTimeButton disableTableLayout: self editTimeButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 09:54'!
updateReopenButton

	self reopenButton 
		visible:
			(self model notNil
				and: [self model isDone
				and: [self alreadyResponsible]]); 
		disableTableLayout:
			self reopenButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 09:52'!
updateStartStopButton

	self startStopButton visible:
		(self model notNil
			and: [self model isDone not
			and: [self alreadyResponsible]]).
	self startStopButton visible ifTrue: [
		self startStopButton labelGraphic:
			(self model isStarted
				ifTrue: [MenuIcons xpfClockStop]
				ifFalse: [MenuIcons xpfClockPlay])].
	self startStopButton disableTableLayout: self startStopButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'topa 4/23/2009 16:36'!
updateTakeResponsibilityButton

	self takeResponsibilityButton
		visible: self alreadyResponsible not;
		disableTableLayout: self alreadyResponsible.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 11:51'!
updateUserStoryArea

	self model ifNil: [^ self].
	
	self userStoryArea
		color: (Color colorFrom: self model userStory color asSymbol) muchLighter.
		
	self userStoryArea assureExtension
		balloonText: ('User Story: "{1}"' format: {self model userStory title withNoLineLongerThan: 40}).! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 11:49'!
userStoryArea

	userStoryArea ifNil: [
		self userStoryArea: (BorderedMorph new
			hResizing: #rigid;
			vResizing: #rigid;
			extent: 21@8;
			borderWidth: 1;
			borderRaised;
			color: Color transparent)].
	^ userStoryArea! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 11:38'!
userStoryArea: anObject

	userStoryArea := anObject.! !

XpfEntityMorphContent subclass: #XpfTasksContent
	instanceVariableNames: 'taskList addButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfTasksContent class methodsFor: 'defaults' stamp: 'bs 6/29/2009 16:14'!
defaultExtent

	^ 180@220! !

!XpfTasksContent methodsFor: 'initialization' stamp: 'mt 4/24/2009 16:09'!
addButton

	addButton ifNil: [
		self addButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfAddTask;
			actionSelector: #addTask;
			setBalloonText: 'Click this button to add a new task.')].
	^ addButton! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:13'!
addButton: aPluggableButtonMorph

	addButton := aPluggableButtonMorph.! !

!XpfTasksContent methodsFor: 'actions' stamp: 'mt 5/15/2009 15:57'!
addTask

	(self model addNew: (Dictionary newFrom: {'title' -> 'Please enter description for new task'}))
		responsibleDeveloper: self model repository currentUser.! !

!XpfTasksContent methodsFor: 'initialization' stamp: 'mt 4/28/2010 21:31:31.61'!
initialize

	super initialize.
	self
		hResizing: #rigid;
		color: (self palette dark alpha: 0.7);
		width: XpfUserStoryMorph defaultWidth;
		layoutInset: 2.
		
	self addMorphBack: self taskList withScrollBars.
	self addMorphBack: (SwaRowPanel for: {self addButton.	SwaHFiller new}).
		
	(self taskList scrollPane)
		extent: self extent.
! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mt 4/28/2009 10:23'!
model: anXpfTasksCollection

	super model: anXpfTasksCollection.
	self taskList model: self model.! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mt 4/24/2009 16:12'!
taskList

	taskList ifNil: [
		taskList := XpfTaskListMorph new model: self model].
	^ taskList! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mfp 3/19/2009 16:27'!
taskList: anObject

	taskList := anObject.! !

XpfEntityMorphContent subclass: #XpfTitleContent
	instanceVariableNames: 'titleEdit titleView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

XpfTitleContent subclass: #XpfTaskTitleContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfTaskTitleContent class methodsFor: 'defaults' stamp: 'mt 4/28/2010 20:41:43.581'!
defaultExtent

	^ 150@70! !

!XpfTaskTitleContent methodsFor: 'testing' stamp: 'topa 4/17/2009 16:03'!
isXpfTaskTitleContent

	^ true! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'cs 4/14/2009 18:44'!
accept

	self titleEdit accept.! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'SR 4/14/2009 21:02'!
cancel

	self titleEdit cancel.! !

!XpfTitleContent methodsFor: 'initialization' stamp: 'mt 4/25/2009 17:32'!
initialize

	super initialize.
	self addMorph: self title.! !

!XpfTitleContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 14:39'!
isXpfTaskTitleContent

	^ false! !

!XpfTitleContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 14:39'!
isXpfUserStoryTitleContent

	^ false! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 5/25/2009 11:53'!
model: anXpfEntity 
	super model: anXpfEntity.

	"preset title."
	(self titleView) 
		model: anXpfEntity;
		extent: self class defaultExtent.
	self isXpfUserStoryTitleContent 
		ifTrue: [self resizeFontSizeForUserStoryIfNecessary: anXpfEntity].
	(self titleEdit)
		setText: self model title;
		extent: self class defaultExtent

	! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 4/21/2009 17:03'!
modelTitle

	^ self model ifNotNil: [self model title asText]
		! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 4/21/2009 17:13'!
modelTitle: aText

	self model title: (aText ifNotNil: [aText asString])! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 19:29'!
title

	^ self inEditMode
		ifTrue: [self titleEdit]
		ifFalse: [self titleView]! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'mt 4/24/2009 15:16'!
titleEdit

	titleEdit ifNil: [
		titleEdit := (XpfSaveEditingTextMorph
			on: self
			text: #modelTitle
			accept: #modelTitle:) 
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			borderWidth: 0;
			fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.35)].
	^ titleEdit! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'mt 5/18/2010 17:04:47.852'!
titleView

	titleView ifNil: [
		titleView := (XpfPluggableTextMorph
			on: self model
			getTextSelector: #title)
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			margins: 3@0;
			textColor: XpfStoryColorPalette text;
			lock].
	^ titleView! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'topa 1/2/2010 17:37'!
toggleEditMode

	super toggleEditMode.
	self
		removeAllMorphs;
		addMorph: (self title font: XpfFontProvider sansFont).! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'mt 4/28/2009 10:40'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #title ifTrue: [
		self titleEdit update: #modelTitle].! !

XpfTitleContent subclass: #XpfUserStoryTitleContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfUserStoryTitleContent class methodsFor: 'defaults' stamp: 'mt 5/20/2010 22:28:46.526'!
defaultExtent

	^ 180@80! !

!XpfUserStoryTitleContent methodsFor: 'testing' stamp: 'topa 4/17/2009 16:03'!
isXpfUserStoryTitleContent

	^ true! !

!XpfUserStoryTitleContent methodsFor: 'accessing' stamp: 'topa 5/4/2010 12:20:47.347'!
resizeFontSizeForUserStoryIfNecessary: anXpfEntity 

	| textLength |
	textLength := anXpfEntity title size.
	
	"In the following line, truncateWithElipsisTo: will be added in the future"
	textLength > 210 ifTrue:  [ self titleView beAllFont: (XpfFontProvider sansFontAt: 8); font: (XpfFontProvider sansFontAt: 8) ].	
	(textLength > 165 and: [ textLength <= 210 ]) ifTrue:  [ self titleView beAllFont: (XpfFontProvider sansFontAt: 8); font: (XpfFontProvider sansFontAt: 8) ].	
	(textLength > 150 and: [ textLength <= 165 ]) ifTrue: [ self titleView beAllFont: (XpfFontProvider sansFontAt: 9); font: (XpfFontProvider sansFontAt: 9)].
	(textLength > 130 and: [ textLength <= 150 ]) ifTrue: [ self titleView beAllFont: (XpfFontProvider sansFontAt: 10); font: (XpfFontProvider sansFontAt: 10) ]! !

!XpfUserStoryTitleContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 15:22'!
titleView

	| tempTitleView |
	tempTitleView := super titleView.
	
"	self resizeFontSizeForUserStoryIfNecessary: self model ofTitleView: tempTitleView. "
	
	^ tempTitleView 
! !

XpfEntityMorphContent subclass: #XpfZoomButtonContent
	instanceVariableNames: 'zoomButton inZoomMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'mt 4/25/2009 17:05'!
defaultExtent
	
	^ 16@16! !

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'mt 4/25/2009 17:17'!
downArrowFrom

	^ ScrollBar arrowOfDirection: #bottom size: 16 color: Color lightGray
! !

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'mt 4/25/2009 17:17'!
rightArrowFrom

	^ ScrollBar arrowOfDirection: #right size: 16 color: Color lightGray
! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:27'!
inZoomMode

	^ inZoomMode! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:27'!
inZoomMode: anObject

	inZoomMode := anObject! !

!XpfZoomButtonContent methodsFor: 'initialization' stamp: 'mt 10/30/2009 13:40'!
initialize

	super initialize.	
	self
		addMorph: self zoomButton;
		listCentering: #center;
		listDirection: #topToBottom;
		vResizing: #shrinkWrap;
		hResizing: #rigid;
		color: Color transparent;
		update.! !

!XpfZoomButtonContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 15:31'!
toggleZoom

	self changed: #toggleZoom.! !

!XpfZoomButtonContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 15:42'!
update: aSymbol
	
	aSymbol = #zoomOut ifTrue: [self zoomButton labelGraphic: self class rightArrowFrom].
	aSymbol = #zoomIn ifTrue: [self zoomButton labelGraphic: self class downArrowFrom].
	super update: aSymbol.! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'topa 3/23/2009 11:07'!
zoomButton

	zoomButton ifNil: [
		zoomButton :=  IconicButton new
	 		color: Color transparent;
		 	target: self;
		 	borderWidth: 0;
			labelGraphic: self class rightArrowFrom;
			actionSelector: #toggleZoom;
			setBalloonText: 'zoom' translated].
	^ zoomButton! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:03'!
zoomButton: anObject

	zoomButton := anObject.! !

Morph subclass: #XpfEstimationCircleMorph
	instanceVariableNames: 'nUnits radius segmentUnitsComputing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfEstimationCircleMorph class methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 20:23'!
nUnits: anInteger segmentUnitsComputing: aBlock
	^ self new nUnits: anInteger; segmentUnitsComputing: aBlock; yourself! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 18:32'!
diameter
	^ self radius * 2! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'mt 10/29/2009 17:36'!
drawOn: aCanvas

	| nPolygons nSegmentPolygons gamma vertices deltaY deltaX segmentColor delta nSegmentsUnit |
	
	aCanvas fillOval: self bounds color: Color veryVeryLightGray borderWidth: 0 borderColor: nil.
	
	nSegmentsUnit := self segmentUnitsComputing value.
	(nSegmentsUnit > 0) ifTrue: [		
		nPolygons := self nUnits.
		nSegmentPolygons := nSegmentsUnit.
		gamma := 360 / nPolygons.
		vertices := OrderedCollection new.
		vertices addAll: {self center. self center + (self radius @ 0)}.

		1 to: nSegmentPolygons do: [:i |
			deltaY := (gamma*i) degreeSin * self radius.
			deltaX := ((self radius * self radius) - (deltaY*deltaY)) sqrt.
			delta := (deltaX rounded * (gamma*i+90) degreeSin sign)@(deltaY rounded).
			vertices add: (self center + delta).
		].
		segmentColor := Color r: 1.0 g: 0.725 b: 0.482.
		aCanvas drawPolygon: vertices color: segmentColor borderWidth: 0 borderColor: nil.		
	].! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 18:32'!
initialize
	super initialize.
	self radius: 30.
	self extent: self diameter @ self diameter.! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:33'!
nUnits
	^nUnits ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:24'!
nUnits: anObject
	nUnits := anObject ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:33'!
radius
	^ radius  ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 19:44'!
radius: anInteger
	radius := anInteger. ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:33'!
segmentUnitsComputing
	^ segmentUnitsComputing! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 20:22'!
segmentUnitsComputing: aBlock
	segmentUnitsComputing := aBlock.! !

Morph subclass: #XpfGridMorph
	instanceVariableNames: 'parentMorph margin hSpacing vSpacing smoothMoving showGrid showHoverEffect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfGridMorph commentStamp: 'mt 9/11/2009 11:25' prior: 0!
I am a morph that helps its parent morph to layout in a grid.!

!XpfGridMorph class methodsFor: 'instance creation' stamp: 'mt 9/11/2009 11:27'!
forMorph: aMorph

	^ self basicNew
		parentMorph: aMorph;
		initialize! !

!XpfGridMorph methodsFor: 'calculations' stamp: 'mt 5/18/2010 16:28:54.024'!
calculateCell: aGlobalPoint
	"Use the given point to calculate the resulting cell."
	
	| row col tl |
	tl := self localPointToGlobal: self topLeft.
	row := aGlobalPoint y.
	col := aGlobalPoint x.
	
	row := (row - tl y - self margin top) // self vStep.
	col := (col - tl x - self margin left) // self hStep.
			
	^ col @ row! !

!XpfGridMorph methodsFor: 'calculations' stamp: 'mt 5/18/2010 21:36:43.919'!
calculateListPosition: aCell
	
	^ (aCell x - 1 * self rowCount) + aCell y! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 11:37'!
cellHeight

	^ 50! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 11:37'!
cellWidth

	^ 50! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 10/8/2009 15:25'!
columnCount

	^ (self width - self margin left - self margin right) // self hStep! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 12:03'!
columnSpan

	^ 1! !

!XpfGridMorph methodsFor: 'drawing' stamp: 'mt 12/1/2009 16:14'!
drawGridOn: aCanvas
	"Just show the grid."

	| offset tw th|
	offset := self topLeft + self margin topLeft.
	tw := self width - self margin left - self margin right.
	th := self height - self margin top - self margin bottom.
	
	[offset := offset + (self hStep @ 0). offset x < self right]
		whileTrue: [
			aCanvas
				line: offset
				to: offset + (0 @ th)
				width: 1 "self hSpacing"
				color: self palette middark
				stepWidth: 3
				secondWidth: 1
				secondColor: Color transparent
				secondStepWidth: 6.
				
			[offset := offset + (0 @ self vStep). offset y < self bottom]
				whileTrue: [
					aCanvas
						line: offset
						to: offset - (self hStep @ 0)
						width: 1 "self vSpacing"
						color: self palette middark
						stepWidth: 3
						secondWidth: 1
						secondColor: Color transparent
						secondStepWidth: 6].
			
			offset := offset x @ (self margin top + self top)].	! !

!XpfGridMorph methodsFor: 'drawing' stamp: 'mt 9/29/2009 09:52'!
drawHoverEffectOn: aCanvas 
	"Highlight the current sector in the grid. Use current mouse position."
	
	| cursorPos targetRect |
	cursorPos := self globalPointToGridPoint: World hands first position.
	targetRect := cursorPos
		corner: cursorPos + ((self cellWidth * self columnSpan) @ (self cellHeight * self rowSpan)).
		
	(targetRect left >= (self left + self margin left)
		and: [targetRect right <= (self right - self margin right)])
		ifTrue: [aCanvas
			fillRectangle: targetRect
			color: self palette mid].! !

!XpfGridMorph methodsFor: 'drawing' stamp: 'mt 5/19/2010 11:33:40.732'!
drawOn: aCanvas
	"Highlight the current sector in the grid. Use current mouse position."
	
	(self showHoverEffect and: [ActiveHand submorphs notEmpty])
		ifTrue: [self drawHoverEffectOn: aCanvas].
	
	self showGrid
		ifTrue: [self drawGridOn: aCanvas].! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 9/11/2009 14:20'!
fixMorphPosition: aMorph

	self fixMorphPosition: aMorph targetPoint: aMorph center! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 10/26/2009 15:22'!
fixMorphPosition: aMorph targetCell: aPoint
	"Let the morph snap into the grid. Use logic coordinates (column, row)."
	
	self
		fixMorphPosition: aMorph
		targetPoint: (self localPointToGlobal: (((aPoint x * self hStep) + self margin left)@((aPoint y * self vStep) + self margin top))
			+ self topLeft)! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 5/20/2010 08:46:18.987'!
fixMorphPosition: aMorph targetIndex: index
	
	| targetPosition |
	targetPosition := (self pointForListIndex: index - 1) rounded.
	targetPosition = (aMorph topLeft - self topLeft)
		ifFalse: [
			((aMorph valueOfProperty: #forceWalkOnPositionChange ifAbsent: [false]) not
				and: [targetPosition x ~= (aMorph left - self left)] and: [targetPosition y ~= (aMorph top - self top)])
					ifTrue: [aMorph warpToTopLeft: targetPosition offsetBlock: [self topLeft]]
					ifFalse: [aMorph walkToTopLeft: targetPosition offsetBlock: [self topLeft]]].
				
	aMorph
		setProperty: #forceWalkOnPositionChange
		toValue: false.! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 5/18/2010 20:23:42.35'!
fixMorphPosition: aMorph targetPoint: aGlobalPoint
	"Let the morph snap into the grid."
	
	self smoothMoving
		ifTrue: [aMorph walkToTopLeft: (self globalPointToGridPoint: aGlobalPoint)]
		ifFalse: [aMorph topLeft: (self globalPointToGridPoint: aGlobalPoint)]	! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 5/20/2010 09:00:08.864'!
fixMorphPositions: someMorphs
	"Rearrange the given morphs in my parent as a list."
	
	[
	someMorphs withIndexDo: [ :morph :index | 
		self
			fixMorphPosition: morph
			targetIndex: index]
	] on: ZeroDivide do: [:err | "Do nothing."].! !

!XpfGridMorph methodsFor: 'private' stamp: 'mt 9/17/2009 12:16'!
globalPointToGridPoint: aPoint
	"Map the given point to be in the grid (topLeft in sector)"

	| pt |
	pt := (self globalPointToLocal: aPoint) - (self left @ 0).

	^ ((((pt x - self margin left) // self hStep) * self hStep)
			+ self left + self margin left + (self hSpacing / 2))
		@
		((((pt y - self margin top) // self vStep) * self vStep)
			+ self margin top + (self vSpacing / 2))! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 13:16'!
hSpacing

	hSpacing ifNil: [hSpacing := 4].
	^ hSpacing! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:21'!
hSpacing: anObject

	hSpacing := anObject.! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 12:04'!
hStep

	^ self cellWidth + (self hSpacing // self columnSpan)! !

!XpfGridMorph methodsFor: 'event handling' stamp: 'mt 9/11/2009 14:54'!
handleMouseLeave: evt
	"Force a redraw."
	
	self changed.! !

!XpfGridMorph methodsFor: 'event handling' stamp: 'mt 9/11/2009 13:34'!
handleMouseMove: evt
	"Force a redraw."
	
	self changed.! !

!XpfGridMorph methodsFor: 'initialization' stamp: 'mt 9/11/2009 11:27'!
initialize

	super initialize.
	self updateExtent.! !

!XpfGridMorph methodsFor: 'calculations' stamp: 'mt 5/19/2010 10:52:28.614'!
listIndexForPoint: aLocalPoint
	
	^ self calculateListPosition: 
		(aLocalPoint - self topLeft - self margin topLeft) // (self hStep @ self vStep) + (1@1)! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:08'!
margin
	"Create a default margin if margin is not set already."

	margin ifNil: [margin := 5@5 corner: 5@5].
	^ margin! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:07'!
margin: anObject

	margin := anObject.! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 9/11/2009 11:25'!
parentMorph

	^ parentMorph! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 9/11/2009 11:25'!
parentMorph: anObject

	parentMorph := anObject.! !

!XpfGridMorph methodsFor: 'calculations' stamp: 'mt 5/18/2010 21:17:36.243'!
pointForListIndex: anInteger
	"Calculate the top left coordinates of a morph that has the given list index."
	
	| cell |
	cell := (anInteger // self rowCount) @ (anInteger \\ self rowCount).
	^ ((cell x * self hStep) @ (cell y * self vStep)) + self margin topLeft + ((self hSpacing / 2) @ (self vSpacing / 2))! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 10/8/2009 11:19'!
proposeNewExtent: aPoint
	"Suggest a better value for a new extent to fit the grid exactly."
	
	| newWidth newHeight |
	newWidth := (aPoint x - self margin left - self margin right) max: 0.
	
	(newWidth \\ self hStep) > 0
		ifTrue: [newWidth := (((newWidth // self hStep) + 1) * self hStep)].
	newWidth := newWidth + self margin left + self margin right.
	
	newHeight := aPoint y.
	
	^ newWidth @ newHeight! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 10/8/2009 15:25'!
rowCount

	^ (self height - self margin top - self margin bottom) // self vStep! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 12:06'!
rowSpan

	^ 1! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:05'!
showGrid

	^ showGrid ifNil: [false]! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:05'!
showGrid: anObject

	showGrid := anObject.! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:23'!
showHoverEffect

	^ showHoverEffect ifNil: [true]! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:22'!
showHoverEffect: anObject

	showHoverEffect := anObject.! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 11/1/2009 14:03'!
smoothMoving
	"^ <Boolean>"

	^ smoothMoving ifNil: [smoothMoving := false]! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 11/1/2009 14:03'!
smoothMoving: aBoolean

	smoothMoving := aBoolean.! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:11'!
toggleShowGrid

	self showGrid: self showGrid not.
	self changed. "force a redraw"! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:23'!
toggleShowHoverEffect

	self showHoverEffect: self showHoverEffect not.
	self changed. "force redraw"! !

!XpfGridMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:16'!
toggleSmoothMoving

	self smoothMoving: self smoothMoving not.! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 9/11/2009 12:04'!
updateExtent
	"Change my own extent to my parent morph's extent."
	
	self parentMorph ifNil: [^ self].
	self extent: self parentMorph extent.! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 13:18'!
vSpacing

	vSpacing ifNil: [vSpacing := 4].
	^ vSpacing! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:22'!
vSpacing: anObject

	vSpacing := anObject.! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 12:04'!
vStep

	^ self cellHeight + (self vSpacing // self rowSpan)! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:43'!
virtualHeight

	^ self height - self margin top - self margin bottom! !

!XpfGridMorph methodsFor: 'geometry' stamp: 'mt 9/11/2009 12:43'!
virtualWidth

	^ self width - self margin left - self margin right! !

!XpfGridMorph methodsFor: 'updating' stamp: 'mt 11/7/2009 11:57'!
withoutSmoothMoving: aBlock

	| state |
	state := self smoothMoving.
	self smoothMoving: false.
	
	aBlock value.
	
	self smoothMoving: state.! !

XpfGridMorph subclass: #XpfUserStoryGridMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfUserStoryGridMorph commentStamp: 'mt 9/17/2009 11:33' prior: 0!
I am a grid that is specialized to user story morphs.!

!XpfUserStoryGridMorph class methodsFor: 'constants' stamp: 'mt 5/20/2010 19:09:47.526'!
defaultHSpacing

	^ 45! !

!XpfUserStoryGridMorph class methodsFor: 'constants' stamp: 'mt 5/18/2010 17:14:58.042'!
defaultVSpacing

	^ 15! !

!XpfUserStoryGridMorph methodsFor: 'accessing' stamp: 'mt 5/18/2010 18:37:49.417'!
calculateCell: aGlobalPoint
	"OVERRIDDEN: Take the space between the cells to insert between."
	
	| row col tl |
	tl := self localPointToGlobal: self topLeft.
	row := aGlobalPoint y.
	col := aGlobalPoint x.
	
	row := (row - tl y - self margin top - (self vStep / 2)) // self vStep.
	col := (col - tl x - self margin left) // self hStep.
			
	^ col @ (row + 1)! !

!XpfUserStoryGridMorph methodsFor: 'geometry' stamp: 'mt 4/26/2010 15:58:28.014'!
cellHeight

	^ XpfUserStoryMorph defaultHeight! !

!XpfUserStoryGridMorph methodsFor: 'geometry' stamp: 'mt 9/17/2009 11:37'!
cellWidth

	^ XpfUserStoryMorph defaultWidth! !

!XpfUserStoryGridMorph methodsFor: 'drawing' stamp: 'mt 5/18/2010 18:27:48.61'!
drawHoverEffectOn: aCanvas 
	"Highlight the current sector in the grid. Use current mouse position."
	
	| cell cursorPos targetRect |
	cell := self calculateCell: World hands first position.
	cursorPos := (((cell x * self hStep) @ (cell y * self vStep)) + self margin topLeft) + (self left @ 0).
	targetRect := ((cursorPos - (0 @ self vSpacing)
		corner: cursorPos + ((self cellWidth * self columnSpan) @ 0))
		translateBy: (self hSpacing / 2) @ (self vSpacing / 2))
		rounded..
		
	(targetRect left >= (self left + self margin left)
		and: [targetRect right <= (self right - self margin right)])
		ifTrue: [aCanvas
			line: targetRect topLeft + (0@ (targetRect height / 2) rounded)
			to: targetRect topRight + (0@ (targetRect height / 2) rounded)
			color: self palette mid].! !

!XpfUserStoryGridMorph methodsFor: 'updating' stamp: 'mt 5/20/2010 17:36:15.376'!
fixMorphPosition: aUserStoryMorph
	"OVERRIDE: Use priority of the user story to define position.."

	self
		fixMorphPosition: aUserStoryMorph
		targetIndex: aUserStoryMorph model priority.! !

!XpfUserStoryGridMorph methodsFor: 'geometry' stamp: 'mt 9/29/2009 10:25'!
hSpacing
	"OVERRIDE: Use a constant value."
	
	^ self class defaultHSpacing! !

!XpfUserStoryGridMorph methodsFor: 'geometry' stamp: 'mt 9/29/2009 10:25'!
vSpacing
	"OVERRIDE: Use a constant value."

	^ self class defaultVSpacing! !

Morph subclass: #XpfPagingAreaMorph
	instanceVariableNames: 'model leftSlider rightSlider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfPagingAreaMorph commentStamp: 'mt 8/29/2009 10:12' prior: 0!
I should only be used in a scrollable area where the #scrollTarget is a 2-level-tape.!

!XpfPagingAreaMorph class methodsFor: 'defaults' stamp: 'mt 5/20/2010 20:35:36.343'!
defaultFooterHeight

	^ 10! !

!XpfPagingAreaMorph methodsFor: 'drawing' stamp: 'mt 5/18/2010 16:07:59.095'!
backgroundGradient

	^ self
		valueOfProperty: #backgroundGradient
		ifAbsentPut: [GradientFillStyle ramp: {
			0.0 -> self palette verydark.
			0.7 -> self palette middark.
			1.0 -> self palette dark}]! !

!XpfPagingAreaMorph methodsFor: 'drawing' stamp: 'mt 5/21/2010 16:35:33.766'!
drawHighlightedOn: aCanvas

	| tape |
	self model ifNil: [^ self].
	
	aCanvas
		fillRectangle: (self bounds topLeft corner: self bounds bottomRight - (0@(self footerHeight)))
		color: self palette mid.
	
	tape := self navigationPanel tape.
	
	tape 
		drawScaledWithHighlightOn: aCanvas 
		factor: self width asFloat / tape width
		boundingBox: self bounds.! !

!XpfPagingAreaMorph methodsFor: 'drawing' stamp: 'mt 5/20/2010 20:37:15.377'!
drawOn: aCanvas
	"Depends on a 2-Level-Tape."

	| tape |
	self model ifNil: [^ self].
	
	aCanvas
		fillRectangle: self bounds
		fillStyle: (self backgroundGradient
			origin: self topLeft;
			direction: 0 @ 50).
			
	aCanvas
		fillRectangle: (self bottomLeft - (0@(self footerHeight - 1)) corner: self bottomRight)
		color: (Color r: 91 / 255 g: 89 / 255 b: 93 / 255).
	
	tape := self navigationPanel tape.
	
	tape 
		drawScaledOn: aCanvas 
		factor: self width asFloat / tape width
		boundingBox: self bounds.! !

!XpfPagingAreaMorph methodsFor: 'geometry' stamp: 'mt 4/23/2010 12:24:21.637'!
extent: aPoint

	super extent: aPoint.
	self leftSlider update.
	self rightSlider update.! !

!XpfPagingAreaMorph methodsFor: 'accessing' stamp: 'mt 5/20/2010 20:35:46.12'!
footerHeight
	"Return the space used for additional information, e.g., week number."
	
	^ self class defaultFooterHeight! !

!XpfPagingAreaMorph methodsFor: 'event handling' stamp: 'mt 5/23/2010 12:58:56.062'!
handlesMouseDown: evt

	^ true! !

!XpfPagingAreaMorph methodsFor: 'initialization' stamp: 'mt 4/23/2010 11:53:08.976'!
initialize

	super initialize.
	self
		addMorph: self leftSlider;
		addMorph: self rightSlider.! !

!XpfPagingAreaMorph methodsFor: 'accessing' stamp: 'mt 4/23/2010 12:03:01.644'!
leftSlider

	^ leftSlider ifNil: [leftSlider := XpfNavigationSlider new pagingArea: self]! !

!XpfPagingAreaMorph methodsFor: 'accessing' stamp: 'mt 8/27/2009 18:34'!
model
	"The scrollbar that uses this paging area. See XpfNavigationBar."
	
	^ model! !

!XpfPagingAreaMorph methodsFor: 'accessing' stamp: 'mt 8/27/2009 18:33'!
model: anObject

	model := anObject.! !

!XpfPagingAreaMorph methodsFor: 'event handling' stamp: 'mt 5/23/2010 13:02:27.305'!
mouseDown: evt

	self scrollToMouse: evt.! !

!XpfPagingAreaMorph methodsFor: 'accessing' stamp: 'mt 4/23/2010 10:58:16.181'!
navigationPanel

	^ self model! !

!XpfPagingAreaMorph methodsFor: 'colors' stamp: 'mt 5/17/2010 20:48:13.34'!
palette

	^ XpfNavigationColorPalette! !

!XpfPagingAreaMorph methodsFor: 'accessing' stamp: 'mt 4/23/2010 12:02:56.796'!
rightSlider

	^ rightSlider ifNil: [rightSlider := XpfNavigationSlider new pagingArea: self]! !

!XpfPagingAreaMorph methodsFor: 'scrolling' stamp: 'mt 5/23/2010 13:00:47.818'!
scrollToMouse: evt

	| pt |
	evt redButtonPressed ifTrue: [
		pt := (evt position adhereTo: (self bounds insetBy: (0@0 extent: self leftSlider extent)))
			- (self leftSlider width/2 @ 0).
		self leftSlider scrollbar setValue: 
			pt x / (self width - (self leftSlider width))].
	evt yellowButtonChanged ifTrue: [
		pt := (evt position adhereTo: (self bounds insetBy: (0@0 extent: self rightSlider extent)))
			- (self rightSlider width/2 @ 0).
		self rightSlider scrollbar setValue: 
			pt x / (self width - (self rightSlider width))].! !

Morph subclass: #XpfReleaseSeparatorMorph
	instanceVariableNames: 'addIterationButton editReleaseButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfReleaseSeparatorMorph commentStamp: 'mt 8/20/2009 13:40' prior: 0!
I can be used as a visual border between two iterations belonging to different releases.
My buttons provide editing facilities like adding a new iteration.
I represent one release and you should position me beside an iteration that belongs to me.!

!XpfReleaseSeparatorMorph methodsFor: 'accessing' stamp: 'topa 10/7/2009 11:11'!
addIterationButton

	addIterationButton ifNil: [
		addIterationButton := IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfAddIteration;
		actionSelector: #requestNewIteration;
		extent: 16@16;
		setBalloonText: 'Add new iteration' translated].
	^ addIterationButton! !

!XpfReleaseSeparatorMorph methodsFor: 'drawing' stamp: 'mt 5/20/2010 20:07:31.582'!
backgroundGradient

	^ self
		valueOfProperty: #backgroundGradient
		ifAbsentPut: [GradientFillStyle ramp: {
			0.0 -> XpfIterationColorPalette dark.
			1.0 -> XpfStoryColorPalette base}]! !

!XpfReleaseSeparatorMorph methodsFor: 'drawing' stamp: 'mt 5/20/2010 20:29:31.686'!
drawOn: aCanvas

"	aCanvas
		fillRectangle: self bounds
		fillStyle: (self backgroundGradient
			origin: self topLeft;
			direction: (self width @ 0))."
			
	aCanvas
		fillRectangle: self bounds
		color: XpfIterationColorPalette dark.! !

!XpfReleaseSeparatorMorph methodsFor: 'drawing' stamp: 'mt 5/20/2010 20:34:06.304'!
drawScaledOn: aCanvas factor: aFactor boundingBox: bb

	"aCanvas
		fillRectangle: bb
		color: self palette middark."! !

!XpfReleaseSeparatorMorph methodsFor: 'drawing' stamp: 'mt 5/21/2010 16:38:57.972'!
drawScaledWithHighlightOn: aCanvas factor: aFactor boundingBox: bb

	^ self
		drawScaledOn: aCanvas
		factor: aFactor
		boundingBox: bb! !

!XpfReleaseSeparatorMorph methodsFor: 'accessing' stamp: 'mt 8/27/2009 17:59'!
editReleaseButton

	editReleaseButton ifNil: [
		editReleaseButton := IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfPencil;
		actionSelector: nil;
		extent: 16@16;
		setBalloonText: 'Edit release' translated].
	^ editReleaseButton! !

!XpfReleaseSeparatorMorph methodsFor: 'initialization' stamp: 'mt 10/8/2009 09:36'!
initialize

	super initialize.
	self
		extent: 18@100;
		color: Color black;
		addMorph: self addIterationButton;
		addMorph: self editReleaseButton.

	self addIterationButton
		position: self position + (1 @ (self width + 1 * 3)).
	self editReleaseButton 
		position: self position + (1 @ (self width + 1 * 4)).! !

!XpfReleaseSeparatorMorph methodsFor: 'actions' stamp: 'topa 10/7/2009 11:18'!
requestNewIteration

	self changed: #newIterationRequested.! !

Morph subclass: #XpfResizeGrip
	instanceVariableNames: 'orientation origin overlay isHighlighted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfResizeGrip commentStamp: 'mt 8/6/2009 19:52' prior: 0!
I recognize mouse drags in the horizontal axis.!

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/29/2009 10:59'!
doubleClick: evt

	self changed: #fitToSubmorphs with: {self. 0}.! !

!XpfResizeGrip methodsFor: 'drawing' stamp: 'bs 5/15/2010 21:13:02.076'!
drawOn: aCanvas

	| len shift1 shift2 tmp dcolor |
	len := self width - 4.
	
	shift1 := self isHighlighted
		ifTrue: [(self left + 1) @ ((((self globalPointToLocal: World hands first position) y - self width max: self top) min: self bottom))]
		ifFalse: [self topLeft + (1 @ (self height / 2 - (self width * 1.5)))].
	
	shift2 := shift1 + (0 @ self width).
	
	dcolor := self isHighlighted
		ifTrue: [self palette verydark]
		ifFalse: [self palette mid].

	self orientation = #toRight
		ifTrue: [tmp := shift1. shift1 := shift2. shift2 := tmp].

	aCanvas
		drawPolygon: {
			(0 @ len) + shift1.
			(len @ 0) + shift1.
			(len @ (len * 2)) + shift1}
		fillStyle: (SolidFillStyle color: dcolor).

	aCanvas
		drawPolygon: {
			(len @ len) + shift2.
			(0 @ 0) + shift2.
			(0 @ (len * 2)) + shift2}
		fillStyle: (SolidFillStyle color: dcolor).! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/27/2009 16:38'!
handleMouseMove: evt

	origin ifNil: [^ self].
	self left: evt targetPoint x.
	self overlay bounds: (origin quickMerge: self bounds).! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/6/2009 11:39'!
handlesMouseDown: evt

	^ true	! !

!XpfResizeGrip methodsFor: 'initialization' stamp: 'bs 5/18/2010 10:58:20.118'!
initialize

	super initialize.
	self
		extent: 10@300;
		borderStyle: BorderStyle raised;
		borderWidth: 1.! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/27/2009 15:57'!
isHighlighted

	isHighlighted ifNil: [self isHighlighted: false].
	^ isHighlighted.! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/29/2009 09:43'!
isHighlighted: aBoolean

	isHighlighted := aBoolean.
	self changed.! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/29/2009 11:02'!
mouseDown: evt

	self comeToFront.
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {nil. #doubleClick:. nil. #startDrag:}
		threshold: 1.! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/29/2009 10:54'!
mouseUp: evt

	origin = nil ifTrue: [^ self].
	
	self
		changed: #resized
		with: {self. self orientation = #toLeft
			ifTrue:  [(origin center - self center) x]
			ifFalse: [(self center - origin center) x]}.
			
	origin := nil.
	self overlay hide.! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/6/2009 20:10'!
orientation

	orientation ifNil: [self orientation: #toLeft].
	^ orientation! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/6/2009 20:11'!
orientation: anObject
	"Used to decide the sign of the move operation delta.
	#toLeft ... origin - position
	#toRight ... position - origin"
	
	orientation := anObject.! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/6/2009 12:16'!
overlay

	overlay ifNil: [
		overlay := Morph new.
		overlay color: (Color gray alpha: 0.2).
		self addMorph: overlay].
	^ overlay! !

!XpfResizeGrip methodsFor: 'accessing' stamp: 'mt 8/6/2009 13:32'!
overlayColor: aColor

	self overlay color: ((aColor mixed: 0.7 with: Color white) alpha: 0.8).
	self color: aColor.! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/6/2009 12:38'!
show

	super show.
	self overlay hide.! !

!XpfResizeGrip methodsFor: 'event handling' stamp: 'mt 8/29/2009 11:02'!
startDrag: evt

	origin := self bounds.
	(self overlay)
		bounds: self bounds;
		show.! !

Morph subclass: #XpfStoryProgressBar
	instanceVariableNames: 'max current story'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfStoryProgressBar class methodsFor: 'instance creation' stamp: 'mt 5/20/2010 22:04:33.59'!
forStory: aUserStory

	^ self new
		story: aUserStory! !

!XpfStoryProgressBar methodsFor: 'accessing' stamp: 'mt 5/23/2010 13:17:26.618'!
current

	^ self story
		ifNotNil: [self story timeActual]
		ifNil: [current ifNil: [self current: self max atRandom. current]]! !

!XpfStoryProgressBar methodsFor: 'accessing' stamp: 'mt 5/23/2010 13:11:04.229'!
current: anInteger

	current := anInteger min: self max.! !

!XpfStoryProgressBar methodsFor: 'drawing' stamp: 'mt 5/20/2010 22:21:06.022'!
drawOn: aCanvas

	| hStep |
	hStep := self width // (self max // 4).
	1 to: self max // 4 do: [:day |
		1 to: 4 do: [:quarter |
			aCanvas
				line: self topLeft + ((hStep * (day - 1)) @ ((quarter - 1) * 2))
				to: self topLeft + ((hStep * day - 2) @ ((quarter - 1) * 2))
				color: self palette light]].
		

	1 to: self current // 4 do: [:day |
		1 to: 4 do: [:quarter |
			aCanvas
				line: self topLeft + ((hStep * (day - 1)) @ ((quarter - 1) * 2))
				to: self topLeft + ((hStep * day - 2) @ ((quarter - 1) * 2))
				color: self palette text]].
		
	4 - (self current \\ 4) + 1 to: 4 do: [:quarter |
		aCanvas
			line: self topLeft + ((hStep * ((self current / 4 roundUpTo: 1) - 1)) @ ((quarter - 1) * 2))
			to: self topLeft + ((hStep * (self current / 4 roundUpTo: 1) - 2) @ ((quarter - 1) * 2))
			color: self palette text].! !

!XpfStoryProgressBar methodsFor: 'initialization' stamp: 'mt 5/20/2010 22:13:07.261'!
initialize

	super initialize.
	self extent: 55@7. ! !

!XpfStoryProgressBar methodsFor: 'accessing' stamp: 'mt 5/23/2010 13:14:12.814'!
max

	^ self story
		ifNotNil: [self story timeEstimated]
		ifNil: [max ifNil: [self max: 8 atRandom * 4. max]]! !

!XpfStoryProgressBar methodsFor: 'accessing' stamp: 'mt 5/23/2010 13:12:29.515'!
max: anInteger

	max := anInteger.
	self extent: ((anInteger // 4) * 11) @7! !

!XpfStoryProgressBar methodsFor: 'colors' stamp: 'mt 5/20/2010 22:07:08.488'!
palette

	^ XpfStoryColorPalette! !

!XpfStoryProgressBar methodsFor: 'accessing' stamp: 'mt 5/20/2010 22:04:17.966'!
story
	
	^ story! !

!XpfStoryProgressBar methodsFor: 'accessing' stamp: 'mt 5/20/2010 22:04:12.613'!
story: aUserStory

	story := aUserStory.! !

Morph subclass: #XpfToolbarMorph
	instanceVariableNames: 'commandProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfToolbarMorph commentStamp: 'mt 9/6/2009 18:53' prior: 0!
I provide buttons for actions delivered by a "command provider". This provider object should understand #availableCommands and return a list of XpfCommand objects.!

!XpfToolbarMorph class methodsFor: 'constants' stamp: 'mt 4/26/2010 16:04:58.389'!
defaultHeight

	^ 22! !

!XpfToolbarMorph methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:18'!
commandProvider

	^ commandProvider! !

!XpfToolbarMorph methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:44'!
commandProvider: anObject

	commandProvider := anObject.
	self updateButtons.! !

!XpfToolbarMorph methodsFor: 'initialize-update' stamp: 'mt 9/2/2009 14:22'!
createButtonForCommand: aCommand

	^ IconicButton new
		color: Color transparent;
		target: aCommand target;
		borderWidth: 0;
		labelGraphic: aCommand icon;
		actionSelector: aCommand selector;
		extent: 16@16;
		setBalloonText: aCommand name translated! !

!XpfToolbarMorph methodsFor: 'initialize-update' stamp: 'mt 4/26/2010 16:05:12.622'!
initialize

	super initialize.
	self
		extent: 100@ self class defaultHeight;
		color: self palette mid;
		updateButtons.! !

!XpfToolbarMorph methodsFor: 'initialize-update' stamp: 'mt 4/25/2010 19:54:18.809'!
updateButtons

	| offset |
	self removeAllMorphs.
	self commandProvider ifNil: [^ self]. "No provider -> no commands -> no buttons."
	
	offset := 5@2.
	self commandProvider availableCommands do: [:command | | btn |
		btn := self createButtonForCommand: command.
		self addMorph: btn.
		btn position: self position + offset.
		offset := offset + ((btn width + 5) @ 0)].! !

Morph subclass: #XpfUserStoryModel
	instanceVariableNames: 'priority'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Models'!

!XpfUserStoryModel commentStamp: 'mt 10/8/2009 15:11' prior: 0!
This model can be used in cases where a real user story (data model) is needed.!

!XpfUserStoryModel methodsFor: 'position' stamp: 'mt 10/8/2009 15:09'!
positionX

	^ self x! !

!XpfUserStoryModel methodsFor: 'position' stamp: 'mt 10/8/2009 15:09'!
positionX: aNumber

	self x: aNumber! !

!XpfUserStoryModel methodsFor: 'position' stamp: 'mt 10/8/2009 15:09'!
positionY

	^ self y! !

!XpfUserStoryModel methodsFor: 'position' stamp: 'mt 10/8/2009 15:09'!
positionY: aNumber

	self y: aNumber! !

!XpfUserStoryModel methodsFor: 'as yet unclassified' stamp: 'mt 6/21/2010 10:08:17.149'!
priority

	^ priority ifNil: [priority := 1]! !

!XpfUserStoryModel methodsFor: 'as yet unclassified' stamp: 'mt 6/21/2010 10:07:51.153'!
priority: aNumber

	priority := aNumber.! !

ImageMorph subclass: #XpfSplashScreen
	instanceVariableNames: 'title message currentMessage'
	classVariableNames: 'SplashScreen'
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Animations'!

XpfSplashScreen class
	instanceVariableNames: 'instance'!

XpfSplashScreen class
	instanceVariableNames: 'instance'!

!XpfSplashScreen class methodsFor: 'instance creation' stamp: 'mt 12/2/2009 10:52'!
appendMessage: aString
	"If there is a splash screen visible, append another message to the current one."
	
	instance ifNotNilDo: [:inst |
		inst appendMessage: aString].! !

!XpfSplashScreen class methodsFor: 'instance creation' stamp: 'mt 12/7/2009 13:02'!
delete

	instance ifNotNilDo: [:morph | morph delete].! !

!XpfSplashScreen class methodsFor: 'as yet unclassified' stamp: 'mt 12/2/2009 09:41'!
reset
	"Resets the splash screen to a new form."
	
	SplashScreen := Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self splashScreenContents readStream)! !

!XpfSplashScreen class methodsFor: 'as yet unclassified' stamp: 'mt 12/2/2009 09:38'!
reset: aForm
	"Resets the splash screen to a new form."
	
	SplashScreen := aForm! !

!XpfSplashScreen class methodsFor: 'instance creation' stamp: 'mt 5/17/2010 17:06:33.314'!
show: aTitle with: someMessages for: aUnaryBlock
	"Displays a splash screen while evaluating the given block several times with an increasing step number. Update the message according to the step."
	
	instance := self new.
	instance
		title: aTitle;
		showMessage: someMessages first;
		show.
		
	someMessages withIndexDo: [:msg :index |
		instance showMessage: msg.
		aUnaryBlock value: index].

	instance delete.
	instance := nil.! !

!XpfSplashScreen class methodsFor: 'as yet unclassified' stamp: 'mt 12/2/2009 09:43'!
splashScreenContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAAfQAAAEsCAYAAAA1u0HIAAAAGXRFWHRTb2Z0d2FyZQBBZG9i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='! !

!XpfSplashScreen methodsFor: 'actions' stamp: 'mt 5/17/2010 17:06:26.957'!
appendMessage: aString
	"Combines the current message with the given one."
	
	self
		message: self currentMessage, ' ', aString;
		comeToFront.
	
	World doOneCycle..! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:48'!
currentMessage

	^ currentMessage ifNil: ['']! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:47'!
currentMessage: anObject

	currentMessage := anObject.! !

!XpfSplashScreen methodsFor: 'initialization' stamp: 'mt 12/2/2009 10:11'!
initialize

	super initialize.
	
	SplashScreen ifNil: [self class reset].
	
	self
		image: SplashScreen;
		addMorph: self title;
		addMorph: self message.
		
	self title position: (260@150) + self position.
	self message position: (40@255) + self position.
	
	self title: 'Project Talk'.
	self message: 'Loading...'.! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:09'!
message

	^ message ifNil: [
		message := TextMorph new lock]! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:48'!
message: aString

	self message contents: ( aString asText
		addAttribute: (TextFontReference toFont: (StrikeFont familyName: #BitstreamVeraSans size: 18))).! !

!XpfSplashScreen methodsFor: 'actions' stamp: 'mt 5/17/2010 15:02:47.845'!
show

	self
		center: World center;
		openInWorld.! !

!XpfSplashScreen methodsFor: 'actions' stamp: 'mt 5/17/2010 17:06:23.502'!
showMessage: aString

	self
		currentMessage: aString;
		message: aString;
		comeToFront.
	
	World doOneCycle.! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:05'!
title

	^ title ifNil: [
		title := TextMorph new lock]! !

!XpfSplashScreen methodsFor: 'accessing' stamp: 'mt 12/2/2009 10:07'!
title: aString

	self title contents: ( aString asText
		addAttribute: (TextFontReference toFont: (StrikeFont familyName: #BitstreamVeraSans size: 36));
		addAttribute: TextEmphasis bold;
		addAttribute: (TextColor color: self palette verydark))! !

ImageMorph subclass: #XpfUserStoryAddMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

XpfUserStoryAddMorph class
	instanceVariableNames: 'icon'!

!XpfUserStoryAddMorph commentStamp: 'topa 3/9/2009 15:16' prior: 0!
I am a Morph that should behave somehow like a Button, yet are embeddable into
a PasteUpMorph.!

XpfUserStoryAddMorph class
	instanceVariableNames: 'icon'!

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'mfp 4/28/2009 10:46'!
emptyUserStory

	^ Dictionary newFrom:	{'title' -> 'Please enter content for new user story'}! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'mt 5/20/2010 08:36:13.144'!
emptyUserStoryAt: aPriority

	^ Dictionary newFrom: {
		'title' -> 'Please enter content for new user story'.
		'priority' -> aPriority}.! !

!XpfUserStoryAddMorph class methodsFor: 'initialize-release' stamp: 'cs 3/11/2009 17:57'!
forProjects: anXpfProject

	^ self new model: anXpfProject! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'topa 4/20/2009 17:53'!
icon

	^ icon ifNil: [icon := Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self iconContent readStream) ]! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/20/2009 22:41'!
icon: anIcon

	icon := anIcon.! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/20/2009 22:39'!
iconContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAAFIAAAA2CAYAAABUSc7XAAAAGXRFWHRTb2Z0d2FyZQBBZG9i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'! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'topa 3/11/2009 14:00'!
handlesMouseDown: evt

	self enabled ifTrue:
		[evt hand waitForClicksOrDrag: self event: evt].
	^ true! !

!XpfUserStoryAddMorph methodsFor: 'initialization' stamp: 'topa 4/20/2009 17:57'!
initialize

	super initialize.
	self
		image: self class icon.! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model

	^ model! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model: anObject

	model := anObject.! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'cs 3/18/2009 15:28'!
mouseDown: evt
	
	^ self performAction openInHand! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'mt 4/28/2009 19:20'!
performAction
	"for Button behavior"

	^ XpfUserStoryMorph forUserStory: XpfNewUserStory new! !

SwaGeneralScrollPane subclass: #XpfTapeScroller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfTapeScroller commentStamp: 'mt 9/6/2009 18:55' prior: 0!
I modify the GeneralScrollPane in the following:

  - hide vertical scrollbar
  - use a special horizontal scrollbar (-> XpfNavigationBar)
  - react to changes of my scroll target
  - use mouse wheel to scroll horizontally!

!XpfTapeScroller methodsFor: 'commands' stamp: 'mt 4/16/2010 14:38:24.706'!
availableCommands

	^ {
		XpfCommand new
			name: 'Add new release';
			icon: MenuIcons flagBlueIcon;
			target: self scrollTarget;
			selector: #createRelease.
		XpfCommand new
			name: 'Toggle grid visibility';
			icon: MenuIcons xpfGridIcon;
			target: self scrollTarget;
			selector: #toggleShowGrid.
		XpfCommand new
			name: 'Toggle smooth card movement';
			icon: MenuIcons xpfMoveCardIcon;
			target: self scrollTarget;
			selector: #toggleSmoothMoving.
		XpfCommand new
			name: 'Toggle hover effect in grid';
			icon: MenuIcons xpfGridHoverIcon;
			target: self scrollTarget;
			selector: #toggleShowHoverEffect.
		XpfCommand new
			name: 'Toggle visualization of occluded cards';
			icon: MenuIcons xpfCardOcclusionIcon;
			target: self scrollTarget;
			selector: #toggleShowOcclusions
		}! !

!XpfTapeScroller methodsFor: 'geometry' stamp: 'mt 5/20/2010 09:01:00.011'!
extent: aPoint

	super extent: aPoint.
	
	aPoint y > 50
		ifTrue: [self scrollTarget height: aPoint y].! !

!XpfTapeScroller methodsFor: 'testing' stamp: 'mt 4/25/2010 20:00:21.503'!
hScrollbarNeeded

	^ false! !

!XpfTapeScroller methodsFor: 'actions' stamp: 'mt 8/6/2009 10:34'!
hideOrShowScrollBars
	"Requested by slider. See ScrollBar>>#mouseDownInSlider:"! !

!XpfTapeScroller methodsFor: 'initialization' stamp: 'mt 5/20/2010 21:15:24.739'!
initialize

	super initialize.
	self extent: 1 @ XpfTapeMorph tapeHeight.! !

!XpfTapeScroller methodsFor: 'event handling' stamp: 'mt 4/16/2010 14:15:45.282'!
mouseWheel: event 
	"OVERRIDE: Only scroll horizontally."

	(self scrollTarget handlesMouseWheel: event)
		ifTrue: [^self scrollTarget mouseWheel: event]. "pass on"
	
	event direction = #up ifTrue: [
		hScrollbar scrollUp: 3].
	event direction = #down ifTrue: [
		hScrollbar scrollDown: 3]! !

!XpfTapeScroller methodsFor: 'initialization' stamp: 'mt 4/21/2010 09:56:45.17'!
newHScrollbar
	"Answer a new horizontal scrollbar."

	^XpfBoundedScrollBar new
		model: self;
		setValueSelector: #hScrollbarValue:! !

!XpfTapeScroller methodsFor: 'accessing' stamp: 'mt 8/5/2009 17:18'!
scrollBarThickness

	^ self hScrollbar sliderThickness! !

!XpfTapeScroller methodsFor: 'accessing' stamp: 'mt 10/4/2009 15:31'!
scrollTarget: aTapeMorph

	super scrollTarget: aTapeMorph.
	
	(aTapeMorph isKindOf: XpfTapeMorph)
		ifTrue: [self height: aTapeMorph class tapeHeight].
		
	aTapeMorph addDependent: self.
	
	self width: (aTapeMorph width min: 300).! !

!XpfTapeScroller methodsFor: 'updating' stamp: 'mt 8/5/2009 16:01'!
update: aSymbol

	aSymbol = #resized
		ifTrue: [self updateScrollbars].! !

!XpfTapeScroller methodsFor: 'updating' stamp: 'mt 4/24/2010 11:30:43.276'!
update: aSymbol with: aNumber

	self scrollTarget width = 0 ifTrue: [^ self].

	(aSymbol = #resized or: [aSymbol = #resizedLeft]) ifTrue: [
		self updateScrollbars.
		self hScrollbar setValue:
			self hScrollbar value + (aNumber / self scrollTarget width asFloat)].
	
	aSymbol = #resizedRight ifTrue: [
		self updateScrollbars].! !

!XpfTapeScroller methodsFor: 'testing' stamp: 'mt 8/5/2009 15:52'!
vScrollbarNeeded

	^ false! !

!XpfTapeScroller methodsFor: 'initialization' stamp: 'mt 4/25/2010 19:55:15.952'!
withToolbar

	^ BorderedMorph new
		color: Color transparent;
		borderWidth: 0;
		changeTableLayout;
		listDirection: #topToBottom;
		addMorphBack: (XpfToolbarMorph new hResizing: #spaceFill; commandProvider: self);
		addMorphBack: (self hResizing: #spaceFill; vResizing: #spaceFill);
		bounds: self submorphBounds.! !

XpfDefaultColorPalette subclass: #XpfIterationColorPalette
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Colors'!

!XpfIterationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 20:42:36.024'!
base

	^ Color
		r: 132 / 255
		g: 132 / 255
		b: 138 / 255! !

!XpfIterationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 20:28:15.005'!
dark

	^ Color
		r: 75 / 255
		g: 75 / 255
		b: 82 / 255! !

!XpfIterationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/21/2010 16:37:15.491'!
light

	^ Color
		r: 169 / 255
		g: 167 / 255
		b: 176 / 255! !

!XpfIterationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 20:05:24.789'!
mid

	^ Color
		r: 103 / 255
		g: 102 / 255
		b: 111 / 255! !

!XpfIterationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 20:24:14.276'!
middark

	^ Color
		r: 81 / 255
		g: 80 / 255
		b: 85 / 255! !

!XpfIterationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 20:42:45.015'!
text

	^ Color
		gray: 237 / 255! !

!XpfIterationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 20:28:20.088'!
verydark

	^ Color
		r: 53 / 255
		g: 51 / 255
		b: 54 / 255! !

XpfDefaultColorPalette subclass: #XpfNavigationColorPalette
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Colors'!

!XpfNavigationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 21:33:53.758'!
base

	^ Color
		r: 148 / 255
		g: 148 / 255
		b: 153 / 255! !

!XpfNavigationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/17/2010 20:45:52.371'!
dark

	^ Color
		r: 73 / 255
		g: 72 / 255
		b: 76 / 255! !

!XpfNavigationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/21/2010 16:15:47.508'!
mid

	^ Color
		r: 86 / 255
		g: 85 / 255
		b: 90 / 255! !

!XpfNavigationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/17/2010 20:50:37.915'!
middark

	^ Color
		r: 79 / 255
		g: 77 / 255
		b: 81 / 255! !

!XpfNavigationColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/17/2010 20:50:41.275'!
verydark

	^ Color
		r: 47 / 255
		g: 47 / 255
		b: 50 / 255! !

XpfDefaultColorPalette subclass: #XpfSplitterColorPalette
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Colors'!

!XpfSplitterColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/17/2010 19:58:46.393'!
base

	^ Color
		gray: 191 / 255! !

!XpfSplitterColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/17/2010 19:59:07.006'!
light

	^ Color
		gray: 222 / 255! !

!XpfSplitterColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 21:54:36.336'!
verydark

	^ Color
		r: 67 / 255
		g: 66 / 255
		b: 70 / 255! !

XpfDefaultColorPalette subclass: #XpfStoryColorPalette
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Colors'!

!XpfStoryColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/18/2010 16:59:39.351'!
base

	^ Color
		r: 146 / 255
		g: 145 / 255
		b: 152 / 255! !

!XpfStoryColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/18/2010 17:15:45.079'!
dark

	^ Color
		r: 84 / 255
		g: 83 / 255
		b: 87 / 255! !

!XpfStoryColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/21/2010 09:28:14.389'!
highlight1

	^ Color
		r: 210 / 255
		g: 138 / 255
		b: 0 / 255! !

!XpfStoryColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/21/2010 09:28:17.746'!
highlight2

	^ Color
		r: 193 / 255
		g: 210 / 255
		b: 0 / 255! !

!XpfStoryColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/18/2010 16:59:22.438'!
light

	^ Color
		r: 169 / 255
		g: 167 / 255
		b: 176 / 255! !

!XpfStoryColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/18/2010 16:59:57.236'!
mid

	^ Color
		r: 128 / 255
		g: 127 / 255
		b: 134 / 255! !

!XpfStoryColorPalette class methodsFor: 'as yet unclassified' stamp: 'mt 5/18/2010 16:59:00.793'!
text

	^ Color
		gray: 237 / 255! !

BorderedMorph subclass: #XpfBorderedMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk'!

!XpfBorderedMorph commentStamp: 'mt 4/23/2010 11:21:40.04' prior: 0!
You can choose your own splitter class.!

!XpfBorderedMorph methodsFor: 'lookenhancements' stamp: 'mt 5/17/2010 20:13:08.46'!
addPaneSplitters
	| splitter remaining target targetX sameX minY maxY targetY sameY minX maxX |
	self removePaneSplitters.
	self removeCornerGrips.

	remaining := submorphs reject: [:each | each layoutFrame rightFraction = 1].
	[remaining notEmpty] whileTrue:
		[target := remaining first.
		targetX := target layoutFrame rightFraction.
		sameX := submorphs select: [:each | each layoutFrame rightFraction = targetX].
		minY := (sameX detectMin: [:each | each layoutFrame topFraction]) layoutFrame topFraction.
		maxY := (sameX detectMax: [:each | each layoutFrame bottomFraction]) layoutFrame bottomFraction.
		splitter := self splitterClass new.
		splitter layoutFrame: (LayoutFrame
			fractions: (targetX @ minY corner: targetX @ maxY)
			offsets: ((0 @ (target layoutFrame topOffset ifNil: [0]) corner: self splitterClass splitterWidth @ (target layoutFrame bottomOffset ifNil: [0])) translateBy: (target layoutFrame rightOffset ifNil: [0]) @ 0)).
		self addMorphBack: (splitter position: self position).
		remaining := remaining copyWithoutAll: sameX].

	remaining := submorphs copy reject: [:each | each layoutFrame bottomFraction = 1].
	[remaining notEmpty]
		whileTrue: [target := remaining first.
			targetY := target layoutFrame bottomFraction.
			sameY := submorphs select: [:each | each layoutFrame bottomFraction = targetY].
			minX := (sameY detectMin: [:each | each layoutFrame leftFraction]) layoutFrame leftFraction.
			maxX := (sameY detectMax: [:each | each layoutFrame rightFraction]) layoutFrame rightFraction.
			splitter := self splitterClass new beSplitsTopAndBottom; yourself.
			splitter layoutFrame: (LayoutFrame
				fractions: (minX @ targetY corner: maxX @ targetY)
				offsets: (((target layoutFrame leftOffset ifNil: [0]) @ 0 corner: (target layoutFrame rightOffset ifNil: [0]) @ self splitterClass splitterWidth) translateBy: 0 @ (target layoutFrame bottomOffset ifNil: [0]))).
			self addMorphBack: (splitter position: self position).
			remaining := remaining copyWithoutAll: sameY].

	self linkSubmorphsToSplitters.
	self splitters do: [:each | each comeToFront].
! !

!XpfBorderedMorph methodsFor: 'drawing' stamp: 'mt 5/17/2010 20:36:31.61'!
backgroundGradient

	^ self
		valueOfProperty: #backgroundGradient
		ifAbsentPut: [
			GradientFillStyle ramp: {
				0.0 -> (Color gray: 0.54).
				1.0 -> (Color gray: 0.29)}]! !

!XpfBorderedMorph methodsFor: 'drawing' stamp: 'mt 5/17/2010 20:38:01.787'!
drawOn: aCanvas

	aCanvas
		fillRectangle: self bounds
		fillStyle: (self backgroundGradient
			origin: self topLeft;
			direction: self extent)! !

!XpfBorderedMorph methodsFor: 'initialization' stamp: 'mt 5/17/2010 20:37:00.697'!
initialize
	
	super initialize.
	self
		borderWidth: 0;
		listDirection: #leftToRight;
		changeProportionalLayout.! !

!XpfBorderedMorph methodsFor: 'initialization' stamp: 'mt 4/23/2010 11:23:31.668'!
splitterClass

	^ XpfSplitterMorph! !

BorderedMorph subclass: #XpfDeveloperListEntryMorph
	instanceVariableNames: 'user onlineIcon userNameText connectDisconnectButton clientTunnel rfbClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfDeveloperListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 13:57'!
forUser: anXpfUser

	^ self new
		user: anXpfUser! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'bs 7/8/2009 18:46'!
connect

	| forwardedVncClienPort |
	forwardedVncClienPort := 15000.
	clientTunnel := SSHTunnel new
							isLocalTunnel: true;
							localPort: forwardedVncClienPort;
							remotePort: self user sharingPort;
							server: self user repository url authority.
	clientTunnel execute.
	
	(0 to: 10) 
		do: [:ignore | (Delay forMilliseconds: 600) wait]
		displayingProgress: 'Giving SSH connection some time...'.

	rfbClient := RFBClient open.
	rfbClient xpfUserId: ActiveHand login.
	rfbClient connectToRfbHub: forwardedVncClienPort.! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'mt 5/6/2009 10:54'!
connectDisconnect

	self isConnected 
		ifFalse: [
			self connectDisconnectButton labelGraphic: MenuIcons xpfScreenDisconnect.
			self connect] 
		ifTrue: [
			self connectDisconnectButton labelGraphic: MenuIcons xpfScreenIndicatedShared.
			self disconnect].! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:22'!
connectDisconnectButton

	connectDisconnectButton ifNil: 
		[ self connectDisconnectButton: ((IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfScreenIndicatedShared;
			actionSelector: #connectDisconnect;
			setBalloonText: '')
			visible: self user sharingPort notNil)].	
	^ connectDisconnectButton! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:40'!
connectDisconnectButton: anObject 

	connectDisconnectButton := anObject! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'mt 4/27/2009 13:42'!
connectDisconnectLabel

	^ MenuIcons xpfScreenIndicatedShared asMorph! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'bs 4/27/2009 21:08'!
disconnect

	rfbClient ifNotNil: [
		rfbClient disconnectFromRfbHub.
		rfbClient close.
		rfbClient := nil].
	
	clientTunnel ifNotNil: [
		clientTunnel terminate.
		clientTunnel := nil].! !

!XpfDeveloperListEntryMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/5/2009 10:40'!
initialize

	super initialize.
	self
		changeTableLayout;
		listDirection: #leftToRight;
		listCentering: #center;
		hResizing: #spaceFill;
		vResizing: #rigid;
		width: XpfDeveloperListWidget defaultExtent x;
		height: 20;
		cellInset: 4.! !

!XpfDeveloperListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 14:02'!
initializeUserInterface

	self
		removeAllMorphs;
		addMorphBack: self onlineIcon;
		addMorphBack: self userNameText;
		addMorphBack: self connectDisconnectButton.! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'bs 4/27/2009 18:59'!
isConnected
	
	^ clientTunnel notNil! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:59'!
onlineIcon

	onlineIcon ifNil: [self onlineIcon:
		(XpfPluggableImageMorph
			formOn: MenuIcons xpfDeveloperIsOnline
			formOff: MenuIcons xpfDeveloperIsOffline
			model: self user
			getOnOffSelector: #isOnline)].
	^ onlineIcon! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:35'!
onlineIcon: anObject

	onlineIcon := anObject.! !

!XpfDeveloperListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 16:54'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #sharingPort ifTrue: [
		self changed: #connectDisconnectLabel.
		self connectDisconnectButton visible: self user sharingPort notNil.
		self connectDisconnectButton setBalloonText: self user sharingPort asString].! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:57'!
user

	^ user! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:02'!
user: anXpfUser

	user ifNotNil: [user removeDependent: self].
	user := anXpfUser.
	user ifNotNil: [user addDependent: self].
	
	self initializeUserInterface.! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'cs 5/15/2009 13:22'!
userNameText

	userNameText ifNil: [self userNameText:
		((XpfPluggableTextMorph
			on: self user
			getTextSelector: #userName)
			lock;
			hResizing: #spaceFill)].
	^ userNameText! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:57'!
userNameText: anObject

	userNameText := anObject.! !

BorderedMorph subclass: #XpfElementListMorph
	instanceVariableNames: 'model scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:34'!
defaultExtent

	^ self defaultWidth @ self defaultHeight.! !

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:33'!
defaultHeight

	self subclassResponsibility.! !

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:32'!
defaultWidth

	self subclassResponsibility.! !

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:43'!
for: anXpfIteration

	^self new model: anXpfIteration! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2010 17:09:09.105'!
buildList

	self submorphsDelete.
	self scrollPane updateScrollbars.! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:32'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		listDirection: #topToBottom;
		fillStyle: Color transparent;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 2.! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'SR 4/11/2009 21:13'!
model

	^ model! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 13:39'!
model: anXpfIteration

	self model ifNotNil: [
		self model removeDependent: self.
		self model userStories ifNotNil: [self model userStories removeDependent: self]].
	
	model := anXpfIteration.
	self buildList.
	
	2 timesRepeat: [self scrollPane updateScrollbars]. "yep!!"
	
	self model ifNotNil: [
		self model addDependent: self.
		self model userStories ifNotNil: [self model userStories addDependent: self]].! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'mt 4/7/2010 17:23:43.828'!
scrollPane

	^ scrollPane ifNil: [scrollPane := SwaGeneralScrollPane new]! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'cs 4/14/2009 17:01'!
scrollPane: anObject

	scrollPane := anObject.! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:38'!
submorphsDelete

	submorphs ifNotNilDo: [:s | s do: [:m | m delete]].! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2010 17:02:40.447'!
withScrollBars

	self 		
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self scrollPane
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		"extent: self class defaultExtent;"
		fillStyle: Color transparent;
		borderWidth: 0;
		scrollTarget: self.
	^ self scrollPane! !

XpfElementListMorph subclass: #XpfTaskListMorph2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfTaskListMorph2 class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:33'!
defaultHeight

	^ 500! !

!XpfTaskListMorph2 class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:31'!
defaultWidth 

	^ 180! !

!XpfTaskListMorph2 methodsFor: 'updating' stamp: 'mt 5/2/2010 17:09:42.66'!
buildList

	| filter |
	super buildList.
	self model ifNil: [^self].
	self model userStories
		do: [:us | us tasks isLoaded ifFalse: [us tasks reloadDepth: 3]]
		displayingProgress: 'Loading...'.

	filter := XpfTaskWidgetFilter new name: 'My';
		filterBlock: [:task | task responsibleDeveloper = self model currentUser & task isDone not].
	filter nextFilter: (XpfTaskWidgetFilter new name: 'Related';
		filterBlock: [:task | (task developers includes: self model currentUser) & task isDone not]).
	filter nextFilter: (XpfTaskWidgetFilter new name: 'Open';
		filterBlock: [:task | task isDone not]).
	filter nextFilter: (XpfTaskWidgetFilter new name: 'Finished').
	self model userStories do: [:us |
		us tasks
			do: [:task | filter process: task];			
			addDependent: self].
	
	filter createMorphListIn: self.
	
	self scrollPane updateScrollbars.! !

!XpfTaskListMorph2 methodsFor: 'updating' stamp: 'mt 5/2/2010 17:15:13.737'!
update: aSymbol

	aSymbol = #requestSorting | (aSymbol = #tasksLoaded) | (aSymbol = #userStoriesLoaded) ifTrue: [
		self buildList].
	super update: aSymbol.! !

XpfElementListMorph subclass: #XpfUserStoryListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfUserStoryListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:33'!
defaultHeight

	^ 500! !

!XpfUserStoryListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:31'!
defaultWidth 

	^ 200! !

!XpfUserStoryListMorph methodsFor: 'as yet unclassified' stamp: 'cs 6/11/2009 14:50'!
buildList
	super buildList.
	self model ifNil: [ ^ self ].
	self model userStories isLoaded ifFalse: [ self model userStories reloadDepth: 4 ].
	self model userStories do: [ :each | self addMorphBack: (XpfUserStoryListEntryMorph for: each) ]! !

!XpfUserStoryListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:39'!
update: aSymbol

	aSymbol = #userStoriesLoaded ifTrue: [
		self buildList].
	super update: aSymbol.! !

BorderedMorph subclass: #XpfEntityMorph
	instanceVariableNames: 'model inEditMode inZoomMode zoomContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfEntityMorph class methodsFor: 'as yet unclassified' stamp: 'mt 3/13/2009 13:49'!
defaultColor

	^ self subclassResponsibility! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:16'!
acceptChanges
	self acceptSubmorphs.
	self switchToViewMode.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'cs 4/14/2009 18:28'!
acceptSubmorphs

	self model deferCommit: [
		self submorphsDo: [:m | m allMorphsDo: [:contentMorph |
			contentMorph isEntityMorphContent ifTrue: [contentMorph accept]]]].! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 6/29/2009 13:38'!
buildContent
	self createMainContent! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:16'!
cancelChanges
	self cancelSubmorphs.
	self switchToViewMode.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'mt 4/28/2009 10:31'!
cancelSubmorphs

	self submorphsDo: [:m | m allMorphsDo: [:contentMorph |	
		contentMorph isEntityMorphContent ifTrue: [contentMorph cancel]]].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:16'!
click: evt

	evt yellowButtonPressed 
		ifTrue: [
			self openContextPopupMenu.
			evt wasHandled: true].
	
	(self inEditMode & evt redButtonPressed)
		ifTrue: [
			self cancelChanges.
			evt wasHandled: true].! !

!XpfEntityMorph methodsFor: 'private' stamp: 'mt 4/28/2010 11:54:52.902'!
createEstimateEdit
	| edit |
	edit := (XpfCardEdit
		for: self
		get: #timeEstimated
		set: #timeEstimated:)
		validator: #integer;
		autoAccept: true;
		acceptOnCR: true;
		width: 24;
		borderWidth: 0;
		height: 18;
		color: (self palette mid alpha: 0.5).
	^edit! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 6/17/2009 10:43'!
createMainContent
	self subclassResponsibility! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 6/22/2009 22:43'!
detailContentMorphs

	|morphs|
	
	(self hasProperty: #XpfTaskDetails) ifFalse: [
		morphs := self createDetailContentMorphs.
		morphs do: [:morph | self addMorphBack: morph].
		self setProperty: #XpfTaskDetails toValue: morphs ].
	
	^ self valueOfProperty: #XpfTaskDetails
	! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:08'!
doubleClick: evt

	(evt redButtonPressed and: [self inEditMode not]) 
		ifTrue: [
			self switchToEditMode.
			evt wasHandled: true.
			].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'mfp 3/18/2009 17:08'!
handlesMouseDown: evt

	^ true! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 7/1/2009 19:58'!
hideDetailContent

	self detailContentMorph hide! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 17:56'!
inEditMode

	^ inEditMode! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 6/16/2009 23:01'!
inEditMode: anObject

	inEditMode := anObject.
	self update: #inEditMode.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:30'!
inZoomMode

	^ inZoomMode! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:30'!
inZoomMode: anObject

	inZoomMode := anObject.! !

!XpfEntityMorph methodsFor: 'initialization' stamp: 'mt 4/27/2010 19:50:12.14'!
initialize
	super initialize.
	self
		hResizing: #rigid;
		vResizing: #rigid;
		cellInset: 0;
		changeTableLayout;
		listDirection: #leftToRight;
		inEditMode: false;
		inZoomMode: false;
		borderWidth: 1;
		fillStyle: Color transparent; " self class defaultColor;"
		enableDragNDrop;
		buildContent
	"layoutInset: 2;"! !

!XpfEntityMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 22:01'!
isXpfEntityMorph

	^true! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mt 3/13/2009 13:54'!
model

	^ model! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'topa 10/6/2009 18:46'!
model: anXpfEntity

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfEntity.
	self model ifNotNil: [self model addDependent: self].
	
	self updateContentModel.
	! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 6/29/2009 17:48'!
mouseDown: evt
	"Do nothing upon mouse-down except inform the hand to watch for a 
	double-click; wait until an ensuing click:, doubleClick:, or drag: 
	message gets dispatched"
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 5.
	
	self comeToFront.! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 7/1/2009 19:58'!
showDetailContent

	self detailContentMorph show.! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'SR 3/19/2009 19:39'!
startDrag: evt

	evt redButtonPressed ifTrue: [
		evt hand grabMorph: self].! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'bs 7/1/2009 20:56'!
switchToEditMode
	
	self toggleEditMode.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'bs 7/1/2009 20:56'!
switchToViewMode
	
	self toggleEditMode.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 7/8/2009 19:15'!
timeEstimated
	^ self model timeEstimated ifNil: [0].! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 6/16/2009 22:49'!
timeEstimated: aPositiveInteger
	^ self model timeEstimated: aPositiveInteger! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'SR 4/18/2009 11:26'!
toggleEditMode
	
	self 
		allSubmorphsWith: [:m | m isEntityMorphContent not] 
		do: [:m | m isEntityMorphContent ifTrue: [m toggleEditMode]].	
	self inEditMode: self inEditMode not.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'mt 4/28/2010 21:11:31.351'!
toggleZoomMode
	
	self inEditMode ifTrue: [
		self cancelSubmorphs.
		self toggleEditMode].
	
	self inZoomMode
		ifTrue: [
			self hideDetailContent.
			self inZoomMode: false.
			self changed: #zoomOut]
		ifFalse: [
			self showDetailContent.
			self inZoomMode: true.
			self comeToFront.
			self changed: #zoomIn].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 6/12/2009 13:25'!
update: aSymbol
	
	aSymbol = #accepted ifTrue: [
		self acceptChanges].
	
	aSymbol = #cancelled ifTrue: [
		self cancelSubmorphs.
		self toggleEditMode].
	
	aSymbol = #toggleZoom ifTrue: [self toggleZoomMode].
	aSymbol = #enterEditMode ifTrue: [self toggleEditMode].
	super update: aSymbol.

	! !

!XpfEntityMorph methodsFor: 'private' stamp: 'SR 4/18/2009 11:26'!
updateContentModel

	(self model isNil | self submorphs isNil) ifTrue: [^ self].
	self 
		allSubmorphsWith: [:m | m isEntityMorphContent not] 
		do: [:m | m isEntityMorphContent ifTrue: [m model: self model]].! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'SR 4/18/2009 11:09'!
zoomContent

	zoomContent ifNil: [
		self zoomContent: (XpfZoomButtonContent forModel: self model).
		self zoomContent addDependent: self.
		self addDependent: self zoomContent].
	^ zoomContent! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/18/2009 18:14'!
zoomContent: anObject

	zoomContent := anObject.! !

XpfEntityMorph subclass: #XpfTaskMorph
	instanceVariableNames: 'actionsMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfTaskMorph class methodsFor: 'defaults' stamp: 'cs 5/13/2009 15:57'!
defaultColor

	^ Color lightRed alpha: 0.85! !

!XpfTaskMorph class methodsFor: 'defaults' stamp: 'cs 5/13/2009 15:57'!
defaultDoneColor

	^ Color lightGreen alpha: 0.85! !

!XpfTaskMorph class methodsFor: 'initialize-release' stamp: 'mfp 3/20/2009 11:23'!
forTask: anXpfTask

	^ self basicNew
		model: anXpfTask;
		initialize;
		update: anXpfTask! !

!XpfTaskMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 21:10'!
actionsMorph

	actionsMorph ifNil: [
		actionsMorph := (XpfTaskActionsContent forModel: self model).
		self actionsMorph addDependent: self.
		self addDependent: self actionsMorph].
	^ actionsMorph! !

!XpfTaskMorph methodsFor: 'accessing' stamp: 'mt 4/28/2010 21:24:18.225'!
comeToFront
	"Ignore."! !

!XpfTaskMorph methodsFor: 'content handling' stamp: 'mt 4/28/2010 20:46:12.376'!
createDetailContentMorphs

	self detailContentMorph: ((SwaColumnPanel for: {
		XpfSimpleTaskWidgetActionsContent forModel: self model.
		XpfTaskDeveloperContent forModel: self model}) spacing: 0; color: self palette dark).
		
	^ self detailContentMorph! !

!XpfTaskMorph methodsFor: 'content handling' stamp: 'mt 4/28/2010 20:44:49.077'!
createMainContent
	
	self
		extent: (XpfUserStoryMorph defaultWidth @ XpfUserStoryMorph defaultHeight) - (25@15);
		listDirection: #topToBottom;
		addMorphBack: ((SwaRowPanel for: { 
				XpfTaskTitleContent forModel: self model.
				self actionsMorph})
			layoutInset: 0;
			cellInset: 2);
		addMorphBack: ((SwaRowPanel for: { 
				self zoomContent.
				SwaHFiller fixed: 80.
				self createEstimateEdit.
				SwaHFiller fixed: 5})
			layoutInset: 0;
			cellInset: 5);
		addMorphBack: self createDetailContentMorphs.
		
	self detailContentMorph hide.! !

!XpfTaskMorph methodsFor: 'testing' stamp: 'mt 4/28/2010 20:30:19.253'!
detailContentMorph

	^ self valueOfProperty: #XpfTaskDetails! !

!XpfTaskMorph methodsFor: 'testing' stamp: 'mt 4/28/2010 20:30:25.052'!
detailContentMorph: morphs

	^ self setProperty: #XpfTaskDetails toValue: morphs.	! !

!XpfTaskMorph methodsFor: 'content handling' stamp: 'mt 4/28/2010 20:30:42.356'!
detailContentMorphs

	^ {self detailContentMorph}
	! !

!XpfTaskMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2010 21:10:50.093'!
initialize

	super initialize.
	self disableDragNDrop.! !

!XpfTaskMorph methodsFor: 'testing' stamp: 'mt 3/13/2009 14:50'!
isTaskMorph

	^ true! !

!XpfTaskMorph methodsFor: 'accessing' stamp: 'mt 4/28/2010 21:08:37.208'!
openContextPopupMenu

	| menu statusMenu |
	statusMenu := MenuMorph new.
	statusMenu
		add: 'Open'
		target: self model
		selector: #isDone:
		argument: false.
	statusMenu lastItem isEnabled: model isDone.
	statusMenu
		add: 'Done'
		target: self model
		selector: #isDone:
		argument: true.
	statusMenu lastItem isEnabled: model isDone not.
		
	menu := MenuMorph entitled: 'Task'.
	menu add: 'Status' subMenu: statusMenu.
	menu addLine.
	menu
		addLabel: 'Delete'
		target: self model
		selector: #delete
		enabled: true
		icon: #xpfDeleteIcon.
	
	menu popUpInWorld.! !

!XpfTaskMorph methodsFor: 'event handling' stamp: 'mt 4/28/2010 20:53:58.256'!
update: aSymbol

	super update: aSymbol.

	self model isDone
		ifTrue: [self color: self class defaultDoneColor]
		ifFalse: [self color: self class defaultColor].
		
	aSymbol = #deleted ifTrue: [self delete].! !

!XpfTaskMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 14:42'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsTasks! !

XpfEntityMorph subclass: #XpfUserStoryMorph
	instanceVariableNames: 'actionsMorph card cancelButton acceptButton deleteButton historyButton actionHalosMorph progressBar showOcclusions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'mfp 3/17/2009 15:34'!
defaultColor
	
	^	Color white.! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'mt 4/26/2010 11:07:01.412'!
defaultHeight
	
	^ 110! !

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'mt 4/26/2010 11:07:07.257'!
defaultWidth
	
	^ 200! !

!XpfUserStoryMorph class methodsFor: 'initialize-release' stamp: 'mfp 3/17/2009 16:04'!
forUserStory: anXpfUserStory

	^ self basicNew
		model: anXpfUserStory;
		initialize! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:22'!
acceptButton

	^ acceptButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:21'!
acceptButton: anObject

	acceptButton := anObject.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:41'!
actionHalosMorph

	^ actionHalosMorph! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:41'!
actionHalosMorph: anObject

	^ actionHalosMorph := anObject! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 21:10'!
actionsMorph

	actionsMorph ifNil: [
		actionsMorph := (XpfUserStoryActionsContent forModel: self model).
		self actionsMorph addDependent: self.
		self addDependent: self actionsMorph].
	^ actionsMorph! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'mt 5/25/2010 16:28:03.92'!
buildContent

	self
		listDirection: #topToBottom;
		addMorphBack: ((SwaRowPanel for: {
			self createMainContent.
			self createActionHalosMorph}) spacing: 0; margin: 1).
"		addMorphBack: self createZoomContent;
		addMorphBack: self createDetailContentMorph."
		
	"self zoomContent hide.
	self detailContentMorph hide."! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:41'!
calculateEstimationSumForAllTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			task timeEstimated 
				ifNotNil: [subTotal + task timeEstimated] 
				ifNil: [subTotal]]! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:41'!
calculateEstimationSumForCompletedTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			(task isDone and: [task timeEstimated notNil])  
				ifTrue: [subTotal + task timeEstimated] 
				ifFalse: [subTotal]]
! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:41'!
calculateProgressBarValue

	^ self model 
		ifNotNil: [ self calculateEstimationSumForAllTasks = 0.0 
			ifTrue: [ 0.0 ]
			ifFalse: [self calculateEstimationSumForCompletedTasks / self calculateEstimationSumForAllTasks]]! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:22'!
cancelButton

	^ cancelButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:20'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/30/2009 17:46'!
cardMorph
	^ card! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'mt 8/27/2009 20:18'!
color

	^ self cardMorph color! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 7/8/2009 22:12'!
color: aColor
	super color: aColor.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:25'!
createAcceptButton

	self acceptButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfAccept;
			actionSelector: #acceptChanges;
			setBalloonText: 'Accept changes').
	^ self acceptButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'mt 4/28/2010 19:54:40.145'!
createActionHalosMorph

	self createDeleteButton.
	self createHistoryButton.
	self createCancelButton.
	self createAcceptButton.
	
	self actionHalosMorph: (SwaColumnPanel new spacing: 0; color: (self palette mid alpha: 0.8)).
	self addMorphBack: self actionHalosMorph.
	self actionHalosMorph 
		extent: 20 @ self height;
		hide.
	
	self actionHalosMorph addMorphBack: self deleteButton.
	self actionHalosMorph addMorphBack: self historyButton.
	
	^ self actionHalosMorph! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:23'!
createCancelButton

	self cancelButton:(IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCancel;
			actionSelector: #cancelChanges;
			setBalloonText: 'Cancel changes').
	^ self cancelButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'mt 12/8/2009 15:35'!
createDeleteButton

	self deleteButton: (IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfDeleteIcon;
		actionSelector: #deleteStory;
		setBalloonText: 'Delete this user story').
	^ self deleteButton! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'mt 4/28/2010 12:27:01.627'!
createDetailContentMorph

"	self assert: self zoomContent notNil description: 'zoomContent must not be nil. it has to be created before detailContent is built'.
"
	"self zoomContent ifNil: [self createZoomContent]."
	"yOffset := self height + self zoomContent height."
	self detailContentMorph: ((SwaRowPanel for: {
			XpfTasksContent forModel: self model tasks.
			SwaHFiller fixed: 20}) spacing: 0).
	^ self detailContentMorph ! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/8/2009 17:54'!
createEstimationCircleMorph
	|circle segment radius iterationUnits storyCosts gamma vertices deltaY deltaX offset segmentColor |
	
	radius := 30.
	iterationUnits := 60 * 100.
	storyCosts := self timeEstimated * 100.
	
	circle := CircleMorph new.
	circle extent: (2*radius)@(2*radius);
						 borderWidth: 0;
						 color: Color veryVeryLightGray.

	(storyCosts > 0) ifTrue: [
	gamma := 360 / iterationUnits.
	vertices := OrderedCollection new.
	vertices addAll: {0@0. radius@0}.

	1 to: storyCosts do: [:i |
		deltaY := (gamma*i) degreeSin * radius.
		deltaX := ((radius*radius) - (deltaY*deltaY)) sqrt.
		vertices add: (deltaX rounded * (gamma*i+90) degreeSin sign)@(deltaY rounded).
	].
	segmentColor := Color r: 1.0 g: 0.725 b: 0.482.
	segment := (PolygonMorph vertices: vertices color: segmentColor borderWidth: 0 borderColor: nil).
	
	offset := circle extent - segment extent.
	circle addMorph: segment.
	segment position: offset.
	].
	^ circle.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/23/2009 21:53'!
createHistoryButton

	self historyButton: (IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfHistory;
		actionSelector: #showHistory;
		setBalloonText: 'Show history of this user story').
	^ self historyButton! !

!XpfUserStoryMorph methodsFor: 'private' stamp: 'mt 4/27/2010 19:04:49.349'!
createLayoutContainer
	| container estimationCircle |
	container := Morph new.
	container
		extent: 170 @ 100;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self addMorph: container.
"	estimationCircle := self createEstimationCircleMorph.
	estimationCircle center: 140 @ 70.
	self addMorphBack: estimationCircle."
	^ container! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'mt 5/21/2010 09:39:46.21'!
createMainContent
	
	card := XpfCardMorph new
		fillStyle: ((GradientFillStyle ramp: {
			0.0 -> self palette base.
			1.0 -> self palette mid})
			origin: self topLeft;
			direction: (self class defaultWidth @ self class defaultHeight));
		borderColor: self palette light;
		borderWidth: 1;
		extent: (self class defaultWidth @ self class defaultHeight);
		storyMorph: self.
	
	self createProgressBar. "dummy"
				
	card addMorphBack: ("(SwaRowPanel for: {
		self createProgressBar."
		(SwaColumnPanel for: {
			XpfUserStoryTitleContent forModel: self model.
			SwaRowPanel for: {
				SwaHFiller fixed: 1.
				XpfStoryProgressBar new.
				
				"self createEstimateEdit.
				SwaHFiller fixed: 5."}}) spacing: 7; margin: 8).

	self progressBar extent: 10@108.
	"self progressBar position: 0@0."

	^ card.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/8/2009 22:52'!
createProgressBar
	self progressBar: (XpfProgressBarMorph new
			borderWidth: 0;
			color: Color transparent;
			progressColor: Color lightGreen;
			extent: 10@100).
	self updateProgressBar.
	^ self progressBar! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/11/2009 17:15'!
createTitleViewFor: aUserStory

	^ (XpfPluggableTextMorph
			on: aUserStory
			getTextSelector: #title)
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			margins: 3@0;
			extent: 170@100! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'mt 4/28/2010 19:55:55.261'!
createZoomContent

	| button |
	button := XpfZoomButtonContent forModel: self model..
	self zoomContent:
		((SwaRowPanel for: {button. SwaHFiller new}) color: (self palette mid alpha: 0.8)).
			
	self addDependent: button.
	button addDependent: self.
	
	^ self zoomContent! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/27/2009 09:22'!
deleteButton
	^ deleteButton ! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 22:15'!
deleteButton: anObject
	deleteButton := anObject! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'mt 5/17/2010 15:13:56.898'!
deleteStory

	self model delete.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/30/2009 13:54'!
detailContentMorph

	^ self valueOfProperty: #XpfTaskDetails
	! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/30/2009 13:54'!
detailContentMorph: morphs

	^ self setProperty: #XpfTaskDetails toValue: morphs.	! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/30/2009 16:02'!
detailContentMorphs

	^ {self detailContentMorph}
	! !

!XpfUserStoryMorph methodsFor: 'private' stamp: 'mt 12/1/2009 19:46'!
detectAndShowOcclusions
	"If one card has the same model position like another, make the border thick."
	
	self showOcclusions ifFalse: [^ self].
	
	self model iteration userStories do: [:story |
		story id ~= self model id ifTrue: [
			story position = self model position
				ifTrue: [self cardMorph borderWidth: 5. ^ self]]].
		
	self cardMorph borderWidth: 1.! !

!XpfUserStoryMorph methodsFor: 'drawing' stamp: 'mt 5/21/2010 09:29:41.611'!
drawOn: aCanvas

	self drawShadowOn: aCanvas.
	super drawOn: aCanvas.! !

!XpfUserStoryMorph methodsFor: 'drawing' stamp: 'mt 5/18/2010 17:22:54.396'!
drawShadowOn: aCanvas

	card ifNotNil: [
		aCanvas
			fillRectangle: ((card bounds) translateBy: (-1@ -1))
			color: (self palette dark alpha: 0.5).

		aCanvas
			fillRectangle: ((card bounds) translateBy: (2@2))
			color: (self palette dark alpha: 0.5).
			
		aCanvas
			fillRectangle: ((card bounds) translateBy: (1@1))
			color: self palette dark.
			
			].! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'mt 10/29/2009 17:23'!
handleMouseOver: anEvent
	anEvent hand noticeMouseOver: self event: anEvent! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'bs 6/29/2009 18:09'!
handlesMouseOver: anEvent
	^ true.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'mt 10/7/2009 09:34'!
hasNewUserStory

	self flag: #obsolete.
	^ self model isKindOf: XpfNewUserStory! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 7/1/2009 20:14'!
hideHalos
	self actionHalosMorph hide.
	! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/27/2009 09:23'!
historyButton

	^ historyButton ! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 21:53'!
historyButton: anObject

	historyButton := anObject! !

!XpfUserStoryMorph methodsFor: 'initialization' stamp: 'mt 4/27/2010 20:00:27.594'!
initialize
		
	super initialize.
		
	self
		cellInset: 0;
		extent: (self class defaultWidth @ self class defaultHeight) + (20@20); "for halos"
		borderWidth: 0;
		color: Color transparent;
		updateColor.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'mt 5/21/2010 09:37:50.493'!
isDone

	^ self model notNil
		and: [self model tasks notEmpty]
		and: [self model tasks allSatisfy: [:task | task isDone]]! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'mt 10/7/2009 09:34'!
isNew

	^ self model isKindOf: XpfNewUserStory! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'topa 3/4/2009 00:21'!
isUserStoryMorph

	^ true! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'mt 5/18/2010 17:46:59.88'!
mouseEnter: anEvent

	"super mouseEnter: anEvent."

	self showsHalos
		ifFalse: [self showHalos].
		
	self showsDetails
		ifFalse: [self zoomContent show].
	
	"self ignoresColorMappings: true.
	self owner darkenThen: []."! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'mt 5/18/2010 17:47:03.368'!
mouseLeave: anEvent

	"super mouseLeave: anEvent."

	self showsHalos 
		ifTrue: [self hideHalos].
		
	self showsDetails 
		ifFalse: [self zoomContent hide].
		
	"self owner lightenThen: [self ignoresColorMappings: false]."! !

!XpfUserStoryMorph methodsFor: 'accessing-model' stamp: 'mt 11/13/2009 20:36'!
moveTo: anXpfIteration

	anXpfIteration addUserStory: self model.! !

!XpfUserStoryMorph methodsFor: 'private' stamp: 'mt 4/21/2010 09:36:28.123'!
openContextPopupMenu

	| menu colorMenu |
	colorMenu := MenuMorph new.
	#(red orange yellow green cyan blue magenta gray white) do: [:currentColor |
		colorMenu
			add: currentColor asString capitalized
			target: self model
			selector: #color:
			argument: currentColor asString].
		
	menu := MenuMorph entitled: 'User Story'.
	menu add: 'Edit color' subMenu: colorMenu.
	menu addLine.
	menu
		addLabel: 'Delete'
		target: self model
		selector: #delete
		enabled: true
		icon: #xpfDeleteIcon.
	
	menu popUpInWorld.
! !

!XpfUserStoryMorph methodsFor: 'colors' stamp: 'mt 5/18/2010 17:02:00.143'!
palette

	^ XpfStoryColorPalette! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 7/2/2009 11:39'!
progressBar
	^ progressBar! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 7/2/2009 11:39'!
progressBar: anObject
	^ progressBar := anObject! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 7/1/2009 20:15'!
showHalos
	self actionHalosMorph show.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/23/2009 21:56'!
showHistory

	self model repository changed: #showHistory with: self model.! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 19:46'!
showOcclusions

	^ showOcclusions ifNil: [false]! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 19:46'!
showOcclusions: anObject

	showOcclusions := anObject.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'topa 10/8/2009 14:53'!
showsDetails

	self detailContentMorph ifNil: [self createDetailContentMorph].
	
	^ self detailContentMorph visible! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'bs 7/1/2009 20:30'!
showsHalos
	^ self actionHalosMorph visible.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'topa 10/6/2009 18:46'!
switchToEditMode

	super switchToEditMode.
	self actionHalosMorph 
		addMorphBack: self cancelButton; 
		addMorphBack: self acceptButton.
! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'topa 10/6/2009 18:46'!
switchToViewMode

	super switchToViewMode.
	self actionHalosMorph 
		removeMorph: self cancelButton; 
		removeMorph: self acceptButton.
! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 19:47'!
toggleShowOcclusions

	self showOcclusions: self showOcclusions not.
	self detectAndShowOcclusions. "force update"! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 5/20/2010 08:27:21.501'!
update: aSymbol 

	super update: aSymbol.
	
	aSymbol = #color ifTrue: [ self updateColor ].
	aSymbol = #priority ifTrue: [self updatePosition.].
	aSymbol = #deleted ifTrue: [self fadeOutThen: [self delete]].
	aSymbol = #moved ifTrue: [
		self owner ifNil: [self fadeOutThen: [self delete]].
		self owner ifNotNilDo: [:morph |
			(morph isHandMorph or: [morph includesUserStory: self model])
				ifFalse: [self fadeOutThen: [self delete]]]].

	self updateProgressBar.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 5/18/2010 17:07:54.829'!
updateColor

	"card color: (Color colorFrom: self model color asSymbol) muchLighter."! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 4/28/2009 17:20'!
updateContentModel

	(self model isNil | self submorphs isNil) ifTrue: [^ self].
	self 
		allSubmorphsWith: [:m | m isEntityMorphContent not] 
		do: [:m | m isEntityMorphContent ifTrue: [
			(m isKindOf: XpfTasksContent)	
				ifTrue: [m model: self model tasks]
				ifFalse: [m model: self model]]].! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/8/2009 18:16'!
updateEstimation
	! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 5/20/2010 08:30:13.197'!
updateModelPriority: anInteger

	anInteger = self model priority
		ifTrue: [^ self].

	self model
		removeDependent: self;
		priority: anInteger;
		addDependent: self.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 5/20/2010 19:04:16.914'!
updatePosition
	"Consider the grid of the owner/iteration."

	self comeToFront.

	self owner ifNotNilDo: [:iterationMorph |
		iterationMorph isHandMorph ifTrue: [^ self].
		iterationMorph updateUserStoryPositions].! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:49'!
updateProgressBar

	self progressBar ifNotNil: [
		self progressBar value contents: self calculateProgressBarValue]! !

!XpfUserStoryMorph methodsFor: 'dropping/grabbing' stamp: 'topa 8/24/2009 13:02'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsUserStories! !

BorderedMorph subclass: #XpfHistoryEntryMorph
	instanceVariableNames: 'model entityTypeField timeField entityTitleField actionField detailField userField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-History'!

!XpfHistoryEntryMorph class methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 14:22'!
forEntry: anXpfHistoryEntryModel

	^ self basicNew
		model: anXpfHistoryEntryModel;
		initialize! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:35'!
actionField

	actionField ifNil: [
		self actionField:
			(self model entry action asMorph
			font: XpfFontProvider sansFont;
			emphasis: 1;
			hResizing: #rigid;
			width: 65;
			lock)].
	^ actionField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
actionField: anObject

	actionField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:35'!
detailField

	detailField ifNil: [
		self detailField:
			(self detailsText asMorph
			font: XpfFontProvider sansFont;
			hResizing: #spaceFill;
			autoFitOnOff;
			wrapFlag: false;
			lock)].
	^ detailField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
detailField: anObject

	detailField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/17/2009 17:09'!
detailsText

	self model entry action = #added ifTrue: [^ self detailsTextAdded].
	self model entry action = #changed ifTrue: [^ self detailsTextChanged].
	^ '' asText! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'mt 4/28/2009 16:58'!
detailsTextAdded

	^ self model new asText
		"addAttribute: TextEmphasis underlined;"
		append: ' to ';
		append: self model entry property capitalized asText allBold;
		yourself! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'mt 4/28/2009 16:56'!
detailsTextChanged

	| text oldValue newValue  |
	oldValue := '''{1}''' format: {self model old}.
	newValue := '''{1}''' format: {self model new}.
	
	text := (self model entry property) asText allBold.
	
	oldValue ifNotNil: [text
		append: ' from ';
		append: (oldValue asText addAttribute: TextEmphasis italic; yourself)].
	
	text
		append: ' to ';
		append: (newValue asText addAttribute: TextEmphasis italic; yourself);
		yourself.
	^ text! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/29/2009 11:37'!
entityTitleField

	entityTitleField ifNil: [self entityTitleField: 
		((XpfPluggableTextMorph
			on: self model entity
			getTextSelector: #title)
			"emphasis: 4(self model entity isDeleted ifTrue: [20] ifFalse: [4]);"
			hResizing: #rigid;
			isTruncatedWithEllipsis: true;
			width: 120;
			lock)].
	^ entityTitleField ! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
entityTitleField: anObject

	entityTitleField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:34'!
entityTypeField

	entityTypeField ifNil: [
		self entityTypeField:
			(self model entityType asString capitalized asMorph
			font: XpfFontProvider sansFont;
			color: Color darkGray;
			hResizing: #rigid;
			width: 70;
			lock)].
	^ entityTypeField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
entityTypeField: anObject

	entityTypeField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'initialization' stamp: 'cs 4/8/2009 11:54'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color white;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8;
		initializeFields.! !

!XpfHistoryEntryMorph methodsFor: 'initialization' stamp: 'cs 4/17/2009 16:41'!
initializeFields

	self addMorphBack: self timeField.
	self model entityType = #individual ifFalse: [
	self addMorphBack: self entityTypeField;
		  addMorphBack: self entityTitleField].
	self addMorphBack: self actionField;
		  addMorphBack: self detailField.
	self model entry user ifNotNil: [
	self addMorphBack: self userField].! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
model

	^ model! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
model: anObject

	model := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:34'!
timeField

	timeField ifNil: [
		self timeField:
			(self model entry timestamp printRelativeTimeStamp asMorph
			font: XpfFontProvider sansFont;
			emphasis: 2;
			hResizing: #rigid;
			width: 180;
			lock)].
	^ timeField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
timeField: anObject

	timeField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:35'!
userField

	userField ifNil: [
		self userField:
			(self userText asMorph
				font: XpfFontProvider sansFont;
				color: Color darkGray;
				hResizing: #rigid;
				width: 120;
				lock)].
	^ userField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:48'!
userField: anObject

	userField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'mt 4/22/2009 16:06'!
userText

	^ ('by {1} --' format: {self model entry user asString}) asText
		addAttribute: TextEmphasis underlined;
		yourself! !

BorderedMorph subclass: #XpfHistoryMorph
	instanceVariableNames: 'model table checkboxBar projectCheckbox userStoriesCheckbox tasksCheckbox individualCheckbox individualLabel client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-History'!

!XpfHistoryMorph class methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 11:03'!
forProject: anXpfProject

	^ self basicNew
		model: (XpfHistoryModel new project: anXpfProject);
		initialize! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:35'!
checkboxBar

	checkboxBar ifNil: [self checkboxBar:
		(UITheme current newRowIn: self for: {
			'Show history for: ' asMorph font: XpfFontProvider sansFont.
			self projectCheckbox.
			self userStoriesCheckbox.
			self tasksCheckbox.
			self individualCheckbox.
			self individualLabel})].
	
	^ checkboxBar! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:36'!
checkboxBar: anObject

	checkboxBar := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:19'!
client

	^ client! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:19'!
client: anObject

	client := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:29'!
individualCheckbox

	individualCheckbox ifNil: [self individualCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showIndividual
		setSelected: #showIndividual:
		getEnabled: #enableIndividual
		label: ''
		help: 'Check this box to see history details of a specific entity')].
	^ individualCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:06'!
individualCheckbox: anIndividualCheckbox

	individualCheckbox := anIndividualCheckbox.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 16:06'!
individualLabel

	individualLabel ifNil: [self individualLabel:
		((XpfPluggableTextMorph
			on: self model
			getTextSelector: #individualTitle)
			hResizing: #spaceFill;
			isTruncatedWithEllipsis: true;
			lock)].
	^ individualLabel! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:16'!
individualLabel: anObject

	individualLabel := anObject.! !

!XpfHistoryMorph methodsFor: 'initialization' stamp: 'cs 4/7/2009 11:39'!
initialize

	super initialize.
	self
		visible: false;
		disableTableLayout: true;
		height: 100;
		vResizing: #rigid;
		hResizing: #spaceFill;
		changeTableLayout;
		addMorph: self table;
		addMorph: self checkboxBar.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:11'!
model

	^ model! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:14'!
model: anObject

	self model ifNotNil: [self model removeDependent: self].
	model := anObject.
	self model ifNotNil: [self model addDependent: self].! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:35'!
projectCheckbox

	projectCheckbox ifNil: [self projectCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showProject
		setSelected: #showProject:
		getEnabled: #enableGlobal
		label: 'Project'  
		help: 'Check this box to see history details on project level')].
	projectCheckbox labelMorph font: XpfFontProvider sansFont.
	^ projectCheckbox
	  ! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
projectCheckbox: anObject

	projectCheckbox := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:51'!
table

	table ifNil: [self table:
		((UITheme current 
			newMorphListIn: self
			for: self model
			list: #entriesAsMorphs
			getSelected: nil
			setSelected: nil
			getEnabled: nil
			help: 'Shows the project history')
			height: 80;
			vResizing: #rigid;
			hResizing: #spaceFill)].
	^ table! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
table: anObject

	table := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:35'!
tasksCheckbox

	tasksCheckbox ifNil: [self tasksCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showTasks
		setSelected: #showTasks:
		getEnabled: #enableGlobal
		label: 'Tasks'
		help: 'Check this box to see history details on task level')].
	tasksCheckbox labelMorph font: XpfFontProvider sansFont.
	^ tasksCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:29'!
tasksCheckbox: anObject

	tasksCheckbox := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:22'!
update: aSymbol

	super update: aSymbol.
	(aSymbol = #showIndividual
		and: [self client notNil]
		and: [self visible not])
		ifTrue: [self client toggleHistory].! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:35'!
userStoriesCheckbox

	userStoriesCheckbox ifNil: [self userStoriesCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showUserStories
		setSelected: #showUserStories:
		getEnabled: #enableGlobal
		label: 'User Stories'  
		help: 'Check this box to see history details on User Story level')].
	userStoriesCheckbox labelMorph font: XpfFontProvider sansFont.
	^ userStoriesCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:29'!
userStoriesCheckbox: anObject

	userStoriesCheckbox := anObject.! !

BorderedMorph subclass: #XpfListEntryMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:21'!
defaultColor

	self subclassResponsibility! !

!XpfListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:34'!
for: aXpfObject

	^self new model: aXpfObject.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:22'!
createUserInterface

	self subclassResponsibility! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:40'!
delete

	self model ifNotNil: [self model removeDependent: self].
	super delete.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 12:35'!
initialize

	super initialize.
	self
		changeTableLayout;
		layoutInset: 0;
		cellInset: 0;
		borderWidth: XpfListWidget defaultBorderWidth;
		borderColor: (Color veryVeryLightGray alpha: 0.5);
		useRoundedCorners;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		color: self class defaultColor.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:07'!
model

	^model! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/21/2009 17:50'!
model: anXpfUserStory

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfUserStory.
	self model ifNotNil: [
		self 
			removeAllMorphs;
			createUserInterface.
		self model addDependent: self].! !

XpfListEntryMorph subclass: #XpfTaskListEntryMorph
	instanceVariableNames: 'actionsMorph titleContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfTaskListEntryMorph class methodsFor: 'contants' stamp: 'cs 5/13/2009 15:56'!
defaultColor

	^ XpfTaskMorph defaultColor! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:09'!
actionsMorph

	^ actionsMorph ifNil: [
		actionsMorph := XpfTaskWidgetActionsContent forModel: self model].! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:08'!
actionsMorph: anObject

	actionsMorph := anObject! !

!XpfTaskListEntryMorph methodsFor: 'initialization' stamp: 'mt 4/28/2010 22:11:23.718'!
createUserInterface

	self
		addMorph: ((SwaRowPanel for: {
			self titleContent.
			self actionsMorph})
				cellInset: 0;
				hResizing: #shrinkWrap);
		addMorphBack: ((XpfTaskDeveloperContent forModel: self model)
			hResizing: #rigid;
			extent: 160@10);
		addMorphBack: ((XpfTaskProgressContentForWidget withModel: self model)
			hResizing: #rigid;
			extent: 160@10);			
		updateStartedBorder.! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 11:52'!
model: myModel

	super model: myModel.
	self
		updateColor;
		updateStartedBorder.! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:47'!
titleContent

	titleContent ifNil: [self titleContent:
		(XpfTaskTitleContent forModel: self model)].
	^ titleContent! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:47'!
titleContent: anObject

	titleContent := anObject.! !

!XpfTaskListEntryMorph methodsFor: 'updating' stamp: 'mt 5/14/2009 13:44'!
update: aSymbol

	aSymbol = #isStarted ifTrue: [self updateStartedBorder].
	aSymbol = #isDone ifTrue: [self updateColor].
	
	(#(isDone responsibleDeveloper developers) includes: aSymbol)
		ifTrue: [self changed: #requestSorting].
	
	super update: aSymbol.! !

!XpfTaskListEntryMorph methodsFor: 'updating' stamp: 'cs 5/13/2009 15:56'!
updateColor

	self color:
		(self model isDone 
			ifTrue: [XpfTaskMorph defaultDoneColor]
			ifFalse: [XpfTaskMorph defaultColor]).! !

!XpfTaskListEntryMorph methodsFor: 'updating' stamp: 'SR 4/28/2009 18:38'!
updateStartedBorder

	self model isStarted 
		ifTrue: [
			self borderWidth: 2.
			self borderColor: Color red]
		ifFalse: [
			self borderWidth: 0.
			self borderColor: Color black].! !

XpfListEntryMorph subclass: #XpfUserStoryListEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfUserStoryListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'topa 4/21/2009 18:08'!
defaultColor

	^ Color lightYellow alpha: 0.85! !

!XpfUserStoryListEntryMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/23/2009 14:25'!
createUserInterface

	self
		addMorph: ((XpfUserStoryTitleContent forModel: self model) width: XpfListWidget defaultWidth);
		addMorphBack: (XpfUserStoryProgressEstimationSliderContent withModel: self model).! !

BorderedMorph subclass: #XpfNavigationPanel
	instanceVariableNames: 'model pagingArea pagingAreaScroller upButton downButton timeOfMouseDown timeOfLastScroll nextPageDirection currentScrollDelay scrollBarAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfNavigationPanel commentStamp: 'mt 4/23/2010 10:34:47.639' prior: 0!
I am responsible for a convenient navigation in the tape with two views.!

!XpfNavigationPanel class methodsFor: 'constants' stamp: 'mt 5/23/2010 09:31:25.51'!
defaultHeight

	^ 65! !

!XpfNavigationPanel class methodsFor: 'instance creation' stamp: 'mt 4/23/2010 10:53:19.916'!
for: anXpfProjectTape

	^ self basicNew
		model: anXpfProjectTape;
		initialize! !

!XpfNavigationPanel methodsFor: 'drawing' stamp: 'mt 5/20/2010 21:16:51.419'!
backgroundGradient

	^ self
		valueOfProperty: #backgroundGradient
		ifAbsentPut: [GradientFillStyle ramp: {
			0.0 -> self palette verydark.
			0.7 -> self palette middark.
			1.0 -> self palette dark}]! !

!XpfNavigationPanel methodsFor: 'scrolling' stamp: 'mt 5/21/2010 09:11:35.016'!
doScrollDown
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	
	pagingAreaScroller offset:
		(pagingAreaScroller offset - (20@0) max: (0@0)).! !

!XpfNavigationPanel methodsFor: 'scrolling' stamp: 'mt 5/21/2010 09:11:28.832'!
doScrollUp
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	
	pagingAreaScroller offset:
		(pagingAreaScroller offset + (20@0) min: ((pagingArea width - pagingAreaScroller width)@0)).! !

!XpfNavigationPanel methodsFor: 'accessing' stamp: 'mt 5/20/2010 21:35:18.882'!
downButton

	^ downButton ifNil: [
		downButton := Morph new
			extent: 20@ (self height - 10);
			color: self palette verydark;
			vResizing: #spaceFill;
			addMorphCentered: 
				(PolygonMorph
					vertices: {0@10. 10@20. 10@0}
					color: self palette base
					borderWidth: 0
					borderColor: Color transparent).
		downButton 
			on: #mouseDown
			send: #scrollDownInit
			to: self.
		downButton 
			on: #mouseUp
			send: #finishedScrolling
			to: self.
		downButton]! !

!XpfNavigationPanel methodsFor: 'geometry' stamp: 'mt 4/23/2010 11:08:21.404'!
extent: aPoint

	super extent: aPoint.
	self updateExtent.! !

!XpfNavigationPanel methodsFor: 'scrolling' stamp: 'mt 4/26/2010 17:30:12.097'!
finishedScrolling

	self stopStepping.
	self scrollBarAction: nil.! !

!XpfNavigationPanel methodsFor: 'events' stamp: 'mt 4/26/2010 17:45:21.308'!
handlesMouseDown: evt

	^ true! !

!XpfNavigationPanel methodsFor: 'events' stamp: 'mt 4/25/2010 14:24:21.183'!
handlesMouseWheel: evt

	^ true! !

!XpfNavigationPanel methodsFor: 'initialization' stamp: 'mt 4/26/2010 17:11:31.425'!
initialize

	super initialize.
	
	self
		color: Color red;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #rigid;
		height: self class defaultHeight;
		changeTableLayout;
		listDirection: #leftToRight.
		
	self
		initializeDownButton;
		initializePagingArea;
		initializeUpButton.! !

!XpfNavigationPanel methodsFor: 'initialization' stamp: 'mt 5/20/2010 21:23:30.581'!
initializeDownButton
	"initialize the receiver's downButton"

	self addMorphBack: self downButton.! !

!XpfNavigationPanel methodsFor: 'initialization' stamp: 'mt 5/23/2010 13:01:31.897'!
initializePagingArea

	pagingArea := XpfPagingAreaMorph new
		model: self;
		"extent: self totalSliderArea extent;"
		topLeft: 0@0;
		borderWidth: 0.
	pagingAreaScroller := (TransformMorph new
		"bounds: self bounds; totalSliderArea;"
		"on: #mouseDown send: #scrollToMousePosition: to: self;"
		addMorph: pagingArea;
		offset: 0@0;
		fillStyle: (self backgroundGradient
			origin: self topLeft;
			direction: (0 @ 50));
		hResizing: #rigid;
		vResizing: #spaceFill).

	self addMorphBack: pagingAreaScroller.! !

!XpfNavigationPanel methodsFor: 'initialization' stamp: 'mt 5/20/2010 21:23:46.391'!
initializeUpButton

	self addMorphBack: self upButton.! !

!XpfNavigationPanel methodsFor: 'model access' stamp: 'mt 4/23/2010 10:45:00.291'!
model
	
	^ model! !

!XpfNavigationPanel methodsFor: 'model access' stamp: 'mt 4/24/2010 12:29:13.333'!
model: anXpfProjectTape
	
	self model ifNotNilDo: [:m |
		m removeDependent: self].
	
	model := anXpfProjectTape.
	
	self model ifNotNilDo: [:m |
		m addDependent: self].! !

!XpfNavigationPanel methodsFor: 'events' stamp: 'mt 5/23/2010 12:27:05.648'!
mouseDown: event

! !

!XpfNavigationPanel methodsFor: 'events' stamp: 'mt 4/25/2010 14:28:17.318'!
mouseWheel: evt

	pagingArea leftSlider scrollbar model mouseWheel: evt.! !

!XpfNavigationPanel methodsFor: 'colors' stamp: 'mt 5/20/2010 21:17:07.646'!
palette

	^ XpfNavigationColorPalette! !

!XpfNavigationPanel methodsFor: 'scroll timing' stamp: 'mt 4/26/2010 17:28:40.78'!
resetTimer

	timeOfMouseDown := Time millisecondClockValue.
	timeOfLastScroll := timeOfMouseDown - 1000 max: 0.
	nextPageDirection := nil.
	currentScrollDelay := nil! !

!XpfNavigationPanel methodsFor: 'accessing' stamp: 'mt 4/26/2010 17:31:03.88'!
scrollBarAction
	^ scrollBarAction! !

!XpfNavigationPanel methodsFor: 'accessing' stamp: 'mt 4/26/2010 17:31:03.96'!
scrollBarAction: anObject
	scrollBarAction := anObject! !

!XpfNavigationPanel methodsFor: 'scrolling' stamp: 'mt 4/26/2010 17:27:39.714'!
scrollDownInit

	self resetTimer.
	self scrollBarAction: #doScrollDown.
	self startStepping.! !

!XpfNavigationPanel methodsFor: 'scrolling' stamp: 'mt 4/26/2010 17:55:33.949'!
scrollUpInit

	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping.! !

!XpfNavigationPanel methodsFor: 'initialization' stamp: 'mt 4/23/2010 11:58:18.676'!
setLeftScrollBar: anXpfBoundedScrollBar

	pagingArea leftSlider scrollbar: anXpfBoundedScrollBar.! !

!XpfNavigationPanel methodsFor: 'initialization' stamp: 'mt 4/23/2010 11:58:26.706'!
setRightScrollBar: anXpfBoundedScrollBar

	pagingArea rightSlider scrollbar: anXpfBoundedScrollBar.! !

!XpfNavigationPanel methodsFor: 'scrolling' stamp: 'mt 4/26/2010 17:28:07.503'!
step
	| action |
	action := self scrollBarAction.
	action ifNotNil:[self perform: action].! !

!XpfNavigationPanel methodsFor: 'scrolling' stamp: 'mt 4/26/2010 17:40:53.006'!
stepTime

	^ 50! !

!XpfNavigationPanel methodsFor: 'model access' stamp: 'mt 4/23/2010 10:58:28.108'!
tape

	^ self model! !

!XpfNavigationPanel methodsFor: 'accessing' stamp: 'mt 5/20/2010 21:35:59.294'!
upButton

	^ upButton ifNil: [
		upButton := Morph new
			extent: 20@ (self height - 10);
			color: self palette verydark;
			vResizing: #spaceFill;
			addMorphCentered: 
				(PolygonMorph
					vertices: {0@0. 10@10. 0@20}
					color: self palette base
					borderWidth: 0
					borderColor: Color transparent).
		upButton 
			on: #mouseDown
			send: #scrollUpInit
			to: self.
		upButton 
			on: #mouseUp
			send: #finishedScrolling
			to: self.
		upButton]! !

!XpfNavigationPanel methodsFor: 'updating' stamp: 'mt 4/24/2010 12:35:36.591'!
update: aSymbol

	self
		updateExtent;
		changed.! !

!XpfNavigationPanel methodsFor: 'updating' stamp: 'mt 4/24/2010 12:35:44.589'!
update: aSymbol with: someArgs

	self
		updateExtent;
		changed.! !

!XpfNavigationPanel methodsFor: 'geometry' stamp: 'mt 5/20/2010 21:27:17.113'!
updateExtent

	pagingArea ifNotNilDo: [:pa |
		pa extent:
			(self tape width * (self height - pa footerHeight / self tape height)) rounded
			@
			self height].
		.
	pagingAreaScroller ifNotNilDo: [:pas | pas width: self width - downButton width - upButton width].
	
	self downButton height: self height.
	self upButton height: self height.! !

!XpfNavigationPanel methodsFor: 'scroll timing' stamp: 'mt 4/26/2010 17:28:55.402'!
waitForDelay1: delay1 delay2: delay2 
	"Return true if an appropriate delay has passed since the last scroll operation.
	The delay decreases exponentially from delay1 to delay2."

	| now scrollDelay |
	timeOfLastScroll isNil ifTrue: [self resetTimer].	"Only needed for old instances"
	now := Time millisecondClockValue.
	(scrollDelay := currentScrollDelay) isNil 
		ifTrue: [scrollDelay := delay1	"initial delay"].
	currentScrollDelay := scrollDelay * 9 // 10 max: delay2.	"decrease the delay"
	timeOfLastScroll := now.
	^true! !

BorderedMorph subclass: #XpfWidget
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

XpfWidget subclass: #XpfDeveloperListWidget
	instanceVariableNames: 'shareButton devList devListModel serverTunnel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfDeveloperListWidget class methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 14:29'!
defaultHeight

	^ 250! !

!XpfDeveloperListWidget class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:37'!
defaultWidth

	^ 250! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'mt 5/5/2009 11:09'!
createVncServerTunnelToHub: hubPort
	
	serverTunnel := SSHTunnel new 
				isLocalTunnel: false; 
				localPort: 5900;
				remotePort: hubPort;
				server: self model repository url authority.
	serverTunnel execute.
	
	(0 to: 10) 
		do: [:ignore | (Delay forMilliseconds: 600) wait]
		displayingProgress: 'Giving SSH connection some time...'. ! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:21'!
destroyVncServerTunnelToHub
	
	serverTunnel ifNotNil: [
		serverTunnel terminate.
		serverTunnel := nil].! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'cs 5/5/2009 10:34'!
devList

	devList ifNil: [self devList: 
		((self theme newMorphListIn: self  
		for: self devListModel
		list: #developers
		getSelected: nil
		setSelected: nil
		getEnabled: nil 
		help: 'See online status and screen share availability of co-developers' )
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		layoutInset: 2)].
	^ devList! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:01'!
devList: anObject
	devList := anObject! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:50'!
devListModel

	devListModel ifNil: [devListModel := XpfDeveloperListModel new].
	^ devListModel! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:48'!
devListModel: anObject

	devListModel := anObject.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 17:56'!
doShareOrUnshare

	self isSharing ifTrue: [self unshare] ifFalse: [self share]! !

!XpfDeveloperListWidget methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 15:05'!
initializeUserInterface

	self
		addMorphBack: self devList;
		addMorphBack: self shareButton.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 17:48'!
isSharing

	^ RFBServer server isNil not! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:51'!
model: anXpfProject.

	super model: anXpfProject.
	self devListModel project: anXpfProject.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:18'!
registerHubPortForCurrentUser: hubPort
	
	| response userProxy |
	response := RestSocket get: self xpfServerUrl , '/info'.
	userProxy := (XpfProxyRepository fromString: self xpfServerUrl) getObject: response content.
	userProxy sharingPort: hubPort.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:14'!
requestAvailableHubPort

	| response |
	response := (RestSocket get: self xpfServerUrl, '/rfb').
	response isOk ifFalse: [self error: response content].
	^ response content asInteger.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'mt 5/5/2009 11:08'!
resetHubPortForCurrentUser

	self model repository currentUser sharingPort: nil.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:19'!
share
	
	| hubPort |
	hubPort := self requestAvailableHubPort.
	self createVncServerTunnelToHub: hubPort.
	RFBServer start: 0.
	self registerHubPortForCurrentUser: hubPort.
	self changed: #shareLabel.! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'bs 4/27/2009 17:06'!
shareButton

	shareButton ifNil: [self shareButton:
		(self theme
			newButtonIn: self
			for: self
			getState: nil
			action: #doShareOrUnshare
			arguments: nil
			getEnabled: nil
			getLabel: #shareLabel
			help: '')].
	^ shareButton! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:01'!
shareButton: anObject
	shareButton := anObject! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 17:48'!
shareLabel

	^ self isSharing
		ifFalse: ['Share']
		ifTrue: ['Unshare']! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:22'!
unshare
	
	| |

	self resetHubPortForCurrentUser.
	RFBServer stop.
	self destroyVncServerTunnelToHub.
	self changed: #shareLabel.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'mt 5/5/2009 11:07'!
xpfServerUrl

	^ self model repository url asString! !

XpfWidget subclass: #XpfListWidget
	instanceVariableNames: 'iterationList elementList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfListWidget class methodsFor: 'constants' stamp: 'SR 4/10/2009 19:25'!
elementListClass

	self subclassResponsibility! !

!XpfListWidget methodsFor: 'accessing' stamp: 'cs 4/14/2009 17:17'!
elementList

	elementList ifNil: [self elementList: self class elementListClass new].
	^ elementList! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:14'!
elementList: anObject

	elementList := anObject! !

!XpfListWidget methodsFor: 'initialization' stamp: 'mt 5/12/2009 17:24'!
initializeUserInterface

	self
		addMorphBack: self iterationList;
		addMorphBack: self seperator;
		addMorphBack: self elementList withScrollBars.! !

!XpfListWidget methodsFor: 'accessing' stamp: 'mt 5/2/2010 16:54:13.33'!
iterationList

	iterationList ifNil: [
		self iterationList: (SwaComboBox
			on: (XpfIterationListModel new project: self model)
			list: #list
			selected: #selectionIndex
			changeSelected: #selectionIndex:
			useIndex: true).
		self iterationList
			hResizing: #spaceFill;
			height: 20.
		self iterationList model addDependent: self.].
	^ iterationList! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:14'!
iterationList: anObject

	iterationList := anObject! !

!XpfListWidget methodsFor: 'accessing' stamp: 'mt 4/28/2010 22:09:23.996'!
model: aXpfProject

	super model: aXpfProject.
	self iterationList model project: self model.
	self model releases 
		ifNotEmpty: [self iterationList listSelectionIndex: 2]
		ifEmpty: [self iterationList listSelectionIndex: 1].

	self layoutChanged.! !

!XpfListWidget methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2010 21:49:56.835'!
seperator

	^ BorderedMorph new
		hResizing: #spaceFill;
		height: 2;
		color: self palette dark.! !

!XpfListWidget methodsFor: 'updating' stamp: 'cs 4/14/2009 17:29'!
update: aSymbol

	aSymbol = #selectionIndex ifTrue: [| newIteration |
		newIteration := self iterationList model iteration.
		self elementList model: newIteration].
	^ super update: aSymbol.! !

XpfListWidget subclass: #XpfTaskListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfTaskListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:01'!
elementListClass

	^ XpfTaskListMorph2! !

XpfListWidget subclass: #XpfUserStoryListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Widgets'!

!XpfUserStoryListWidget class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:30'!
defaultWidth 

	^ 200! !

!XpfUserStoryListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:56'!
elementListClass

	^ XpfUserStoryListMorph! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 4/27/2009 11:57'!
defaultBorderWidth

	^ 3! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 5/12/2009 17:56'!
defaultExtent

	^ self defaultWidth @ self defaultHeight! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 4/27/2009 14:29'!
defaultHeight

	^ 500! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 5/2/2010 17:10:23.624'!
defaultWidth 

	^ 200! !

!XpfWidget class methodsFor: 'instance creation' stamp: 'cs 5/27/2009 11:15'!
open
	
	[^ self openProject: XpfLoginProcessor new project]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfWidget class methodsFor: 'instance creation' stamp: 'mt 5/2/2010 17:05:17.98'!
openProject: project
		
	| instance |
	[#(model open) do: [:step |
		World displayWorldSafely.
		step = #model ifTrue: [instance := self new model: project].
		step = #open ifTrue: [instance openInHand; extent: self defaultExtent]] displayingProgress: 'Opening widget...'.

	^ instance]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfWidget methodsFor: 'as yet unclassified' stamp: 'cs 4/27/2009 17:09'!
delete

	self model ifNotNil: [self model repository stopUpdating].
	^ super delete! !

!XpfWidget methodsFor: 'initialization' stamp: 'mt 5/2/2010 17:04:54.145'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #rigid;
		listDirection: #topToBottom;
		borderWidth: 0;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.5);
		layoutInset: 5;
		cellInset: 5;
		useRoundedCorners;
		initializeUserInterface.! !

!XpfWidget methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 12:52'!
initializeUserInterface

	self subclassResponsibility.! !

!XpfWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 11:55'!
model

	^ model! !

!XpfWidget methodsFor: 'accessing' stamp: 'SR 4/28/2009 17:16'!
model: anObject

	self model ifNotNil: [self model removeDependent: self].
	model := anObject.
	anObject repository startUpdating.
	self model ifNotNil: [self model addDependent: self].! !

MorphicModel subclass: #XpfDraggableCardMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfDraggableCardMorph commentStamp: 'mt 9/11/2009 11:20' prior: 0!
This is just a draggable morph that has the dimensions of a user story card. It may become obsolete and is only for development issues. (grid)!

!XpfDraggableCardMorph methodsFor: 'model dummy' stamp: 'mt 12/1/2009 19:19'!
detectAndShowOcclusions! !

!XpfDraggableCardMorph methodsFor: 'event handling' stamp: 'mt 9/11/2009 11:04'!
handlesMouseDown: evt

	^ true! !

!XpfDraggableCardMorph methodsFor: 'initialization' stamp: 'mt 9/11/2009 15:09'!
initialize

	super initialize.
	self
		extent: XpfUserStoryMorph defaultWidth @ XpfUserStoryMorph defaultHeight;
		color: Color white;
		borderWidth: 1;
		borderColor: Color red;
		enableDragNDrop.! !

!XpfDraggableCardMorph methodsFor: 'model dummy' stamp: 'mt 10/7/2009 10:13'!
isNew

	^ false! !

!XpfDraggableCardMorph methodsFor: 'dropping/grabbing' stamp: 'mt 9/11/2009 11:09'!
isUserStoryMorph

	^ true! !

!XpfDraggableCardMorph methodsFor: 'model dummy' stamp: 'mt 4/8/2010 17:51:33.926'!
model

	^ model ifNil: [model := XpfUserStoryModel new position:
		{-5. -4. -3. -2. -1. 0. 1. 2. 3. 4} atRandom
		@
		5 atRandom]! !

!XpfDraggableCardMorph methodsFor: 'event handling' stamp: 'mt 9/11/2009 11:05'!
mouseDown: evt
	"Do nothing upon mouse-down except inform the hand to watch for a 
	double-click; wait until an ensuing click:, doubleClick:, or drag: 
	message gets dispatched"
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {nil. nil. nil. #startDrag:}
		threshold: 5.
	
	self comeToFront.! !

!XpfDraggableCardMorph methodsFor: 'model dummy' stamp: 'mt 10/30/2009 12:37'!
moveTo: aTarget

	"Ignored."! !

!XpfDraggableCardMorph methodsFor: 'dropping/grabbing' stamp: 'mt 9/11/2009 11:05'!
startDrag: evt

	evt redButtonPressed ifTrue: [
		evt hand grabMorph: self].! !

!XpfDraggableCardMorph methodsFor: 'model dummy' stamp: 'mt 11/1/2009 17:12'!
updateModelPosition

	self owner ifNotNilDo: [:iterationMorph |
		| cell |
		cell := iterationMorph gridMorph calculateCell: self topLeft.
		self model
			removeDependent: self;
			positionX: cell x;
			positionY: cell y;
			addDependent: self].! !

!XpfDraggableCardMorph methodsFor: 'dropping/grabbing' stamp: 'mt 9/11/2009 11:09'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsUserStories! !

MorphicModel subclass: #XpfTapeMorph
	instanceVariableNames: 'sortedSubmorphs name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfTapeMorph commentStamp: 'mt 10/4/2009 14:16' prior: 0!
I store several morphs and maintain their position. I should be embedded into a scroll pane that recognized my change requests.

Use "MorphicModel" as base class to provide basic model handling.!

XpfTapeMorph subclass: #XpfFixedEndTapeMorph
	instanceVariableNames: 'fixedEndMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfFixedEndTapeMorph commentStamp: 'mt 4/16/2010 14:52:39.466' prior: 0!
No matter which morphs you add to me, I will ensure that some special fixed morphs are appended at the end.!

!XpfFixedEndTapeMorph class methodsFor: 'constants' stamp: 'mt 4/16/2010 14:58:20.819'!
fixedEndClasses
	"Used to automatically create instances for the fixed end of the tape."

	^ {Morph}! !

!XpfFixedEndTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 4/24/2010 11:23:41.423'!
addMorphs: someMorphs.
	"OVERRIDE: Be sure that the fixed-end-morphs are the last elements."
	
	self fixedEndMorphs do: [:m |
		m removeDependent: self.
		self sortedSubmorphs
			remove: m
			ifAbsent: []].

	self
		expandToRight: self fixedEndMorphsWidth negated;
		changed: #resizedRight with: self fixedEndMorphsWidth negated.
	
	super addMorphs: someMorphs, self fixedEndMorphs.! !

!XpfFixedEndTapeMorph methodsFor: 'accessing' stamp: 'mt 4/16/2010 14:53:29.998'!
contentSubmorphs

	^ self sortedSubmorphs reject: [:m | self fixedEndMorphs includes: m]! !

!XpfFixedEndTapeMorph methodsFor: 'accessing' stamp: 'mt 4/16/2010 14:52:57.456'!
fixedEndMorphs

	^ fixedEndMorphs ifNil: [fixedEndMorphs := OrderedCollection new]! !

!XpfFixedEndTapeMorph methodsFor: 'accessing' stamp: 'mt 4/16/2010 14:54:19.531'!
fixedEndMorphsWidth

	^ self fixedEndMorphs
		inject: 0
		into: [:sum :each | sum + each width]! !

!XpfFixedEndTapeMorph methodsFor: 'initialization' stamp: 'mt 10/4/2009 14:01'!
initialize

	super initialize.	
	self
		color: Color transparent;
		initializeFixedEndMorph.! !

!XpfFixedEndTapeMorph methodsFor: 'initialization' stamp: 'mt 4/18/2010 16:44:18.922'!
initializeFixedEndMorph
	"This is a little bit tricky due to re-implementation of #addMorphs: here."

	self class fixedEndClasses do: [:c |
		self fixedEndMorphs add: c new].
	
	super addMorphs: self fixedEndMorphs.! !

!XpfFixedEndTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/8/2009 11:01'!
removeAllSubmorphs
	"Overridden to ignore the fixed-end-morph."

	self removeMorphs: self contentSubmorphs.! !

XpfFixedEndTapeMorph subclass: #XpfProjectTapeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfProjectTapeMorph class methodsFor: 'examples' stamp: 'mt 10/4/2009 15:14'!
exampleTape
	"Create an example tape and put it in a scrollable area."
	
	^ (self new
		addMorphs: {
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape})! !

!XpfProjectTapeMorph class methodsFor: 'constants' stamp: 'mt 4/16/2010 14:59:14.86'!
fixedEndClasses

	^ {XpfOpenStoriesMorph}! !

!XpfProjectTapeMorph methodsFor: 'accessing-model' stamp: 'mt 4/16/2010 14:30:42.405'!
addNewRelease: aTitleString

	^ self project addNewRelease: (Dictionary newFrom: {'title' -> aTitleString})! !

!XpfProjectTapeMorph methodsFor: 'actions' stamp: 'mt 4/16/2010 14:44:35.203'!
addReleaseTapeMorph: anXpfRelease

	self
		showMessage: 'Release added.';
		addMorph: (XpfReleaseTapeMorph new model: anXpfRelease).! !

!XpfProjectTapeMorph methodsFor: 'actions' stamp: 'mt 4/16/2010 14:33:12.825'!
createRelease

	(SwaInputDialog
		getTextWithTitle: 'New Release'
		label: 'Enter a name for the release:'
		value: '(unnamed release)')
			ifNotNilDo: [:title | self addNewRelease: title]	! !

!XpfProjectTapeMorph methodsFor: 'drawing' stamp: 'mt 5/20/2010 20:36:17.288'!
drawSeparatorOn: aCanvas shift: shift boundingBox: bb

	aCanvas
		line: (bb left + shift) @ bb top
		to: (bb left + shift) @ (bb bottom - XpfPagingAreaMorph defaultFooterHeight)
		color: XpfIterationColorPalette verydark.! !

!XpfProjectTapeMorph methodsFor: 'drawing' stamp: 'mt 5/21/2010 16:33:02.26'!
drawSeparatorWithHighlightOn: aCanvas shift: shift boundingBox: bb

	aCanvas
		line: (bb left + shift) @ bb top
		to: (bb left + shift) @ (bb bottom - XpfPagingAreaMorph defaultFooterHeight)
		color: XpfIterationColorPalette dark.! !

!XpfProjectTapeMorph methodsFor: 'accessing-model' stamp: 'mt 4/16/2010 14:40:08.39'!
model: anXpfProject

	self model ifNotNilDo: [:mod |
		mod removeDependent: self.
		mod releases removeDependent: self].

	model := anXpfProject.
		
	self model ifNotNilDo: [:mod |		
		mod addDependent: self.
		mod releases addDependent: self].
	
	self processModel.! !

!XpfProjectTapeMorph methodsFor: 'accessing' stamp: 'mt 4/16/2010 14:59:29.93'!
openStoriesMorph

	^ self fixedEndMorphs first! !

!XpfProjectTapeMorph methodsFor: 'printing' stamp: 'mt 4/18/2010 16:22:20.563'!
printString

	^ 'XpfProjectTapeMorph ({1})' format: {self project printString}! !

!XpfProjectTapeMorph methodsFor: 'accessing-model' stamp: 'mt 5/24/2010 15:22:29.827'!
processModel

	super processModel.

	XpfSplashScreen appendMessage: 'Open stories...'.
	
	(self openStoriesMorph)
		model: self project futureIteration;
		fitToSubmorphs.
	
	XpfSplashScreen appendMessage: 'Releases...'.

	self addMorphs:
		(self project releases collect: [:release |
			XpfReleaseTapeMorph new model: release]).! !

!XpfProjectTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/8/2009 10:06'!
project

	^ self model! !

!XpfProjectTapeMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:09'!
toggleShowGrid
	"Toggle the visibility of all grids in all iteration morphs in this project tape."
	
	self openStoriesMorph gridMorph toggleShowGrid.
	self contentSubmorphs do: [:releaseMorph |
		releaseMorph contentSubmorphs do: [:iterationMorph |
			iterationMorph gridMorph toggleShowGrid]]! !

!XpfProjectTapeMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:23'!
toggleShowHoverEffect
	"Toggle the hover effect of all grids in all iteration morphs in this project tape."
	
	self openStoriesMorph gridMorph toggleShowHoverEffect.
	self contentSubmorphs do: [:releaseMorph |
		releaseMorph contentSubmorphs do: [:iterationMorph |
			iterationMorph gridMorph toggleShowHoverEffect]]! !

!XpfProjectTapeMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 19:49'!
toggleShowOcclusions
	"Toggle the visualization of occluded cards in all iteration morphs in this project tape."
	
	self openStoriesMorph userStoryMorphs do: [:us |
		us toggleShowOcclusions].
	self contentSubmorphs do: [:releaseMorph |
		releaseMorph contentSubmorphs do: [:iterationMorph |
			iterationMorph userStoryMorphs do: [:us |
				us toggleShowOcclusions]]]! !

!XpfProjectTapeMorph methodsFor: 'accessing' stamp: 'mt 12/1/2009 16:16'!
toggleSmoothMoving
	"Toggle the smooth moving in all grids in all iteration morphs in this project tape."
	
	self openStoriesMorph gridMorph toggleSmoothMoving.
	self contentSubmorphs do: [:releaseMorph |
		releaseMorph contentSubmorphs do: [:iterationMorph |
			iterationMorph gridMorph toggleSmoothMoving]]! !

!XpfProjectTapeMorph methodsFor: 'updating' stamp: 'mt 4/16/2010 14:34:22.859'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.

	aSymbol = #releasesAdded ifTrue: [self addReleaseTapeMorph: anObject].! !

XpfFixedEndTapeMorph subclass: #XpfReleaseTapeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfReleaseTapeMorph commentStamp: 'mt 10/4/2009 14:05' prior: 0!
I am a tape that stores a release separator morph with some controls as fixed morph at the end.!

!XpfReleaseTapeMorph class methodsFor: 'examples' stamp: 'mt 8/27/2009 19:50'!
exampleTape
	"Create an example tape and put it in a scrollable area."
	
	^ self new
		addMorphs: {
			XpfIterationMorph exampleIteration.
			XpfIterationMorph exampleIteration.
			XpfIterationMorph exampleIteration.
			XpfIterationMorph exampleIteration}! !

!XpfReleaseTapeMorph class methodsFor: 'constants' stamp: 'mt 4/16/2010 14:59:51.013'!
fixedEndClasses
	
	^ {
		XpfOpenStoriesMorph.
		XpfReleaseSeparatorMorph
	}! !

!XpfReleaseTapeMorph methodsFor: 'actions' stamp: 'mt 10/29/2009 10:40'!
addIterationMorph: anXpfIteration

	self
		showMessage: 'Iteration added.';
		addMorph: (XpfIterationMorph new model: anXpfIteration).! !

!XpfReleaseTapeMorph methodsFor: 'accessing-model' stamp: 'mt 4/15/2010 15:17:04.603'!
addNewIteration: aTitleString

	^ self theRelease addNewIteration: (Dictionary newFrom: {'title' -> aTitleString})! !

!XpfReleaseTapeMorph methodsFor: 'actions' stamp: 'mt 4/15/2010 15:17:45.466'!
createIteration

	self theRelease ifNil: [^ self addMorph: XpfIterationMorph new].

	(FillInTheBlankMorph
		request: 'Choose a name for the iteration:'
		initialAnswer: '(unnamed)')
			ifNotNilDo: [:title | self addNewIteration: title]	! !

!XpfReleaseTapeMorph methodsFor: 'drawing' stamp: 'mt 5/20/2010 20:36:29.484'!
drawSeparatorOn: aCanvas shift: shift boundingBox: bb

	aCanvas
		line: (bb left + shift) @ bb top
		to: (bb left + shift) @ (bb bottom - XpfPagingAreaMorph defaultFooterHeight)
		color: XpfIterationColorPalette verydark.
! !

!XpfReleaseTapeMorph methodsFor: 'drawing' stamp: 'mt 5/21/2010 16:32:18.882'!
drawSeparatorWithHighlightOn: aCanvas shift: shift boundingBox: bb

	aCanvas
		line: (bb left + shift) @ bb top
		to: (bb left + shift) @ (bb bottom - XpfPagingAreaMorph defaultFooterHeight)
		color: XpfIterationColorPalette dark.
! !

!XpfReleaseTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/28/2009 17:42'!
model: anXpfRelease

	self model ifNotNilDo: [:mod |
		mod removeDependent: self.
		mod iterations removeDependent: self].

	model := anXpfRelease.
		
	self model ifNotNilDo: [:mod |		
		mod addDependent: self.
		mod iterations addDependent: self].
	
	self processModel.! !

!XpfReleaseTapeMorph methodsFor: 'accessing' stamp: 'mt 4/16/2010 15:00:06.426'!
openStoriesMorph

	^ self fixedEndMorphs first! !

!XpfReleaseTapeMorph methodsFor: 'printing' stamp: 'mt 4/18/2010 16:22:36.535'!
printString

	^ 'XpfReleaseTapeMorph ({1})' format: {self theRelease printString}! !

!XpfReleaseTapeMorph methodsFor: 'accessing-model' stamp: 'mt 4/24/2010 11:53:00.514'!
processModel

	super processModel.
	
	XpfSplashScreen appendMessage: 'Iterations...'.

	(self openStoriesMorph)
		model: self theRelease iterations last;
		fitToSubmorphs.

	self addMorphs:
		(self theRelease iterations allButLast collect: [:iteration |
			XpfIterationMorph new model: iteration]).! !

!XpfReleaseTapeMorph methodsFor: 'accessing' stamp: 'mt 4/18/2010 16:12:31.467'!
releaseSeparator

	^ self fixedEndMorphs second! !

!XpfReleaseTapeMorph methodsFor: 'accessing-model' stamp: 'mt 4/15/2010 15:16:55.596'!
theRelease

	^ self model! !

!XpfReleaseTapeMorph methodsFor: 'updating' stamp: 'mt 10/28/2009 18:33'!
update: aSymbol

	super update: aSymbol.

	aSymbol = #newIterationRequested ifTrue: [
		self createIteration].! !

!XpfReleaseTapeMorph methodsFor: 'updating' stamp: 'mt 10/29/2009 10:33'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.

	aSymbol = #iterationsAdded ifTrue: [self addIterationMorph: anObject].! !

!XpfTapeMorph class methodsFor: 'examples' stamp: 'mt 9/2/2009 14:42'!
exampleTape
	"Create an example tape and put it in a scrollable area."
	
	^ (self new
		addMorphs: {
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape.
			XpfReleaseTapeMorph exampleTape})! !

!XpfTapeMorph class methodsFor: 'constants' stamp: 'mt 9/29/2009 10:24'!
tapeHeight

	^ (XpfUserStoryMorph defaultHeight + XpfUserStoryGridMorph defaultVSpacing) * 5! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2009 14:43'!
addMorph: aMorph
	"Hint: If you want to add more than one morph at a time, see #addMorphs:."
	
	self addMorphs: {aMorph}.! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2009 15:27'!
addMorphSilent: aMorph

	super addMorph: aMorph.! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 9/29/2009 16:12'!
addMorphs: someMorphs
	"Keep all submorphs in a sorted list. This is important for their visual appearance."
	
	| additionalWidth |
	self sortedSubmorphs addAll: someMorphs.
	
	additionalWidth := 0.
	someMorphs do: [:m |
		m height: self height.
		m addDependent: self.
		super addMorph: m.
		additionalWidth := additionalWidth + m width].

	self
		expandToRight: additionalWidth;
		updatePositions;
		changed: #resizedRight with: additionalWidth.! !

!XpfTapeMorph methodsFor: 'drawing' stamp: 'mt 5/21/2010 17:12:02.733'!
drawScaledOn: aCanvas factor: aFactor boundingBox: bb

	| shift |
	(aCanvas isVisible: bb) ifFalse: [^ self].
	
	shift := 0.
	self sortedSubmorphsForScaling do: [:morph | |newShift|
		newShift := shift + (morph width * aFactor).
		morph
			drawScaledOn: aCanvas
			factor: aFactor
			boundingBox: ((bb topLeft + (shift@0)) corner: (bb topLeft + (newShift @ bb height))).
		shift := newShift]
	separatedBy: [
		self drawSeparatorOn: aCanvas shift: shift boundingBox: bb].! !

!XpfTapeMorph methodsFor: 'drawing' stamp: 'mt 5/21/2010 17:12:11.597'!
drawScaledWithHighlightOn: aCanvas factor: aFactor boundingBox: bb

	| shift |
	(aCanvas isVisible: bb) ifFalse: [^ self].
	
	shift := 0.
	self sortedSubmorphsForScaling do: [:morph | |newShift|
		newShift := shift + (morph width * aFactor).
		morph
			drawScaledWithHighlightOn: aCanvas
			factor: aFactor
			boundingBox: ((bb topLeft + (shift@0)) corner: (bb topLeft + (newShift @ bb height))).
		shift := newShift]
	separatedBy: [
		self drawSeparatorWithHighlightOn: aCanvas shift: shift boundingBox: bb].! !

!XpfTapeMorph methodsFor: 'drawing' stamp: 'mt 9/17/2009 11:01'!
drawSeparatorOn: aCanvas shift: shift boundingBox: bb

	aCanvas
		line: (bb left + shift) @ bb top
		to: (bb left + shift) @ bb bottom
		color: self palette dark! !

!XpfTapeMorph methodsFor: 'drawing' stamp: 'mt 5/21/2010 16:32:44.776'!
drawSeparatorWithHighlightOn: aCanvas shift: shift boundingBox: bb

	self
		drawSeparatorOn: aCanvas
		shift: shift
		boundingBox: bb.! !

!XpfTapeMorph methodsFor: 'geometry' stamp: 'mt 4/25/2010 20:52:49.795'!
height: anInteger

	super height: anInteger.
	
	self submorphs do: [:s | s height: anInteger].! !

!XpfTapeMorph methodsFor: 'initialization' stamp: 'mt 10/29/2009 10:42'!
initialize

	super initialize.
	
	self
		color: self palette verydark;
		height: XpfTapeMorph tapeHeight;
		borderWidth: 0;
		width: 0.! !

!XpfTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/4/2009 14:17'!
model
	"Override to avoid creating custom models on demand."
	
	^ model! !

!XpfTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/8/2009 09:47'!
model: aModel

	self model ifNotNilDo: [:mod | mod removeDependent: self].
	model := aModel.
	self model ifNotNilDo: [:mod | mod addDependent: self. self processModel].! !

!XpfTapeMorph methodsFor: 'accessing' stamp: 'mt 10/26/2009 14:39'!
name
	"^ <String>"
	
	^ name ifNil: ['unnamed']! !

!XpfTapeMorph methodsFor: 'accessing' stamp: 'mt 10/26/2009 14:36'!
name: aString
	
	name := aString! !

!XpfTapeMorph methodsFor: 'printing' stamp: 'mt 4/18/2010 16:21:49.416'!
printString

	^ 'XpfTapeMorph ({1})' format: {self model printString}! !

!XpfTapeMorph methodsFor: 'accessing-model' stamp: 'mt 10/8/2009 10:33'!
processModel
	"Used to read model data, create morphs a.s.o. - Called once after setting the model."

	self removeAllSubmorphs.! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/8/2009 11:00'!
removeAllSubmorphs

	self removeMorphs: self sortedSubmorphs.! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/8/2009 10:59'!
removeMorph: aMorph

	self removeMorphs: {aMorph}.! !

!XpfTapeMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 10/28/2009 18:37'!
removeMorphs: someMorphs

	| w |
	w := 0.
	someMorphs do: [:m |
		w := w + m width.
		m removeDependent: self.
		self sortedSubmorphs
			remove: m
			ifAbsent: [w := w - m width].
		super removeMorph: m].
	self
		expandToRight: w negated;
		updatePositions;
		changed: #resizedRight with: w negated.! !

!XpfTapeMorph methodsFor: 'actions' stamp: 'mt 10/29/2009 19:13'!
showMessage: aString

	XpfOverlayMessage showAtAllHands: aString.! !

!XpfTapeMorph methodsFor: 'accessing' stamp: 'mt 8/20/2009 14:13'!
sortedSubmorphs

	sortedSubmorphs ifNil: [sortedSubmorphs := OrderedCollection new].
	^ sortedSubmorphs! !

!XpfTapeMorph methodsFor: 'drawing' stamp: 'topa 8/31/2009 14:41'!
sortedSubmorphsForScaling

	^ self sortedSubmorphs! !

!XpfTapeMorph methodsFor: 'updating' stamp: 'mt 4/24/2010 11:09:22.441'!
update: aSymbol
	
	aSymbol = #resized ifTrue: [
		self
			updatePositions;
			bounds: self submorphBounds;
			"expandToRight: -32;"
			changed: #resized. "to be recursive"].! !

!XpfTapeMorph methodsFor: 'updating' stamp: 'mt 9/29/2009 16:34'!
update: aSymbol with: aNumber
	"React to size change requests due to size grip activities."
	
	aSymbol = #resized ifTrue: [^ self].
	aSymbol = #resizedLeft ifTrue: [
		self expandToLeft: aNumber.
		self left: self left + aNumber.
		self
			changed: #resized
			with: aNumber].
	aSymbol = #resizedRight ifTrue: [
		self expandToRight: aNumber.
		self
			changed: #resized
			with: 0].
	
	self
		updatePositions;
		changed: aSymbol with: aNumber. "to be recursive"! !

!XpfTapeMorph methodsFor: 'updating' stamp: 'mt 4/19/2010 20:11:04.457'!
updatePositions
	"Change the positions of all submorphs to appear from left to right without spacing."
	
	| shift |
	shift := 0.
	
	self sortedSubmorphs do: [:m |
		m position: self position + (shift@0).
		shift := shift + m width].! !

!XpfTapeMorph methodsFor: 'initialization' stamp: 'mt 4/19/2010 17:26:11.345'!
withScrollBar

	self width = 0
		ifTrue: [Error signal: 'Tape width must not be zero to create scroller!!'].
		
	self topLeft: 0@0.
		
	^ XpfTapeScroller new
		scrollTarget: self! !

TextMorph subclass: #XpfOverlayMessage
	instanceVariableNames: 'hand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Animations'!

!XpfOverlayMessage class methodsFor: 'as yet unclassified' stamp: 'mt 5/23/2010 09:41:30.601'!
contents: aString

	^ self new
		contents: aString;
		textColor: Color white! !

!XpfOverlayMessage class methodsFor: 'as yet unclassified' stamp: 'mt 10/29/2009 10:18'!
show: aString at: aPoint

	(self contents: aString)
		position: aPoint;
		openInWorld;
		disappear.! !

!XpfOverlayMessage class methodsFor: 'as yet unclassified' stamp: 'topa 1/1/2010 20:18'!
show: aString atHand: aHand

	(self contents: aString)
		topLeft: aHand topLeft + (16 @ 0);
		hand: aHand;
		openInWorld;
		disappear.! !

!XpfOverlayMessage class methodsFor: 'as yet unclassified' stamp: 'topa 1/1/2010 20:19'!
showAtAllHands: aString

	World hands do: [:hand |
		hand submorphs do: [:m | (m isKindOf: XpfOverlayMessage)
			ifTrue: [m delete]].
		self show: aString atHand: hand].! !

!XpfOverlayMessage methodsFor: 'animation' stamp: 'mt 6/7/2010 15:25:32.329'!
disappear

	(AnimPropertyAnimation
		on: self
		property: #topLeft
		start: 0@0
		end: 0@25
		duration: 1000)
		finishBlock: [self delete];
		offsetBlock: [self hand topLeft + (16@0)];
		register;
		start: #deleteWhenFinished.
		
	(AnimAlphaBlendAnimation
		fadeOutOn: self
		duration: 1000)
		register;
		start: #deleteWhenFinished.! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 10/29/2009 10:24'!
hand

	^ hand! !

!XpfOverlayMessage methodsFor: 'accessing' stamp: 'mt 5/17/2010 17:14:47.579'!
hand: aHand

	hand := aHand.
	aHand addMorph: self.! !

RectangleMorph subclass: #XpfNavigationSlider
	instanceVariableNames: 'scrollbar pagingArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfNavigationSlider methodsFor: 'accessing' stamp: 'mt 5/20/2010 20:15:39.053'!
currentScaleFactor

	self scrollbar viewportHeight = 0
		ifTrue: [^ 1.0].
		
	^ self pagingArea height - self pagingArea footerHeight / self scrollbar viewportHeight! !

!XpfNavigationSlider methodsFor: 'drawing' stamp: 'mt 5/21/2010 16:49:10.618'!
drawOn: aCanvas

	self pagingArea ifNil: [^ super drawOn: aCanvas].

	aCanvas
		clipBy: self bounds
		during: [:canvas |
			self pagingArea
				drawHighlightedOn: canvas].
			
	self isLeft ifTrue: [
		aCanvas
			line: self topRight - (2@0)
			to: self bottomRight - (2@0)
			color: (XpfSplitterColorPalette light).
			
		aCanvas
			line: self topRight - (1@0)
			to: self bottomRight - (1@0)
			color: (XpfSplitterColorPalette base).
		].
	self isRight ifTrue: [
		aCanvas
			line: self topLeft
			to: self bottomLeft
			color: (XpfSplitterColorPalette light).
			
		aCanvas
			line: self topLeft + (1@0)
			to: self bottomLeft + (1@0)
			color: (XpfSplitterColorPalette base).].! !

!XpfNavigationSlider methodsFor: 'events' stamp: 'mt 4/25/2010 18:49:41.749'!
handlesMouseDown: evt

	^ true! !

!XpfNavigationSlider methodsFor: 'initialization' stamp: 'mt 5/20/2010 21:18:57.322'!
initialize

	super initialize.
	self
		color: (Color white alpha: 0.3);
		borderWidth: 0.! !

!XpfNavigationSlider methodsFor: 'testing' stamp: 'mt 5/21/2010 16:44:01.996'!
isLeft

	^ self pagingArea notNil and: [self pagingArea leftSlider = self]! !

!XpfNavigationSlider methodsFor: 'testing' stamp: 'mt 5/21/2010 16:43:55.461'!
isRight

	^ self pagingArea notNil and: [self pagingArea rightSlider = self]! !

!XpfNavigationSlider methodsFor: 'accessing' stamp: 'mt 4/23/2010 12:02:38.966'!
pagingArea
	^ pagingArea! !

!XpfNavigationSlider methodsFor: 'accessing' stamp: 'mt 4/23/2010 12:02:39.046'!
pagingArea: anObject
	pagingArea := anObject! !

!XpfNavigationSlider methodsFor: 'events' stamp: 'mt 4/26/2010 17:14:34.3'!
scrollAbsolute: event

	| r p |
	r := self pagingArea bounds insetBy: (0@0 extent: self extent).
	r width = 0 ifTrue: [^ self].

	p := (event targetPoint "+ self scroller transform offset") adhereTo: r.

	self scrollbar setValue:
		(p x - r left) asFloat / r width.! !

!XpfNavigationSlider methodsFor: 'accessing' stamp: 'mt 4/23/2010 11:58:01.976'!
scrollbar
	^ scrollbar! !

!XpfNavigationSlider methodsFor: 'accessing' stamp: 'mt 4/25/2010 18:48:59.723'!
scrollbar: anObject

	self scrollbar ifNotNilDo: [:s |
		s removeDependent: self].

	scrollbar := anObject.
	
	self scrollbar ifNotNilDo: [:s |
		s addDependent: self.
		
		self on: #mouseMove send: #scrollAbsolute: to: self.
"		self on: #mouseDown send: #mouseDownInSlider: to: s.
		self on: #mouseUp send: #mouseUpInSlider: to: s"].! !

!XpfNavigationSlider methodsFor: 'accessing' stamp: 'mt 4/25/2010 19:42:46.511'!
scroller

	^ self pagingArea owner! !

!XpfNavigationSlider methodsFor: 'updating' stamp: 'mt 4/23/2010 12:24:58.129'!
update

	self
		updateExtent;
		updatePosition.! !

!XpfNavigationSlider methodsFor: 'updating' stamp: 'mt 4/23/2010 12:25:04.059'!
update: aSymbol

	super update: aSymbol.

	aSymbol = #value ifTrue: [self update].! !

!XpfNavigationSlider methodsFor: 'updating' stamp: 'mt 5/20/2010 20:15:55.695'!
updateExtent

	self scrollbar ifNil: [^ self].
	
	self extent:
		(self scrollbar viewportWidth * self currentScaleFactor) rounded
		@
		(self pagingArea height - self pagingArea footerHeight).! !

!XpfNavigationSlider methodsFor: 'updating' stamp: 'mt 5/19/2010 10:34:54.103'!
updatePosition

	self scrollbar ifNil: [^ self].

	self left:
		self scrollbar viewportRect left * self currentScaleFactor.! !

SwaGeneralScrollBar subclass: #XpfBoundedScrollBar
	instanceVariableNames: 'boundingScrollBar ignore side'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-TapeGUI'!

!XpfBoundedScrollBar methodsFor: 'model access' stamp: 'mt 4/22/2010 17:35:28.315'!
absoluteDelta: relativeDelta

	^ relativeDelta * (self model scroller submorphs first width - self viewportWidth)! !

!XpfBoundedScrollBar methodsFor: 'model access' stamp: 'mt 4/23/2010 12:31:03.255'!
adjustValue: aDeltaValue

	super setValue: self value + aDeltaValue.
	self changed: #value.! !

!XpfBoundedScrollBar methodsFor: 'accessing' stamp: 'mt 4/21/2010 09:55:35.731'!
boundingScrollBar
	^ boundingScrollBar! !

!XpfBoundedScrollBar methodsFor: 'accessing' stamp: 'mt 4/21/2010 10:29:13.784'!
boundingScrollBar: anXpfBoundedScrollBar

	self boundingScrollBar ifNotNilDo: [:s |
		s removeDependent: self].

	boundingScrollBar := anXpfBoundedScrollBar.
	
	self boundingScrollBar ifNotNilDo: [:s |
		s addDependent: self].! !

!XpfBoundedScrollBar methodsFor: 'private' stamp: 'mt 4/21/2010 11:24:42.703'!
ignore

	^ ignore ifNil: [ignore := false]! !

!XpfBoundedScrollBar methodsFor: 'private' stamp: 'mt 4/21/2010 11:24:53.766'!
ignore: aBoolean

	ignore := aBoolean.! !

!XpfBoundedScrollBar methodsFor: 'testing' stamp: 'mt 5/25/2010 17:00:11.975'!
isLeft

	^ self side = #left! !

!XpfBoundedScrollBar methodsFor: 'testing' stamp: 'mt 5/25/2010 17:00:19.709'!
isRight

	^ self side = #right! !

!XpfBoundedScrollBar methodsFor: 'model access' stamp: 'mt 4/22/2010 17:35:39.375'!
relativeDelta: absoluteDelta

	^ absoluteDelta / (self model scroller submorphs first width - self viewportWidth)! !

!XpfBoundedScrollBar methodsFor: 'model access' stamp: 'mt 4/23/2010 12:11:06.63'!
setValue: aValue

	self side = #left
		ifTrue: [self setValueLeft: aValue. self changed: #value. ^ self].

	self side = #right
		ifTrue: [self setValueRight: aValue. self changed: #value. ^ self].

	^ super setValue: aValue! !

!XpfBoundedScrollBar methodsFor: 'model access' stamp: 'mt 4/22/2010 18:39:58.856'!
setValueLeft: aValue

	| delta deltaAbs spaceLeft |
	delta := aValue - self value.
	
	delta <= 0
		ifTrue: [^ super setValue: aValue].
	
	spaceLeft := self boundingScrollBar viewportRect left - self viewportRect right .
	deltaAbs := self absoluteDelta: delta.
	
	spaceLeft > 0.001 "avoid rounding errors"
		ifTrue: [
			spaceLeft <= deltaAbs "snap"
				ifTrue: [^ super setValue: (self relativeDelta: spaceLeft) + self value]
				ifFalse: [^ super setValue: aValue]].

	self boundingScrollBar value = 1.0 "at the end"
		ifTrue: [^ self].
	
	self boundingScrollBar adjustValue:
		(self boundingScrollBar relativeDelta: deltaAbs).
		
	self boundingScrollBar value = 1.0 "at the end"
		ifTrue: [
			spaceLeft := self boundingScrollBar viewportRect left - self viewportRect right.
			^ super setValue: (self relativeDelta: spaceLeft) + self value].
		
	^ super setValue: aValue! !

!XpfBoundedScrollBar methodsFor: 'model access' stamp: 'mt 4/22/2010 18:40:39.386'!
setValueRight: aValue

	| delta deltaAbs spaceLeft |
	delta := aValue - self value.
	
	delta >= 0
		ifTrue: [^ super setValue: aValue].
	
	spaceLeft := self viewportRect left - self boundingScrollBar viewportRect right.
	deltaAbs := self absoluteDelta: delta.
	
	spaceLeft > 0.001 "avoid rounding errors"
		ifTrue: [
			spaceLeft <= deltaAbs abs "snap"
				ifTrue: [^ super setValue: (self relativeDelta: spaceLeft) * -1 + self value]
				ifFalse: [^ super setValue: aValue]].

	self boundingScrollBar value = 0.0 "at the beginning"
		ifTrue: [^ self].
	
	self boundingScrollBar adjustValue:
		(self boundingScrollBar relativeDelta: deltaAbs).
		
	self boundingScrollBar value = 0.0 "at the beginning"
		ifTrue: [
			spaceLeft := self viewportRect left - self boundingScrollBar viewportRect right.
			^ super setValue: (self relativeDelta: spaceLeft) * -1 + self value].
		
	^ super setValue: aValue! !

!XpfBoundedScrollBar methodsFor: 'accessing' stamp: 'mt 4/22/2010 16:27:12.426'!
side

	^ side! !

!XpfBoundedScrollBar methodsFor: 'accessing' stamp: 'mt 4/22/2010 16:27:26.977'!
side: aSymbol
	"#left or #right"
	
	side := aSymbol! !

!XpfBoundedScrollBar methodsFor: 'model access' stamp: 'mt 4/22/2010 15:53:26.465'!
viewportHeight
	"Height of the scrollable area that is currently visible."
	
	^ self model scroller height! !

!XpfBoundedScrollBar methodsFor: 'model access' stamp: 'mt 4/22/2010 15:50:20.568'!
viewportOffset
	"Part the scrollable area that is hidden on the left side."
	
	^ self model scroller transform offset! !

!XpfBoundedScrollBar methodsFor: 'model access' stamp: 'mt 4/22/2010 15:57:35.127'!
viewportRect
	
	^ self model scroller topLeft + self viewportOffset
		extent:
		self viewportWidth @ self viewportHeight! !

!XpfBoundedScrollBar methodsFor: 'model access' stamp: 'mt 4/22/2010 15:43:41.308'!
viewportWidth
	"Width of the scrollable area that is currently visible."
	
	^ self model scroller width! !

ProgressBarMorph subclass: #XpfProgressBarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:49'!
drawOn: aCanvas
	| width height inner origin progressRectangle |
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle borderStyle: self borderStyle.
	inner := self innerBounds.
	(inner height > inner width) 
		ifTrue: [
			height := (inner height * lastValue) truncated min: inner height.
			origin := inner origin x @ (inner bottom - height).
			progressRectangle := origin extent: (inner width @ height)]
		ifFalse: [
			width := (inner width * lastValue) truncated min: inner width.
			progressRectangle := inner origin extent: width @ inner height].
	
	aCanvas fillRectangle: progressRectangle color: progressColor.! !

SwaLineEdit subclass: #XpfCardEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Cards'!

!XpfCardEdit methodsFor: 'initialization' stamp: 'mt 4/8/2010 16:53:46.037'!
initialize

	super initialize.
	self validator: #integer.! !

Object subclass: #XpfCommand
	instanceVariableNames: 'icon name description target selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Helpers'!

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
description

	^ description! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
description: anObject

	description := anObject.! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
icon

	^ icon! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
icon: anObject

	icon := anObject.! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:10'!
name

	^ name! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
name: anObject

	name := anObject.! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
selector

	^ selector! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
selector: anObject

	selector := anObject.! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
target

	^ target! !

!XpfCommand methodsFor: 'accessing' stamp: 'mt 9/2/2009 14:09'!
target: anObject

	target := anObject.! !

Object subclass: #XpfDeveloperChooserModel
	instanceVariableNames: 'developerList selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Models'!

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:58'!
developer

	^ self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self developerList at: self selectionIndex]! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'cs 4/23/2009 15:06'!
developerList

	^ developerList! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:11'!
developerList: anObject

	developerList := anObject.
	self changed: #list.
	self developerList ifNotEmpty: [self selectionIndex: 1].! !

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:10'!
initialize

	super initialize.
	self selectionIndex: 0.! !

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:57'!
list

	self developerList ifNil: [^ #()].
	^(self developerList collect: [:each | each userName]).! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
selectionIndex

	^ selectionIndex! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
selectionIndex: anObject

	selectionIndex := anObject.
	self changed: #selectionIndex.! !

Object subclass: #XpfDeveloperListModel
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Models'!

!XpfDeveloperListModel methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:48'!
developers

	self project ifNil: [^ #()].
	^ ((self project developers
		sortBy: [:dev1 :dev2 | dev1 userName asLowercase <= dev2 userName asLowercase])
		reject: [:dev | dev = dev repository currentUser])
		collect: [:developer | XpfDeveloperListEntryMorph forUser: developer]! !

!XpfDeveloperListModel methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:49'!
project

	^ project! !

!XpfDeveloperListModel methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:58'!
project: anObject

	project := anObject.
	self changed: #developers.! !

Object subclass: #XpfHistoryEntryModel
	instanceVariableNames: 'entity entry entityType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-History'!

!XpfHistoryEntryModel methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 14:38'!
asMorph

	^ XpfHistoryEntryMorph forEntry: self! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entity

	^ entity! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entity: anObject

	entity := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:20'!
entityType

	^ entityType! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:20'!
entityType: anObject

	entityType := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entry

	^ entry! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entry: anObject

	entry := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'mt 4/28/2009 16:57'!
new

	^ (self entry newVal ifNil: [self entry newRef]) asString withoutLineEndingsTruncatedTo: 20! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'mt 4/28/2009 16:57'!
old

	^ (self entry oldVal ifNil: [self entry oldRef]) asString withoutLineEndingsTruncatedTo: 20! !

Object subclass: #XpfHistoryModel
	instanceVariableNames: 'project showProject showTasks showUserStories individualEntity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-History'!

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:16'!
enableGlobal

	^ self individualEntity isNil! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:13'!
enableIndividual

	^ self individualEntity notNil! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 13:47'!
entries
	
	| result |
	result := OrderedCollection new.
	self showProject ifTrue: [result addAll: self projectEntries].
	self showUserStories ifTrue: [result addAll: self userStoryEntries].
	self showTasks ifTrue: [result addAll: self taskEntries].
	self showIndividual ifTrue: [result addAll: self individualEntries].
	^ result reversed sortBy: [:first :second | first entry timestamp > second entry timestamp]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:31'!
entriesAsMorphs
	
	^ self entries collect: [:entry | entry asMorph]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:10'!
individualEntity

	^ individualEntity! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/28/2009 13:40'!
individualEntity: entity

	self individualEntity ifNotNil: [self individualEntity removeDependent: self].
	individualEntity := entity.
	self individualEntity ifNotNil: [self individualEntity addDependent: self].
	
	self
		changed: #enableGlobal;
		changed: #enableIndividual;
		changed: #showIndividual;
		changed: #showProject;
		changed: #showTasks;
		changed: #showUserStories;
		changed: #entriesAsMorphs;
		changed: #individualTitle.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:52'!
individualEntries
	
	(individualEntity isRestProxy and: [individualEntity history isLoaded not]) ifTrue:
		[individualEntity history reloadDepth: 3].
	^ individualEntity history collect: [:each |
			XpfHistoryEntryModel new
				entity: individualEntity;
				entry: each;
				entityType: #individual]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:19'!
individualTitle

	^ self enableIndividual
		ifTrue: [self individualEntity asString]
		ifFalse: ['']! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:03'!
project

	^ project! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 10:34'!
project: anObject

	self project isRestProxy ifTrue: [self project repository removeDependent: self].
	self project ifNotNil: [self project removeDependent: self].
	project := anObject.
	self project ifNotNil: [self project addDependent: self].
	self project isRestProxy ifTrue: [self project repository addDependent: self].! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:52'!
projectEntries
	
	(project isRestProxy and: [project history isLoaded not]) ifTrue:
		[project history reloadDepth: 3].
	^ project history collect: [:each |
			XpfHistoryEntryModel new
				entity: project;
				entry: each;
				entityType: #project]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:10'!
showIndividual

	^ self individualEntity notNil! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:21'!
showIndividual: anObject

	"if the checkbox is clicked, then the individual view will be deselected"
	self
		individualEntity: nil;
		changed: #enableGlobal;
		changed: #showIndividual;
		changed: #entriesAsMorphs;
		changed: #individualTitle.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 10:38'!
showProject

	showProject ifNil: [showProject := false].
	^ showProject and: [self enableGlobal]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 10:49'!
showProject: anObject

	showProject := anObject.
	self showProject
		ifTrue: [self project history addDependent: self]
		ifFalse: [self project history removeDependent: self].
	self
		changed: #showProject;
		changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/22/2009 14:45'!
showTasks

	showTasks ifNil: [showTasks := false].
	^ showTasks and: [self enableGlobal]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:22'!
showTasks: anObject

	showTasks := anObject.
	self
		changed: #showTasks;
		changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/22/2009 14:45'!
showUserStories

	showUserStories ifNil: [showUserStories := false].
	^ showUserStories and: [self enableGlobal]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 11:17'!
showUserStories: anObject

	showUserStories := anObject.
	self showUserStories
		ifTrue: [project iterations do: [:iteration | iteration history addDependent: self]]
		ifFalse: [project iterations do: [:iteration | iteration history removeDependent: self]].

	self
		changed: #showUserStories;
		changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:51'!
taskEntries
	
	| allTasks allStories |
	allStories := project iterations
		inject: OrderedCollection new
		into: [:all :it | all addAll: it userStories. all]
		displayingProgress: 'Collecting all userstories...'.
	
	allTasks := allStories
		inject: OrderedCollection new
		into: [:all :us | all addAll: us tasks. all]
		displayingProgress: 'Collecting all tasks...'. "This may take a while if not loaded."
		
	^ allTasks
		inject: OrderedCollection new
		into: [:old :eachTask |
			(eachTask isRestProxy and: [eachTask history isLoaded not])
				ifTrue: [eachTask history reloadDepth: 3].
			old addAll: (eachTask history
				collect: [:eachEntry |
					XpfHistoryEntryModel new
					entity: eachTask;
					entry: eachEntry;
					entityType: #task]). old]
		displayingProgress: 'Collecting all userstories...'.! !

!XpfHistoryModel methodsFor: 'updating' stamp: 'cs 4/29/2009 10:49'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #historyLoaded
		ifTrue: [self changed: #entriesAsMorphs].
	aSymbol = #title ifTrue: [self changed: #individualTitle].! !

!XpfHistoryModel methodsFor: 'updating' stamp: 'cs 4/17/2009 16:22'!
update: aSymbol with: argument

	super update: aSymbol with: argument.
	aSymbol = #showHistory
		ifTrue: [self individualEntity: argument].! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:52'!
userStoryEntries
	
	| allStories |
	allStories := project iterations
		inject: OrderedCollection new
		into: [:all :it | all addAll: it userStories. all].
	
	^ allStories
		inject: OrderedCollection new
		into: [:old :eachUserStory |
			(eachUserStory isRestProxy and: [eachUserStory history isLoaded not])
				ifTrue: [eachUserStory history reloadDepth: 3].
			old addAll:
				(eachUserStory history collect: [:eachEntry |
					XpfHistoryEntryModel new
					entity: eachUserStory;
					entry: eachEntry;
					entityType: #userStory]). old]
		displayingProgress: 'Collecting all userstories...'.! !

Object subclass: #XpfIterationListModel
	instanceVariableNames: 'project selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Models'!

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:49'!
initialize

	super initialize.
	self selectionIndex: 0.! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2010 22:06:51.889'!
iteration

	^ self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self iterationList at: self selectionIndex]! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2010 22:06:12.458'!
iterationList

	| result |
	self project ifNil: [^ {}].
	
	result := OrderedCollection with: self project futureIteration.
	
	self project releases do: [:rel | result addAll: rel iterations reversed].
		
	^ result! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2010 22:06:35.855'!
list

	^ self iterationList collect: [:it | it title]! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:36'!
project

	^ project! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:48'!
project: anObject

	project := anObject.
	self project ifNotNil: [self project addDependent: self].
	self changed: #list.	! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:47'!
selectionIndex

	^ selectionIndex! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:47'!
selectionIndex: anObject

	selectionIndex := anObject.
	self changed: #selectionIndex.! !

Object subclass: #XpfNewUserStory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Helpers'!

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:18'!
color

	^ 'white'! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:16'!
positionX

	^ 0! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:16'!
positionY

	^ 0! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:17'!
tasks

	^ #()! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:17'!
timeEstimated

	^ 0.0! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:15'!
title

	^ 'Drop me into iteration'! !

Object subclass: #XpfProgressEstimationSliderModel
	instanceVariableNames: 'timeEstimated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Helpers'!

!XpfProgressEstimationSliderModel methodsFor: 'accessing' stamp: 'bs 6/16/2009 22:31'!
isEnabled
	^true! !

!XpfProgressEstimationSliderModel methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:36'!
timeEstimated

	^ timeEstimated! !

!XpfProgressEstimationSliderModel methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:39'!
timeEstimated: anObject

	timeEstimated := anObject.
	self changed: #timeEstimated.! !

Object subclass: #XpfTracCsvParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk'!

!XpfTracCsvParser class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 23:54:33.084'!
createIterations

	| project time count|
	project := XpfRoot production projects detect: [:p | p title = 'Trac'].
	
	time := TimeStamp fromString: '24 August 2003 10:33:02 pm'.
	count := 0.
	
	[count := count + 1. (time := time + (Duration weeks: 16)) < (TimeStamp now + (Duration weeks: 16))]
		whileTrue: [
			| releaseIndex release iTime |
			releaseIndex := count.
			release := project releases at: releaseIndex.
			iTime := time - (Duration weeks: 16).
			[(iTime := iTime + (Duration weeks: 4)) <= time]
				whileTrue: [release addNewIteration: (Dictionary newFrom: {'title' -> ((iTime - (Duration weeks: 4)) asDate asString, ' to: ', (iTime asDate asString))})]]! !

!XpfTracCsvParser class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 23:54:26.657'!
createReleases

	| project time|
	project := XpfRoot production projects detect: [:p | p title = 'Trac'].
	
	time := TimeStamp fromString: '24 August 2003 10:33:02 pm'.
	
	[(time := time + (Duration weeks: 16)) < (TimeStamp now + (Duration weeks: 16))]
		whileTrue: [project addNewRelease: (Dictionary newFrom: {'title' -> ((time - (Duration weeks: 16)) asDate asString, ' to: ', (time asDate asString))})].! !

!XpfTracCsvParser class methodsFor: 'as yet unclassified' stamp: 'mt 5/20/2010 23:59:14.98'!
currentStoryCount

	| project count |
	project := XpfRoot production projects detect: [:p | p title = 'Trac'].
	count := 0.
	project releases do: [:rel | rel iterations do: [:it | count := count + it userStories size]].
	
	^ count! !

!XpfTracCsvParser class methodsFor: 'as yet unclassified' stamp: 'mt 5/21/2010 09:42:50.358'!
parse

	| strm parser project startTime |
	project := XpfRoot production projects detect: [:p | p title = 'Trac'].
	strm := StandardFileStream readOnlyFileNamed: 'trac.csv'.
	parser := CSVParser on: strm.
	parser nextRow. "Skip heading"

	startTime := TimeStamp fromString: '24 August 2003 10:33:02 pm'.

	parser rowsDo: [:row | 
		| time release iteration span |
		time := TimeStamp fromString: (row at: 12).
		span := Timespan starting: startTime ending: time.
		release := project releases at: (span weeks size / 16 roundUpTo: 1).
		iteration := release iterations at: ((span weeks size \\ 4) max: 1).
		iteration userStories size < 7 atRandom
			ifTrue: [ | story |
				story := iteration addNewUserStory: (Dictionary newFrom: {
					'title' -> (row at: 2) utf8ToSqueak.}).
				(row at: 5) = 'closed' ifTrue: [
					story addNewTask: (Dictionary newFrom: {
						'title' -> 'dummy'. 'isDone' -> true})]].
		].! !

Object subclass: #XpfWidgetFilter
	instanceVariableNames: 'name filterBlock result nextFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Helpers'!

XpfWidgetFilter subclass: #XpfTaskWidgetFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ProjectTalk-Helpers'!

!XpfTaskWidgetFilter methodsFor: 'results' stamp: 'cs 5/13/2009 18:43'!
morphFor: task 

	^ XpfTaskListEntryMorph for: task! !

!XpfWidgetFilter methodsFor: 'results' stamp: 'cs 5/15/2009 13:06'!
createMorphListIn: aMorph

	aMorph addMorphBack: (('-- {1} ({2}) --' format: {self name. self result size}) asText asMorph lock).
	self result do: [:each | | widgetMorph |
		widgetMorph := (self morphFor: each).
		aMorph addMorphBack: widgetMorph.
		widgetMorph addDependent: aMorph].
	self nextFilter ifNotNilDo: [:filter | filter createMorphListIn: aMorph]! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
filterBlock

	^ filterBlock! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
filterBlock: anObject

	filterBlock := anObject.! !

!XpfWidgetFilter methodsFor: 'initialization' stamp: 'cs 5/13/2009 18:08'!
initialize

	super initialize.
	self
		result: OrderedCollection new;
		filterBlock: [:a| true].! !

!XpfWidgetFilter methodsFor: 'results' stamp: 'cs 5/13/2009 18:40'!
morphFor: anObject
	
	self subclassResponsibility.! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:08'!
name

	^ name! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:08'!
name: anObject

	name := anObject.! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:06'!
nextFilter

	^ nextFilter! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:50'!
nextFilter: anObject

	self nextFilter
		ifNil: [nextFilter := anObject]
		ifNotNilDo: [:filter | filter nextFilter: anObject].! !

!XpfWidgetFilter methodsFor: 'processing' stamp: 'cs 5/13/2009 20:07'!
process: anObject

	(self filterBlock value: anObject)
		ifTrue: [self result add: anObject]
		ifFalse: [self nextFilter ifNotNilDo: [:filter | filter process: anObject]].! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
result

	^ result! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
result: anObject

	result := anObject.! !
